/* Create Using File for HRS Subjective Probability Analysis */

clear all
set mem 3g
set more off
set maxvar 30000


/* Settings */

local totalfile = 0
local ltcdo = 0
local lifedo = 0
local disdo = 1

/* Total File */

if `totalfile' == 1 {

use data/rndhrs_j
sort hhid pn
merge hhid pn using data/rawmerge , nokeep
tab _merge
drop _merge
compress
gen female = 0
replace female = 1 if ragender == 2

gen intyear1 = 1992
gen intyear2 = 1993
gen intyear3 = 1995
gen intyear4 = 1998
gen intyear5 = 2000
gen intyear6 = 2002
gen intyear7 = 2004
gen intyear8 = 2006
gen intyear9 = 2008

gen yr_since_int_1 = 0 if hacohort == 0 | hacohort == 1 | hacohort == 3
gen yr_since_int_2 = 2 if hacohort == 3
replace yr_since_int_2 = 1 if hacohort == 0 | hacohort == 1
gen yr_since_int_3 = 4 if hacohort == 3
replace yr_since_int_3 = 3 if hacohort == 0 | hacohort == 1
gen yr_since_int_4 = 6 if hacohort == 0 | hacohort == 1 | hacohort == 3 
replace yr_since_int_4 = 0 if hacohort == 2 | hacohort == 4
gen yr_since_int_5 = 8 if hacohort == 0 | hacohort == 1 | hacohort == 3
replace yr_since_int_5 = 2 if hacohort == 2 | hacohort == 4
gen yr_since_int_6 = 10 if hacohort == 0 | hacohort == 1 | hacohort == 3
replace yr_since_int_6 = 4 if hacohort == 2 | hacohort == 4
gen yr_since_int_7 = 10 if hacohort == 0 | hacohort == 1 | hacohort == 3
replace yr_since_int_7 = 6 if hacohort == 2 | hacohort == 4
replace yr_since_int_7 = 0 if hacohort == 5
gen yr_since_int_8 = 12 if hacohort == 0 | hacohort == 1 | hacohort == 3
replace yr_since_int_8 = 8 if hacohort == 2 | hacohort == 4
replace yr_since_int_8 = 2 if hacohort == 5
gen yr_since_int_9 = 14 if hacohort == 0 | hacohort == 1 | hacohort == 3
replace yr_since_int_9 = 10 if hacohort == 2 | hacohort == 4
replace yr_since_int_9 = 4 if hacohort == 5

rename rabyear birthyear
rename rabmonth birthmonth

gen deathage_t = deathyr + (deathmo-1)/12 - birthyear - (birthmonth-1)/12 if deathyr < 3000 & deathmo < 13
gen deathage = floor(deathage_t)


forvalues j = 1(1)9 {

	local j1 = `j'+1
	local j2 = `j'+2
	local j3 = `j'+3
	local j4 = `j'+4
	local j5 = `j'+5
	local j6 = `j'+6
	local j7 = `j'+7
	local j8 = `j'+8
	local j_1 = `j'-1
	local j_2 = `j'-2
	local j_3 = `j'-3
	local j_4 = `j'-4
	local j_5 = `j'-5
	local j_6 = `j'-6
	local j_7 = `j'-7
	local j_8 = `j'-8
	
	
	
	/* Loss Variables */
		
	
	*Nursing Home Usage
	gen nrshom`j' = r`j'nrshom
	if `j' < 8 {
	gen nrshom5y_old`j' = 0
	replace nrshom5y_old`j' = 1 if r`j1'nrshom == 1 | r`j2'nrshom == 1
	replace nrshom5y_old`j' = 0 if r`j'nrshom == 1
	replace nrshom5y_old`j' = . if r`j'nrshom == .
	replace nrshom5y_old`j' = . if r`j1'iwstat == 5
	* Note that we are coding people who die in the next two years as missing, and coding those who die in 2-4 years as the nursing home usage in the 0-2 year range
	}
	
	if `j' < 7 {
	if `j' > 1 {
	gen nrshom5y`j' = 0
	replace nrshom5y`j' = 1 if r`j1'nrshom == 1 | r`j2'nrshom == 1 
	replace nrshom5y`j' = 1 if r`j1'wliv == 1 | r`j2'wliv == 1
	replace nrshom5y`j' = 0 if r`j'nrshom == 1
	replace nrshom5y`j' = . if r`j1'nrshom == . & r`j2'nrshom == . & r`j1'wliv == . & r`j2'wliv == .
	if `j' >= 4 {
	replace nrshom5y`j' = 1 if r`j3'nrshom == 1 & (r`j3'nhyr + r`j3'nhmo/12 - (r`j'iwendy+r`j'iwendm/12) <= 5)
	replace nrshom5y`j' = 1 if r`j3'wliv == 1 & (r`j3'wliv_yr + r`j3'wliv_mo/12 - (r`j'iwendy+r`j'iwendm/12) <= 5) & r`j3'wliv_yr < 2010 & r`j3'wliv_mo < 13
	}
	}
	}
	
	
	if `j' < 7 {
	gen nrshom5y_f`j' = 0
	replace nrshom5y_f`j' = 1 if r`j1'nrshom == 1 | r`j2'nrshom == 1
	replace nrshom5y_f`j' = 0 if r`j'nrshom == 1
	replace nrshom5y_f`j' = . if r`j'nrshom == .
	replace nrshom5y_f`j' = . if r`j1'iwstat == 5
	if `j' >= 4 {
	replace nrshom5y_f`j' = 1 if r`j3'nrshom == 1 & r`j3'nhyr + r`j3'nhmo/12 - (r`j'iwendy+r`j'iwendm/12) <= 5
	}
	}
	
	
	
	
	* Health limits work
	
	gen hlthlm`j' = r`j'hlthlm
	
	if `j' < 9 {
	gen hlthlm_r1f`j' = 0
	replace hlthlm_r1f`j' = 1 if r`j1'hlthlm == 1
	replace hlthlm_r1f`j' = . if r`j1'iwstat == 7
	}
	if `j' < 8 {
	gen hlthlm_r2f`j' = hlthlm_r1f`j'
	replace hlthlm_r2f`j' = 1 if r`j2'hlthlm == 1
	replace hlthlm_r2f`j' = . if r`j2'iwstat == 7
	}
	if `j' < 7 {
	gen hlthlm_r3f`j' = hlthlm_r2f`j'
	replace hlthlm_r3f`j' = 1 if r`j3'hlthlm == 1
	replace hlthlm_r3f`j' = . if r`j3'iwstat == 7
	}
	if `j' < 6 {
	gen hlthlm_r4f`j' = hlthlm_r3f`j'
	replace hlthlm_r4f`j' = 1 if r`j4'hlthlm == 1 
	replace hlthlm_r4f`j' = . if r`j4'iwstat == 7
	}
	if `j' < 5 {
	gen hlthlm_r5f`j' = hlthlm_r4f`j'
	replace hlthlm_r5f`j' = 1 if r`j5'hlthlm == 1 
	replace hlthlm_r5f`j' = . if r`j5'iwstat == 7
	}
	if `j' > 1 {
	gen hlthlm_l1`j' = 0
	replace hlthlm_l1`j' = 1 if r`j_1'hlthlm == 1
	replace hlthlm_l1`j' = . if r`j_1'iwstat == 7
	}
	* NOTE: I'm assuming the insurance company keeps the premium if people die
	
	local hlthlmvars = " hlthlm_r1f hlthlm_r2f hlthlm_r3f hlthlm_r4f hlthlm_r5f hlthlm hlthlm_l1 "
	
	* Disabled work status
	
	gen lbrf`j' = r`j'lbrf
	gen lfdable`j' = 0 if lbrf`j' ~=.
	replace lfdable`j' = 1 if lbrf`j' == 6	
	
	if `j' < 9 {
	gen lfdable_r1f`j' = 0
	replace lfdable_r1f`j' = 1 if r`j1'lbrf == 6
	replace lfdable_r1f`j' = . if r`j1'iwstat == 7
	}
	if `j' < 8 {
	gen lfdable_r2f`j' = lfdable_r1f`j'
	replace lfdable_r2f`j' = 1 if r`j2'lbrf == 6
	replace lfdable_r2f`j' = . if r`j2'iwstat == 7
	}
	if `j' < 7 {
	gen lfdable_r3f`j' = lfdable_r2f`j'
	replace lfdable_r3f`j' = 1 if r`j3'lbrf == 6
	replace lfdable_r3f`j' = . if r`j3'iwstat == 7
	}
	if `j' < 6 {
	gen lfdable_r4f`j' = lfdable_r3f`j'
	replace lfdable_r4f`j' = 1 if r`j4'lbrf == 6
	replace lfdable_r4f`j' = . if r`j4'iwstat == 7
	}
	if `j' < 5 {
	gen lfdable_r5f`j' = lfdable_r4f`j'
	replace lfdable_r5f`j' = 1 if r`j5'lbrf == 6
	replace lfdable_r5f`j' = . if r`j5'iwstat == 7
	}
	
	local lfdablevars = " lfdable_r1f lfdable_r2f lfdable_r3f lfdable_r4f lfdable_r5f lfdable lbrf "

	
	* Disability Status - Applied *
	
	gen dapp`j' = radappd1 < r`j'iwend
	
	if `j' < 9 {
	gen dapp_r1f`j' = 0
	replace dapp_r1f`j' = 1 if radappd1 < r`j1'iwend
	}
	if `j' < 8 {
	gen dapp_r2f`j' = dapp_r1f`j'
	replace dapp_r2f`j' = 1 if radappd1 < r`j2'iwend
	}
	if `j' < 7 {
	gen dapp_r3f`j' = dapp_r2f`j'
	replace dapp_r3f`j' = 1 if radappd1 < r`j3'iwend
	}
	if `j' < 6 {
	gen dapp_r4f`j' = dapp_r3f`j'
	replace dapp_r4f`j' = 1 if radappd1 < r`j4'iwend
	}
	if `j' < 5 {
	gen dapp_r5f`j' = dapp_r4f`j'
	replace dapp_r5f`j' = 1 if radappd1 < r`j5'iwend
	}
	
	local dappvars = "dapp dapp_r1f dapp_r2f dapp_r3f dapp_r4f dapp_r5f "
	
	* Disability Status - Received *
	
	gen drec`j' = min(radrecd1,radrecd2,radrecd3,radrecd4,radrecd5,radrecd6,radrecd7) < r`j'iwend
	
	if `j' < 9 {
	gen drec_r1f`j' = 0
	replace drec_r1f`j' = 1 if min(radrecd1,radrecd2,radrecd3,radrecd4,radrecd5,radrecd6,radrecd7) < r`j1'iwend
	}
	if `j' < 8 {
	gen drec_r2f`j' = drec_r1f`j'
	replace drec_r2f`j' = 1 if min(radrecd1,radrecd2,radrecd3,radrecd4,radrecd5,radrecd6,radrecd7) < r`j2'iwend
	}
	if `j' < 7 {
	gen drec_r3f`j' = drec_r2f`j'
	replace drec_r3f`j' = 1 if min(radrecd1,radrecd2,radrecd3,radrecd4,radrecd5,radrecd6,radrecd7) < r`j3'iwend
	}
	if `j' < 6 {
	gen drec_r4f`j' = drec_r3f`j'
	replace drec_r4f`j' = 1 if min(radrecd1,radrecd2,radrecd3,radrecd4,radrecd5,radrecd6,radrecd7) < r`j4'iwend
	}
	if `j' < 5 {
	gen drec_r5f`j' = drec_r4f`j'
	replace drec_r5f`j' = 1 if min(radrecd1,radrecd2,radrecd3,radrecd4,radrecd5,radrecd6,radrecd7) < r`j5'iwend
	}
	
	local drecvars = "drec drec_r1f drec_r2f drec_r3f drec_r4f drec_r5f "
	
	* Death
	
	gen age`j' = r`j'agey_e
	gen imputedage`j' = r1agey_e + yr_since_int_`j'
	replace age`j' = imputedage`j' if age`j' == .
	
	gen dead75`j' = 0
	replace dead75`j' = 1 if (r`j'iwstat == 5 | r`j'iwstat == 6) & age`j' <= 75
	
	gen dead_see75`j' = 0
	replace dead_see75`j' = 1 if r`j'agey_e > 75 & r`j'agey_e ~=.
	
	gen dead80`j' = 0
	replace dead80`j' = 1 if (r`j'iwstat == 5 | r`j'iwstat == 6) & age`j' <= 80
	
	gen dead_see80`j' = 0
	replace dead_see80`j' = 1 if r`j'agey_e > 80 & r`j'agey_e ~=.

	gen dead85`j' = 0
	replace dead85`j' = 1 if (r`j'iwstat == 5 | r`j'iwstat == 6) & age`j' <= 85
	
	gen dead_see85`j' = 0
	replace dead_see85`j' = 1 if r`j'agey_e > 85 & r`j'agey_e ~=.
	
	gen dead90`j' = 0
	replace dead90`j' = 1 if (r`j'iwstat == 5 | r`j'iwstat == 6) & age`j' <= 90
	
	gen dead_see90`j' = 0
	replace dead_see90`j' = 1 if r`j'agey_e > 90 & r`j'agey_e ~=.

	gen dead95`j' = 0
	replace dead95`j' = 1 if (r`j'iwstat == 5 | r`j'iwstat == 6) & age`j' <= 95
	
	gen dead_see95`j' = 0
	replace dead_see95`j' = 1 if r`j'agey_e > 95 & r`j'agey_e ~=.

	gen dead100`j' = 0
	replace dead100`j' = 1 if (r`j'iwstat == 5 | r`j'iwstat == 6) & age`j' <= 100
	
	gen dead_see100`j' = 0
	replace dead_see100`j' = 1 if r`j'agey_e > 100 & r`j'agey_e ~=.

	
	gen iwstat`j' = r`j'iwstat 
	
	
	*Hospital Utilization Indicator
	gen hosp`j' = r`j'hosp
	
	*Doctor visit Indicator
	gen doctor`j' = r`j'doctor
	
	*Home Care Usage
	gen homcar`j' = r`j'homcar
	
	
	
	
	/* Insurance Purchase Variables */
	
	* Long term care insurance
	gen ltcins`j' = r`j'hiltc
	
	if `j' > 1 {
	gen ltcinstype`j' = r`j'tyltc
	}
	
	* Life Insurance Ownership
	gen lifein`j' = r`j'lifein
	
	
	
	* Buying LTCins in next 5 years
	if `j' < 8 {
	gen ltcins5ybuy`j' = 0
	replace ltcins5ybuy`j' = 1 if r`j1'hiltc == 1 | r`j2'hiltc == 1
	replace ltcins5ybuy`j' = 0 if r`j'hiltc == 1
	replace ltcins5ybuy`j' = . if r`j'hiltc == .
	}
	if `j' > 1 {
	gen ltcins5ydrop`j' = 0
	replace ltcins5ydrop`j' = 1 if r`j_1'hiltc == 1 & r`j'hiltc == 0
	gen ltcinsbuy`j' = 0
	replace ltcinsbuy`j' = 1 if r`j_1'hiltc == 0 & r`j'hiltc == 1
	gen ltcinsdrop`j' = 0
	replace ltcinsdrop`j' = 1 if r`j_1'hiltc == 1 & r`j'hiltc == 0
	}
	
	* medicaid & medigap
	
	if `j' == 2 | `j' == 3 {
	gen medigap`j' = r`j'medigap
	}
	if `j' >= 2 {
	gen medicaid`j' = r`j'medicaid
	}
	
	/* Subjective Variables */
	
	
	* Probability of Nursing Home in 5 Years
	if `j' > 1 {
	gen pnhm5y`j' = r`j'pnhm5y
	if `j' > 2 {
	gen pnhm5y_1l`j' = r`j_1'pnhm5y
	}
	}
	
	
	* Probability of health limiting work in next 10 years
	if `j' < 7 {
	gen worklm`j' = r`j'worklm
	if `j' > 2 {
	gen worklm_1l`j' = r`j_1'worklm
	}
	}
	
	* Probability of living to 75+
	gen liv75`j' = r`j'liv75
	gen liv75_1l`j' = r`j'liv75
	
	* Probability of living to 85+
	if `j' < 5 {
	gen liv85`j' = r`j'liv85
	}
	
	* Probability of living 10-15 years
	if `j' > 1 {
	if `j' ~=4 {
	gen liv10`j' = r`j'liv10
	gen liv10a`j' = r`j'liv10a
	if `j' > 2 & `j_1' ~=4 {
	gen liv10_1l`j' = r`j_1'liv10
	}
	}
	}
	
	* Risk Aversion Measures
	if `j' > 3 {
	if `j' < 9 {
	gen risk`j' = r`j'risk
	gen risk6`j' = r`j'risk6
	}
	}
	
	local subjvars = "pnhm5y pnhm5y_1l worklm worklm_1l risk risk6 liv10 liv10a liv10_1l liv75_1l"
	
	/* Observables */
	
	* Sample Selection Variables
	
	gen work`j' = r`j'work
	gen iwend`j' = r`j'iwend
	
	local samplevars = "work intdt"
	
	* Demographic Variables
	gen married`j' = 0
	replace married`j' = 1 if r`j'mstat == 1
	gen spouseby`j' = s`j'byear
	gen wealth`j' = h`j'atota
	gen income`j' = h`j'itot
	gen cenreg`j' = r`j'cenreg
	gen child`j' = h`j'child
	gen hhres`j' = h`j'hhres
	
	* Job Characteristics 
	
	gen wgihr`j' = r`j'wgihr
	gen jweeks`j' = r`j'jweeks
	gen jhours`j' = r`j'jhours
	gen slfemp`j' = r`j'slfemp
	gen jphys`j' = r`j'jphys
	gen jlift`j' = r`j'jlift
	gen jstoop`j' = r`j'jstoop
	gen jsight`j' = r`j'jsight
	gen jstres`j' = r`j'jstres
	gen jcten`j' = r`j'jcten
	gen jcocc`j' = r`j'jcocc
	gen jcind`j' = r`j'jcind
	gen jlten`j' = r`j'jlten
	gen jjobs`j' = r`j'jjobs
	gen jyears`j' = r`j'jyears
	
	local jobchar = " wgihr jweeks jhours slfemp jphys jlift jstoop jsight jstres jcten jcocc jcind jlten jjobs jyears "
	
	* Current Health Variables
	gen height`j' = r`j'height
	gen weight`j' = r`j'weight
	gen bmi`j' = r`j'bmi
	gen back`j' = r`j'back			
	if `j' == 4 | `j' == 6 | `j' == 8 {
	replace back`j' = back`j_1'
	}
	gen hrtatt`j' = r`j'hrtatt
	gen hrtanga`j' = r`j'hrtanga
	gen hrtchf`j' = r`j'hrtchf
	gen diabinsul`j' = r`j'diabinsul
	gen wordrec`j' = r`j'wordrec
	
	if `j' > 1 {
	gen hipfe`j' = r`j'hipfe
	gen incont`j' = r`j'incont
	gen hlthoth`j' = r`j'hlthoth
	gen cncrsrg`j' = r`j'cncrsrg
	gen cncrcmo`j' = r`j'cncrcmo
	gen cncrrad`j' = r`j'cncrrad
	if `j' < 7 {
	gen incontpad`j' = r`j'incontpad
	}
	}
	
	
	* Parental Mortality
	gen momliv`j' = r`j'momliv
	gen dadliv`j' = r`j'dadliv
	gen momage`j' = r`j'momage
	gen dadage`j' = r`j'dadage
	
	local parmort = " momliv dadliv momage dadage "
	
	
	if `j' > 3 {
	gen memry`j' = r`j'memry 		/* memory problems */
	replace memry`j' = . if r`j'memry > 1
	}
	
	*ADLs
	if `j' > 1 {
	
	gen walkr`j' = r`j'walkr 		/* Difficulty walking across room */
	replace walkr`j' = 1 if walkr`j' == 2 | walkr`j' == 3 | walkr`j' == 4 | walkr`j' == 9
	gen dress`j' = r`j'dress 		/* Difficulty dressing */
	replace dress`j' = 1 if dress`j' == 2 | dress`j' == 3 | dress`j' == 4 | dress`j' == 9
	gen bath`j' = r`j'bath 		/* Difficulty dressing */
	replace bath`j' = 1 if bath`j' == 2 | bath`j' == 3 | bath`j' == 4 | bath`j' == 9
	gen eat`j' = r`j'eat 		/* Difficulty dressing */
	replace eat`j' = 1 if eat`j' == 2 | eat`j' == 3 | eat`j' == 4 | eat`j' == 9
	gen bed`j' = r`j'bed 		/* Difficulty dressing */
	replace bed`j' = 1 if bed`j' == 2 | bed`j' == 3 | bed`j' == 4 | bed`j' == 9
	gen toilt`j' = r`j'toilt 		/* Difficulty dressing */
	replace toilt`j' = 1 if toilt`j' == 2 | toilt`j' == 3 | toilt`j' == 4 | toilt`j' == 9
	gen anyADL`j' = walkr`j'
	replace anyADL`j' = 1 if dress`j' == 1 | bath`j' == 1 | eat`j' == 1 | bed`j' == 1 | toilt`j' == 1
	
	gen bedh`j' = r`j'bedh 				/* Help getting out of bed */
	replace bedh`j' = 1 if bedh`j' == 2 | bedh`j' == 3 | bedh`j' == 9
	replace bedh`j' = 0 if bed`j' == 0
	gen walkrh`j' = r`j'walkrh			/* Help walking across room (0 = No, 1 = Yes, occasionally, 2 = yes ,sometimes, 3 = yes most of time, 9 = don't do) */
	replace walkrh`j' = 1 if walkrh`j' == 2 | walkrh`j' == 3 | walkrh`j' == 9 
	replace walkrh`j' = 0 if walkr`j' == 0
	gen dressh`j' = r`j'dressh			/* Help Dressing (0 = no, 1 = yes, 2 = can't do) */
	replace dressh`j' = 1 if dressh`j' == 2 | dressh`j' == 3 | dressh`j' == 9 
	replace dressh`j' = 0 if dress`j' == 0
	gen bathh`j' = r`j'bathh			/* Help bathing and showering (0 = no, 1 = yes, 2 = can't do, 9 = don't do) */
	replace bathh`j' = 1 if bathh`j' == 2 | bathh`j' == 3 | bathh`j' == 9 
	replace bathh`j' = 0 if bath`j' == 0
	gen toilth`j' = r`j'toilth			/* Help using toilet (0 = no, 1 = yes, 2 = can't do, 9 = don't do) */
	replace toilth`j' = 1 if toilth`j' == 2 | toilth`j' == 3 | toilth`j' == 9 
	replace toilth`j' = 0 if toilt`j' == 0
	gen eath`j' = r`j'eath				/* Help eating(0 = no, 1 = yes, 2 = can't do, 9 = don't do) */
	replace eath`j' = 1 if eath`j' == 2 | eath`j' == 3 | eath`j' == 9 
	replace eath`j' = 0 if eat`j' == 0

	}
	
	
	*IADLs
	
	if `j' > 1 {
	gen phone`j' = r`j'phone 		/* Difficulty using phone */
	replace phone`j' = 1 if phone`j' == 2 | phone`j' == 3 | phone`j' == 4 | phone`j' == 9
	gen money`j' = r`j'money		/* Difficulty managing money */
	replace money`j' = 1 if money`j' == 2 | money`j' == 3 | money`j' == 4 | money`j' == 9
	gen meds`j' = r`j'meds			/* Difficulty managing Medication */
	replace meds`j' = 1 if meds`j' == 2 | meds`j' == 3 | meds`j' == 4 | meds`j' == 9
	}
	if `j' > 2 {
	gen shop`j' = r`j'shop 			/* Difficulty Shopping */
	replace shop`j' = 1 if shop`j' == 2 | shop`j' == 3 | shop`j' == 9
	gen meals`j' = r`j'meals		/* Difficulty Preparing Meals */
	replace meals`j' = 1 if meals`j' == 2 | meals`j' == 3 | meals`j' == 9
	}
	
	if `j' == 2 {
	gen medhlp`j' = r`j'medhlp
	gen shophlp`j' = r`j'shophlp
	gen mealhlp`j' = r`j'mealhlp
	}
	
	
	* Health History Variables
	gen diabe`j' = r`j'diabe 		/* diabetes */
	gen hibpe`j' = r`j'hibpe 		/* *high blood pressure */
	gen cancre`j' = r`j'cancre 		/* *cancer */
	gen lunge`j' = r`j'lunge 		/* *Lung Disease */
	gen hearte`j' = r`j'hearte		/* Heart Problems */ 
	gen stroke`j' = r`j'stroke		/* Stroke */
	gen psyche`j' = r`j'psyche		/* Psych Problems */
	gen arthre`j' = r`j'arthre		/* Arthritis */
	gen conde`j' = r`j'conde		/* Sum of Conditions */
	
	* Current Health Conditions
	gen diab`j' = r`j'diab  		/* diabetes */
	replace diab`j' = . if r`j'diab > 1
	replace diab`j' = 1 if r`j'diab == .y & `j' == 2
	gen hibp`j' = r`j'hibp	 		/* *high blood pressure */
	replace hibp`j' = . if r`j'hibp > 1
	replace hibp`j' = 1 if r`j'hibp == .y & `j' == 2
	gen cancr`j' = r`j'cancr 		/* *cancer */
	replace cancr`j' = . if r`j'cancr > 1
	replace cancr`j' = 1 if r`j'cancr == .y & `j' == 2 & r1cncrorg ~= 42
	replace cancr`j' = 0 if r2cncrorg == 42 & `j' == 2
	
	if `j' < 3 {
	gen cncrorg`j' = r`j'cncrorg 
	replace cncrorg`j' = 0 if cncrorg`j' == .
	}
	
	gen lung`j' = r`j'lung 		/* *Lung Disease */
	replace lung`j' = . if r`j'lung > 1
	replace lung`j' = 1 if r`j'lung == .y & `j' == 2
	gen heart`j' = r`j'heart		/* Heart Problems */
	replace heart`j' = . if r`j'heart > 1
	gen strok`j' = r`j'strok		/* Stroke */
	replace strok`j' = . if r`j'strok > 1
	replace strok`j' = 1 if r`j'strok == 2
	replace strok`j' = 1 if r`j'strok == .y & `j' ==2 
	gen psych`j' = r`j'psych		/* Psych Problems */
	replace psych`j' = . if r`j'psych > 1
	replace psych`j' = 1 if r`j'psych == .y * `j' == 2
	gen arthr`j' = r`j'arthr		/* Arthritis */
	replace arthr`j' = . if r`j'arthr > 1	
	replace arthr`j' = 1 if r`j'arthr == .y & `j' == 2
	
	* Lifestyle Variables
	gen smokev`j' = r`j'smokev
	gen smoken`j' = r`j'smoken
	
	if `j' > 1 {
	gen arthrADL`j' = arthr`j'*anyADL`j'
	}
	}


	

drop s1* s2* s3* s4* s5* s6* s7* s8* s9* r1* r2* r3* r4* r5* r6* r7* r8* r9* h1* h2* h3* h4* h5* h6* h7* h8* h9* ra* inw* 
drop ahd haoahdhh sassrecv sassagem sassageb bwv lfamr i filever

replace diabinsul2 = diabinsul1 if diabinsul2 == 0


#delimit ;

reshape long married spouseby intyear wealth income cenreg nrshom nrshom5y nrshom5y_f nrshom5y_old
		homcar ltcins ltcinstype height weight back memry bedh walkrh 
		dressh bathh toilth eath phone money meds shop meals diabe hibpe cancre cncrorg
		lunge hearte stroke psyche arthre conde walkr dress bath eat bed toilt 
		ltcins5ybuy ltcinsbuy ltcinsdrop hosp doctor diab hibp cancr lung heart 
		strok psych arthr arthrADL bmi lifein anyADL child hhres
		smoken smokev hrtatt hrtanga hrtchf diabinsul wordrec hipfe incont hlthoth cncrsrg cncrcmo cncrrad incontpad
		medhlp shophlp mealhlp
		age liv75 liv85 iwstat
		medigap medicaid
		`hlthlmvars'
		`lfdablevars'
		`samplevars' 
		`dappvars' `drecvars' 
		`subjvars' `jobchar'
		`parmort'
		, i(hhidpn) j(wav)
		;
#delimit cr


gen yrsseen = 2008-1992 if (hacohort == 3 | hacohort <= 1) & wav == 1
replace yrsseen = 2008-1994 if (hacohort == 3 | hacohort <= 1) & wav == 2
replace yrsseen = 2008-1996 if (hacohort == 3 | hacohort <= 1) & wav == 3
replace yrsseen = 2008-1998 if (hacohort == 3 | hacohort <= 1) & wav == 4
replace yrsseen = 2008-2000 if (hacohort == 3 | hacohort <= 1) & wav == 5
replace yrsseen = 2008-2002 if (hacohort == 3 | hacohort <= 1) & wav == 6
replace yrsseen = 2008-2004 if (hacohort == 3 | hacohort <= 1) & wav == 7
replace yrsseen = 2008-2006 if (hacohort == 3 | hacohort <= 1) & wav == 8
replace yrsseen = 2008-1998 if (hacohort == 2 | hacohort == 4) & wav == 4
replace yrsseen = 2008-2000 if (hacohort == 2 | hacohort == 4) & wav == 5
replace yrsseen = 2008-2002 if (hacohort == 2 | hacohort == 4) & wav == 6
replace yrsseen = 2008-2004 if (hacohort == 2 | hacohort == 4) & wav == 7
replace yrsseen = 2008-2006 if (hacohort == 2 | hacohort == 4) & wav == 8
replace yrsseen = 2008-2004 if hacohort == 5 & wav == 7
replace yrsseen = 2008-2006 if hacohort == 5 & wav == 8
replace yrsseen = 0 if wav == 9



/* Generate Demographic Variables */

gen spouseage = intyear - spouseby

gen agesq = age*age
gen age80 = 0 if age ~=.
replace age80 = 1 if age >= 80 & age ~=.

gen agefemale = age*female
gen agesqfemale = agesq*female
gen spouseagesq = spouseage^2
gen marriedspouseage = 0
replace marriedspouseage = spouseage if married == 1
gen marriedspouseagesq = marriedspouseage^2

egen demogroup = group(age female married)


gen agecat = 0 if age <= 55
replace agecat = 1 if age > 55 & age <= 60
replace agecat = 2 if age > 60 & age <= 65
replace agecat = 3 if age > 65 & age <= 70
replace agecat = 4 if age > 70 & age <= 75
replace agecat = 5 if age > 75 & age <= 80
replace agecat = 6 if age > 80

label define agecat 1 "56-60" 2 "61-65" 3 "66-70" 4 "71-75" 5 "76-80" 6 "80+"
label val agecat agecat

gen agespline55 = 0
replace agespline55 = age if agecat == 0
gen agespline5560 = 0
replace agespline5560 = age if agecat == 1
gen agespline6065 = 0
replace agespline6065 = age if agecat == 2
gen agespline6570 = 0
replace agespline6570 = age if agecat == 3
gen agespline7075 = 0
replace agespline7075 = age if agecat == 4
gen agespline7580 = 0
replace agespline7580 = age if agecat == 5
gen agespline80 = 0
replace agespline80 = age if agecat == 6

gen agespline50_2 = 0
replace agespline50_2 = age^2 if agecat == 0
gen agespline5560_2 = 0
replace agespline5560_2 = age^2 if agecat == 1
gen agespline6065_2 = 0
replace agespline6065_2 = age^2 if agecat == 2
gen agespline6570_2 = 0
replace agespline6570_2 = age^2 if agecat == 3
gen agespline7075_2 = 0
replace agespline7075_2 = age^2 if agecat == 4
gen agespline7580_2 = 0
replace agespline7580_2 = age^2 if agecat == 5
gen agespline80_2 = 0
replace agespline80_2 = age^2 if agecat == 6

gen agespline50_3 = 0
replace agespline50_3 = age^3 if agecat == 0
gen agespline5560_3 = 0
replace agespline5560_3 = age^3 if agecat == 1
gen agespline6065_3 = 0
replace agespline6065_3 = age^3 if agecat == 2
gen agespline6570_3 = 0
replace agespline6570_3 = age^3 if agecat == 3
gen agespline7075_3 = 0
replace agespline7075_3 = age^3 if agecat == 4
gen agespline7580_3 = 0
replace agespline7580_3 = age^3 if agecat == 5
gen agespline80_3 = 0
replace agespline80_3 = age^3 if agecat == 6


* Death Variables
/*
gen dead75 = max(dead751,dead752,dead753,dead754,dead755,dead756,dead757,dead758,dead759)
gen dead80 = max(dead801,dead802,dead803,dead804,dead805,dead806,dead807,dead808,dead809)
gen dead85 = max(dead851,dead852,dead853,dead854,dead855,dead856,dead857,dead858,dead859)
gen dead90 = max(dead901,dead902,dead903,dead904,dead905,dead906,dead907,dead908,dead909)
gen dead95 = max(dead951,dead952,dead953,dead954,dead955,dead956,dead957,dead958,dead959)
gen dead100 = max(dead1001,dead1002,dead1003,dead1004,dead1005,dead1006,dead1007,dead1008,dead1009)
*/
gen dead_see75 = max(dead_see751,dead_see752,dead_see753,dead_see754,dead_see755,dead_see756,dead_see757,dead_see758,dead_see759)
gen dead_see85 = max(dead_see851,dead_see852,dead_see853,dead_see854,dead_see855,dead_see856,dead_see857,dead_see858,dead_see859)

egen baseage = min(age) , by(hhidpn)

* Age of death *
gen dead75 = 0
replace dead75 = 1 if deathage < 75
gen dead80 = 0
replace dead80 = 1 if deathage < 80
gen dead85 = 0
replace dead85 = 1 if deathage < 85
gen dead90 = 0
replace dead90 = 1 if deathage < 90
gen dead95 = 0
replace dead95 = 1 if deathage < 95
gen dead100 = 0
replace dead100 = 1 if deathage < 100



save data/totalfile, replace

}


if `ltcdo' == 1 {

use data/totalfile, clear

****************************
/* Generate LTC Variables */
****************************


*replace agecat = 3 if age == 65

*Past Nursing Home Usage Indicator

sort hhidpn wav
by hhidpn: gen nurshompast = sum(nrshom) 
replace nurshompast = 1 if nurshompast > 1 & nurshompast <.

sort hhidpn wav
by hhidpn: gen homcarpast = sum(homcar) 
replace homcarpast = 1 if homcarpast > 1 & homcarpast <.


* Rejection Variables

gen reject_murtaugh = 0
replace reject_murtaugh = 1 if nurshompast == 1
replace reject_murtaugh = 1 if walkrh == 1 | dressh == 1 | bathh == 1 | toilth == 1 | eath == 1
replace reject_murtaugh = 1 if stroke == 1
replace reject_murtaugh = 1 if homcarpast == 1

*Note: Add more conditions when link up to HRS

gen probreject_murtaugh = reject_murtaugh
replace probreject_murtaugh = 1 if stroke == 1
replace probreject_murtaugh = 1 if heart == 1
gen obese = 0
replace obese = 1 if bmi > 40
replace obese = . if bmi == .
replace probreject_murtaugh = 1 if bmi > 40
replace probreject_murtaugh = 1 if diab == 1


gen wordmem = 0
forval j = 1(1)9 {
xtile wordmem`j' = wordrec if wav == `j', n(4)
replace wordmem = wordmem`j' if wav == `j'
}

gen reject = reject_murtaugh
replace reject = 2 if memry == 1
*replace reject = 2 if wordmem == 1 & (wav ==2 | wav == 3)
replace reject = 1 if meds == 1
replace reject = 1 if bedh == 1

replace reject = 2 if (heart == 1 | hipfe == 1 | lung == 1 | hlthoth == 1 | cancr == 1 ) & reject == 0

*replace reject = 1 if age > 80

gen maybereject = probreject_murtaugh
replace maybereject = 1 if reject == 1
replace maybereject = 1 if arthrADL == 1
replace maybereject = 1 if homcarpast == 1

gen reject_ltc = reject
replace reject_ltc = 1 if age > 80

egen rejectcat = group(reject maybereject)

* Observables

replace meds = medhlp if wav == 2 & (hacohort == 0 | hacohort == 1)
replace shop = shophlp if wav == 2
replace meals = mealhlp if wav == 2


gen adlcount = dressh + bathh + eath + bedh + toilth 
gen iadlcount = meds + shop + meals

gen robinson_cat = 1 if adlcount == 0 & iadlcount == 0 & memry == 0
replace robinson_cat = 2 if adlcount == 0 & iadlcount == 1 & memry == 0
replace robinson_cat = 3 if adlcount == 1 & memry == 0
replace robinson_cat = 4 if adlcount == 2 & memry == 0
replace robinson_cat = 5 if adlcount >=3 & adlcount < . & memry == 0
replace robinson_cat = 6 if adlcount < 2 & memry == 1
replace robinson_cat = 7 if adlcount >= 2 & memry == 1

egen agereg = group(agecat cenreg)
quietly tab agereg, gen(agereg_)

* Family Structure

egen reject_ltc_agecat = group(reject agecat)

xtile kidgroup = child, n(4)
gen famliv = hhres
replace famliv = 3 if hhres > 2 & hhres ~=.
replace famliv = 2 if hhres == 2 & hhres ~=.

egen famcat = group(famliv reject agecat)
egen kidcat = group(kidgroup reject agecat)
replace famcat = 0 if reject_ltc == 0
replace kidcat = 0 if reject_ltc == 0

quietly tab famcat , gen(famcat_)
quietly tab kidcat, gen(kidcat_)

egen memrycat = group(reject_ltc_agecat memry) 

gen numconditions1 = hibp + diab + heart + lung + arthr + stroke + obese + psych
replace numconditions1 = 0 if maybereject == 0
gen numconditions2 = hibp + diab + heart + lung + arthr + stroke + obese + psych
replace numconditions2 = 0 if reject == 0
gen numadlrej = adlcount 
replace numadlrej = 0 if reject == 0

egen rejectagecat = group(rejectcat agecat)
quietly tab rejectagecat , gen(rejectcatagecat_)
egen numconditionsagecat1 = group(numconditions1 agecat reject)
quietly tab numconditionsagecat1 , gen(numconditionsagecat1_)
egen numconditionsagecat2 = group(numconditions2 agecat reject)
quietly tab numconditionsagecat2 , gen(numconditionsagecat2_)
egen numadlagerej = group(numadlrej agecat reject)
quietly tab numadlagerej, gen(numadlagerej_)

gen nursorhomcarpast = max(nurshompast,homcarpast)

*egen group1 = group(robinson_cat female agecat rejectcat)
gen adlgp12 = adlcount
replace adlcount = 3 if adlcount > 3 & adlcount ~=.
gen iadlgp1 = iadlcount
replace iadlgp1 = 1 if iadlcount > 1 & iadlcount ~=.
egen group1 = group(iadlgp1 adlgp12 wordmem female agecat reject)

quietly tab group1 , gen(group1_)

egen homcarage = group(agecat homcarpast reject )
quietly tab homcarage , gen(homcarage_)

xtile incomecatfine = income, n(10)
egen agecatincome = group(agecat incomecatfine reject)
quietly tab agecatincome , gen(ageinc_)

xtile incomecatcoarse = income , n(3)
egen agegender = group(age female reject)
quietly tab agegender , gen(agegender_)

gen i_adl_num = iadlcount + adlcount
replace i_adl_num = 1 if i_adl_num > 1 & i_adl_num < .
gen lowword = wordmem 
replace lowword = 0 if wordmem > 1 & wordmem < 5

gen agetop = age
replace agetop = 95 if agetop > 95
replace agetop = 91 if agetop <= 95 & agetop > 90

egen pricegroup = group(agetop female reject i_adl_num lowword) if age >= 65
quietly tab pricegroup , gen(pricegroup_)

* Subjective Probabilities *

gen selfprob5y = pnhm5y / 100
gen selfprob5y_2 = selfprob5y^2
gen selfprob5y_3 = selfprob5y^3
gen sp1l = pnhm5y_1l / 100
gen sp1l2 = sp1l^2
gen sp1lp = selfprob5y - sp1l
replace sp1lp = 0 if sp1lp  < 0
gen sp1ln = selfprob5y - sp1l
replace sp1ln = 0 if sp1ln >= 0 & sp1ln ~=.


/*
foreach a in 2 3 4 5 6 {
foreach r in 0 1 {
foreach j in 1 2 3 4 5 {
local k = 10*`a' + 5*`r' + `j'-1

if `j' == 1 {
gen n`k' = 0 if selfprob5y ~=.
replace n`k' = selfprob5y^`j' if agecat == `a' & (reject_ltc == `r' | reject_ltc == `r'*(`r'+1))
}
if `j' == 2 {
gen n`k' = 0 if selfprob5y ~=.
replace n`k' = 2*selfprob5y^`j'-1 if agecat == `a' & (reject_ltc == `r' | reject_ltc == `r'*(`r'+1))
}
if `j' == 3 {
gen n`k' = 0 if selfprob5y ~=.
replace n`k' = 4*selfprob5y^`j'-3*selfprob5y if agecat == `a' & (reject_ltc == `r' | reject_ltc == `r'*(`r'+1))
}
if `j' == 4 {
gen n`k' = 1-selfprob5y
replace n`k' = 0 if selfprob5y > 0 & selfprob5y ~=.
}
if `j' == 5 {
gen n`k' = selfprob5y
replace n`k' = 0 if selfprob5y < 1
}
}
}
}


foreach a in 2 3 4 5 6 {
foreach r in 0 1 {
foreach j in 1 2 3 4 5 {
local k = 10*`a' + 5*`r' + `j'-1

if `j' == 1 {
gen m`k' = 0 if selfprob5y ~=.
replace m`k' = age*selfprob5y^`j' if agecat == `a' & (reject_ltc == `r' | reject_ltc == `r'*(`r'+1))
}
if `j' == 2 {
gen m`k' = 0 if selfprob5y ~=.
replace m`k' = age*(2*selfprob5y^`j'-1) if agecat == `a' & (reject_ltc == `r' | reject_ltc == `r'*(`r'+1))
}
if `j' == 3 {
gen m`k' = 0 if selfprob5y ~=.
replace m`k' = age*(4*selfprob5y^`j'-3*selfprob5y) if agecat == `a' & (reject_ltc == `r' | reject_ltc == `r'*(`r'+1))
}
if `j' == 4 {
gen m`k' = (1-selfprob5y)*age
replace m`k' = 0 if selfprob5y > 0 & selfprob5y ~=.
}
if `j' == 5 {
gen m`k' = selfprob5y*age
replace m`k' = 0 if selfprob5y < 1
}
}
}
}

*/



gen agen_00 = 1 if age <= 80
gen agen_10 = 1 if age > 80
gen agen_01 = (age - 72.5)/7.5 if age <= 80
gen agen_11 = (age - 100)/7.5 if age > 80

gen agen_02 = 2*agen_01^2-1
gen agen_12 = 2*agen_11^2 -1
gen agen_03 = 4*agen_01^3-3*agen_01
gen agen_13 = 4*agen_11^3-3*agen_11

gen over80 = (age > 80)

gen p_use = 2*(selfprob5y - .5)

/*
local k = 0
foreach r in 0 1 2 {
foreach o in 0 1 {
foreach q in 1 2 3 {
foreach j in 1 2 3 4 5 {

local k = `k' + 1

if `j' == 1 {
gen pns`k' = 0 if selfprob5y ~=.
replace pns`k' = agen_`o'`q' * p_use^`j' if over80 == `o' & reject == `r'
}
if `j' == 2 {
gen pns`k' = 0 if selfprob5y ~=.
replace pns`k' = agen_`o'`q' *(2*p_use^`j'-1)  if over80 == `o' & reject == `r'
}
if `j' == 3 {
gen pns`k' = 0 if selfprob5y ~=.
replace pns`k' = agen_`o'`q' *(4*p_use^`j'-3*p_use)  if over80 == `o' & reject == `r'
}
if `j' == 4 {
gen pns`k' = 0 if selfprob5y ~=.
replace pns`k' = agen_`o'`q' if selfprob5y == 0 & over80 == `o' & reject == `r' 
}
if `j' == 5 {
gen pns`k' = 0 if selfprob5y ~=.
replace pns`k' = agen_`o'`q' if selfprob5y == 1 & over80 == `o' & reject == `r' 
}
}
}
}
}
*/
gen agep = (age - 80)/15
gen agep_0 = 1
gen agep_1 = agep
gen agep_2 = 2*agep^2 - 1
gen agep_3 = 4*agep^3 - 3*agep
gen agep_4 = 8*agep^4 - 8*agep^2 + 1
gen agep_5 = 16*agep^5 - 20*agep^3 + 5*agep
gen agep_1f = agep_1*female
gen agep_2f = agep_2*female
gen agep_3f = agep_3*female



local k = 0
foreach r in 0 1 2 {
foreach q in 0 1 {
foreach j in 1 2 4 5 {

local k = `k' + 1

if `j' == 1 {
gen pnc`k' = 0 if selfprob5y ~=.
replace pnc`k' = agep_`q' * p_use^`j' if reject == `r'
}
if `j' == 2 {
gen pnc`k' = 0 if selfprob5y ~=.
replace pnc`k' = agep_`q' *(2*p_use^`j'-1)  if reject == `r'
}
if `j' == 3 {
gen pnc`k' = 0 if selfprob5y ~=.
replace pnc`k' = agep_`q' *(4*p_use^`j'-3*p_use)  if reject == `r'
}
if `j' == 4 {
gen pnc`k' = 0 if selfprob5y ~=.
replace pnc`k' = agep_`q' if selfprob5y == 0 & reject == `r' 
}
if `j' == 5 {
gen pnc`k' = 0 if selfprob5y ~=.
replace pnc`k' = agep_`q' if selfprob5y == 1 & reject == `r' 
}
}
}
}




/*
gen r0a2 = 0
replace  r0a2 = selfprob5y if reject == 0 & agecat == 2
gen r0a3 = 0
replace  r0a3 = selfprob5y if reject == 0 & agecat == 3
gen  r0a4 = 0
replace  r0a4 = selfprob5y if reject == 0 & agecat == 4
gen  r0a5 = 0
replace  r0a5 = selfprob5y if reject == 0 & agecat == 5
gen  r0a6 = 0
replace  r0a6 = selfprob5y if reject == 0 & agecat == 6
gen  r1a2 = 0
replace r1a2 = selfprob5y if reject == 1 & agecat == 2
gen  r1a3 = 0
replace r1a3 = selfprob5y if reject == 1 & agecat == 3
gen r1a4 = 0
replace r1a4 = selfprob5y if reject == 1 & agecat == 4
gen r1a5 = 0
replace r1a5 = selfprob5y if reject == 1 & agecat == 5
gen r1a6 = 0
replace r1a6 = selfprob5y if reject == 1 & agecat == 6

gen r0a22 = 0
replace r0a22 = selfprob5y^2 if reject == 0 & agecat == 2
gen r0a32 = 0
replace r0a32 = selfprob5y^2 if reject == 0 & agecat == 3
gen r0a42 = 0
replace r0a42 = selfprob5y^2 if reject == 0 & agecat == 4
gen r0a52 = 0
replace r0a52 = selfprob5y^2 if reject == 0 & agecat == 5
gen r0a62 = 0
replace r0a62 = selfprob5y^2 if reject == 0 & agecat == 6
gen r1a22 = 0
replace r1a22 = selfprob5y^2 if reject == 1 & agecat == 2
gen r1a32 = 0
replace r1a32 = selfprob5y^2 if reject == 1 & agecat == 3
gen r1a42 = 0
replace r1a42 = selfprob5y^2 if reject == 1 & agecat == 4
gen r1a52 = 0
replace r1a52 = selfprob5y^2 if reject == 1 & agecat == 5
gen r1a62 = 0
replace r1a62 = selfprob5y^2 if reject == 1 & agecat == 6

gen r0a23 = 0
replace r0a23 = selfprob5y^3 if reject == 0 & agecat == 2
gen r0a33 = 0
replace r0a33 = selfprob5y^3 if reject == 0 & agecat == 3
gen r0a43 = 0
replace r0a43 = selfprob5y^3 if reject == 0 & agecat == 4
gen r0a53 = 0
replace r0a53 = selfprob5y^3 if reject == 0 & agecat == 5
gen r0a63 = 0
replace r0a63 = selfprob5y^3 if reject == 0 & agecat == 6
gen r1a23 = 0
replace r1a23 = selfprob5y^3 if reject == 1 & agecat == 2
gen r1a33 = 0
replace r1a33 = selfprob5y^3 if reject == 1 & agecat == 3
gen r1a43 = 0
replace r1a43 = selfprob5y^3 if reject == 1 & agecat == 4
gen r1a53 = 0
replace r1a53 = selfprob5y^3 if reject == 1 & agecat == 5
gen r1a63 = 0
replace r1a63 = selfprob5y^3 if reject == 1 & agecat == 6
*/
gen sp = selfprob5y
gen sp2 = selfprob5y^2
gen sp3 = selfprob5y^3


* Fine group *

gen age5 = agecat
replace age5 = 7 if age >= 85 & age ~= .
replace age5 = 8 if age >= 90 & age ~= .
replace age5 = 3 if age5 == 2


egen finegroup_full_t = group(cenreg reject_ltc age5 female) if cenreg ~=5 
replace finegroup_full_t = 1 if finegroup_full_t == 2
replace finegroup_full_t = 9 if finegroup_full_t == 10
replace finegroup_full_t = 21 if finegroup_full_t == 22
replace finegroup_full_t = 31 if finegroup_full_t == 32
replace finegroup_full_t = 43 if finegroup_full_t == 44
replace finegroup_full_t = 65 if finegroup_full_t == 66
replace finegroup_full_t = 75 if finegroup_full_t == 76
replace finegroup_full_t = 87 if finegroup_full_t == 88
egen finegroup_full = group(finegroup_full_t)


egen finegroup = group(reject_ltc age5)


gen finegroup_age = age - 64
replace finegroup_age = 1 if age < 65
replace finegroup_age = 26 if age > 90
gen finegroup_age_r = finegroup_age if reject == 0
replace finegroup_age_r = finegroup_age + 26 if reject == 1


compress

save data/hrs_using_ltc, replace


}
*****************************
/* Generate Life Variables */
*****************************

if `lifedo' == 1 {

use data/totalfile, clear

* Selection *
keep if wav < 5

* Rejection Categories


gen reject_life = 0
replace reject_life = 1 if stroke == 1 | cancr == 1 
replace reject_life = . if heart == . | stroke == . | cancr == . | lung == .
replace reject_life = 1 if age >= 90
replace reject_life = 2 if (hlthoth == 1 | cancre == 1 | heart == 1) & reject_life == 0
replace reject_life = 2 if (diab == 1 | hibp == 1 | lung == 1) & reject_life == 0
*replace reject_life = 1 if heart == 1 | stroke == 1 | cancr == 1 | lung == 1 | diab == 1 | psych == 1 | hibp == 1
gen healthy_life = 0
replace healthy_life = 1 if hearte == 0 & stroke == 0 & cancr == 0 & lung == 0 & diab == 0 & psych == 0 & hibp == 0 & arthr == 0 & back == 0

egen reject_life_agecat = group(reject_life agecat)

* Observables

egen conditiongroup = group(heart strok cancr lung psych hibp diab agecat female reject_life)
*egen heartgroup = group(heart hrtanga hrtchf hrtatt reject_life_agecat)
egen heartgroup = group(heart reject_life_agecat)
egen strokgroup = group(strok reject_life_agecat)
*egen cancrgroup = group(cancr cncrrad cncrcmo cncrsrg reject_life_agecat)
egen cancrgroup = group(cancr reject_life_agecat)
egen lunggroup = group(lung reject_life_agecat)
egen hibpgroup = group(hibp reject_life_agecat)
*egen diabgroup = group(diab diabinsul reject_life_agecat)
egen diabgroup = group(diab reject_life_agecat)
egen arthrgroup = group(arthr reject_life_agecat)

egen heart_r = group(heart reject_life)
egen strok_r = group(strok reject_life)
egen cancr_r = group(cancr reject_life)
egen lung_r = group(lung reject_life)
egen diab_r = group(diab reject_life)

xtile bmigrp = bmi, n(4)
gen obese = 0
replace obese = 1 if bmi > 40
replace obese = . if bmi == .

egen agegender = group(age female)
egen agegenderrej = group(age female reject_life)
egen agegenrejother = group(agecat female reject_life bmigrp cenreg)

egen agegensmoke = group(age female smoken reject_life bmigrp)

egen agegenbmi = group(age female bmigrp reject_life)
egen agecatsmoke = group(agecat smoken reject_life)

egen agereg = group(agecat cenreg reject_life)

xtile wealthcat = wealth, n(2)
xtile incomecat = income, n(4)
xtile incomecatfine = income, n(10)
egen moneygroup = group(wealthcat incomecat reject_life)
quietly tab incomecat , gen(incomecat_)

xtile daddie = dadage if dadliv == 1 , n(4)
xtile momdie = momage if momliv == 1 , n(4)
* egen parentmort = group(daddie momdie dadliv momliv agecat reject_life)
gen dadb460 = 0
replace dadb460 = 1 if dadliv == 0 & dadage < 60
gen momb460 = 0
replace momb460 = 1 if momliv == 0 & momage < 60
gen parentb460 = 0
replace parentb460 = 1 if dadb460 == 1 | momb460 == 1 

egen agecatincome = group(agecat incomecatfine reject_life)

gen deathgroup = 75 if liv75 ~=.
replace deathgroup = liv10a if age > 65

egen agecohort = group(agecat yrsseen) 
egen agedeathgrp = group(agecat deathgroup reject_life) 

gen yearsquestion = deathgroup - age

quietly tab yearsquestion , gen(yearsquestion_)


quietly tab heartgroup, gen(heartgroup_)
quietly tab strokgroup, gen(strokgroup_)
quietly tab cancrgroup, gen(cancrgroup_)
quietly tab lunggroup, gen(lunggroup_)
quietly tab hibpgroup, gen(hibpgroup_)
quietly tab diabgroup, gen(diabgroup_)
quietly tab agereg, gen(agereg_)
quietly tab agedeathgrp , gen(agedg_)
quietly tab agecatsmoke , gen(agecatsmoke_)
quietly tab agegenbmi , gen(agegenbmi_)
quietly tab agegender, gen(agegender_)

quietly tab heart_r , gen(heart_r_)
quietly tab strok_r , gen(strok_r_)
quietly tab cancr_r , gen(cancr_r_)
quietly tab lung_r , gen(lung_r_)
quietly tab diab_r , gen(diab_r_)
quietly tab cncrorg , gen(cncrorg_)

/*
*quietly tab conditiongroup, gen(conditiongroup_)
*quietly tab parentmort, gen(parentmort_)
quietly tab moneygroup, gen(moneygroup_)
quietly tab agecohort , gen(agecohort_)
*quietly tab agegender, gen(agegender_)
*quietly tab heartgroup, gen(heartgroup_)
*quietly tab strokgroup, gen(strokgroup_)
*quietly tab cancrgroup, gen(cancrgroup_)
*quietly tab lunggroup, gen(lunggroup_)
*quietly tab hibpgroup, gen(hibpgroup_)
quietly tab diabgroup, gen(diabgroup_)
quietly tab arthrgroup, gen(arthrgroup_)
quietly tab agegenderrej, gen(agegenderrej_)
quietly tab agegenrejother, gen(agegenrejother_)
*/

quietly tab agegensmoke , gen(agegensmoke_)
quietly tab agecatincome , gen(ageinc_)


* Subjective Probabilities *

gen dead = dead75 if liv75 ~=.
replace dead = dead80 if deathgroup == 80
replace dead = dead85 if deathgroup == 85
replace dead = dead90 if deathgroup == 90
replace dead = dead95 if deathgroup == 95
replace dead = dead100 if deathgroup == 100

gen liv = liv75
gen liv_1l = liv75_1l
replace liv = liv10 if deathgroup ~= 75 & deathgroup ~=.
replace liv_1l = liv10_1l if deathgroup ~= 75 & deathgroup ~=.

replace liv = liv/100
replace liv_1l = liv_1l / 100

gen liv_2 = liv^2
gen liv_3 = liv^3

/*
foreach a in 0 1 2 3 4 5 6 {
foreach r in 0 1 {
foreach j in 1 2 3 4 5 {
local k = 10*`a' + 5*`r' + `j'-1
if `j' < 4 {
gen l`k' = 0 if liv ~=.
replace l`k' = liv^`j' if agecat == `a' & (reject_life == `r' | reject_life == `r'*(`r'+1))
}
if `j' == 4 {
gen l`k' = 1-liv
replace l`k' = 0 if liv > 0 & liv ~=.
}
if `j' == 5 {
gen l`k' = liv
replace l`k' = 0 if liv < 1
}
}
}
}
*/

gen agep = (age - 70)/10
gen agep_0 = 1
gen agep_1 = agep
gen agep_2 = 2*agep^2 - 1
gen agep_3 = 4*agep^3 - 3*agep
gen agep_4 = 8*agep^4 - 8*agep^2 + 1
gen agep_5 = 16*agep^5 - 20*agep^3 + 5*agep
gen agep_1f = agep_1*female
gen agep_2f = agep_2*female
gen agep_3f = agep_3*female


gen p_use = 2*(liv - .5)

local k = 0
foreach r in 0 1 2 {
foreach q in 0 1 {
foreach j in 1 2 4 5 {

local k = `k' + 1

if `j' == 1 {
gen plc`k' = 0 if liv ~=.
replace plc`k' = agep_`q' * p_use^`j' if reject_life == `r'
}
if `j' == 2 {
gen plc`k' = 0 if liv ~=.
replace plc`k' = agep_`q' *(2*p_use^`j'-1)  if reject_life == `r'
}
if `j' == 3 {
gen plc`k' = 0 if liv ~=.
replace plc`k' = agep_`q' *(4*p_use^`j'-3*p_use)  if reject_life == `r'
}
if `j' == 4 {
gen plc`k' = 0 if liv ~=.
replace plc`k' = agep_`q' if liv == 0 & reject_life == `r' 
}
if `j' == 5 {
gen plc`k' = 0 if liv ~=.
replace plc`k' = agep_`q' if liv == 1 & reject_life == `r' 
}
}
}
}


/*

gen age0liv75 = 0
replace age0liv75 = liv75 if agecat == 0
gen age1liv75 = 0
replace age1liv75 = liv75 if agecat == 1 
gen age2liv75 = 0
replace age2liv75 = liv75 if agecat == 2
gen age3liv75 = 0
replace age3liv75 = liv75 if agecat == 3 
gen age4liv75 = 0
replace age4liv75 = liv75 if agecat == 4 
gen age5liv75 = 0
replace age5liv75 = liv75 if agecat == 5
gen age6liv75 = 0
replace age6liv75 = liv75 if agecat == 6
gen age0liv75_2 = 0
replace age0liv75_2 = liv75_2 if agecat == 0
gen age1liv75_2 = 0
replace age1liv75_2 = liv75_2 if agecat == 1 
gen age2liv75_2 = 0
replace age2liv75_2 = liv75_2 if agecat == 2
gen age3liv75_2 = 0
replace age3liv75_2 = liv75_2 if agecat == 3 
gen age4liv75_2 = 0
replace age4liv75_2 = liv75_2 if agecat == 4 
gen age5liv75_2 = 0
replace age5liv75_2 = liv75_2 if agecat == 5
gen age6liv75_2 = 0
replace age6liv75_2 = liv75_2 if agecat == 6
gen age0liv75_3 = 0
replace age0liv75_3 = liv75_3 if agecat == 0
gen age1liv75_3 = 0
replace age1liv75_3 = liv75_3 if agecat == 1 
gen age2liv75_3 = 0
replace age2liv75_3 = liv75_3 if agecat == 2
gen age3liv75_3 = 0
replace age3liv75_3 = liv75_3 if agecat == 3 
gen age4liv75_3 = 0
replace age4liv75_3 = liv75_3 if agecat == 4 
gen age5liv75_3 = 0
replace age5liv75_3 = liv75_3 if agecat == 5
gen age6liv75_3 = 0
replace age6liv75_3 = liv75_3 if agecat == 6

*/


* Fine group *

gen age5 = agecat
replace age5 = 7 if age >= 85 & age ~= .
*replace age5 = 8 if age >= 90 & age ~= .


egen finegroup_full_t = group(cenreg reject_life age5 female) if cenreg ~=5 
/* 
replace finegroup_full_t = 1 if finegroup_full_t == 2
replace finegroup_full_t = 9 if finegroup_full_t == 10
replace finegroup_full_t = 21 if finegroup_full_t == 22
replace finegroup_full_t = 31 if finegroup_full_t == 32
replace finegroup_full_t = 43 if finegroup_full_t == 44
replace finegroup_full_t = 65 if finegroup_full_t == 66
replace finegroup_full_t = 75 if finegroup_full_t == 76
replace finegroup_full_t = 87 if finegroup_full_t == 88
*/

replace age5 = 2 if age5 == 3
replace age5 = 6 if age5 == 7
replace age5 = 2 if age5 == 1


egen finegroup_full = group(finegroup_full_t)
egen finegroup = group(reject_life age5) 



/*
replace finegroup = 4 if finegroup == 3
replace finegroup = 11 if finegroup == 10
replace finegroup = 6 if finegroup == 7
replace finegroup = 13 if finegroup == 14
rename finegroup finegroup_t
egen finegroup = group(finegroup_t)
drop finegroup_t
*/

compress

save data/hrs_using_life, replace

}
	 
***********************************
/* Generate Disability Variables */
***********************************

if `disdo' == 1 {

use data/totalfile , clear



/* Rejection */
gen obese = 0
replace obese = 1 if bmi > 40
replace obese = . if bmi == .

gen reject_dis = max(back,obese,psyche)
gen bluejob = 0
replace bluejob = 1 if jcocc == 5 | jcocc == 6 | jcocc == 7 | jcocc == 10 | jcocc == 11 | jcocc == 12 | jcocc == 14 | jcocc == 15 | jcocc == 16
gen unsurejob = bluejob
replace bluejob = 0 if slfemp == 1

replace reject_dis = 2 if reject_dis == 0 & (hlthoth == 1 | cancre == 1 | diab == 1 | arthr == 1 | bluejob == 1 | hlthlm_l1 == 1 | heart == 1)
gen reject_dis_ni = reject_dis
replace reject_dis = 2 if reject_dis == 0 & income < 75000 & income ~=.
*gen reject_dis = back

replace reject_dis_ni = 2 if reject_dis_ni == 0 & (hibpe == 1 | anyADL == 1 | hearte == 1 )
replace reject_dis_ni = 2 if reject_dis_ni == 0 & (income < 30000 | wgihr <= 15)


/* Demographics */

* Job Characteristics

xtile wagecat = wgihr , n(10)
xtile hourscat = jweeks , n(2)
xtile tencat = jcten , n(4)
egen jobchar = group(wagecat hourscat tencat slfemp reject_dis)
quietly tab wagecat , gen(wagecat_)

gen jphys1 = jphys < 3 if jphys ~=.
gen jlift1 = jlift < 3 if jlift ~=.
gen jstoop1 = jstoop < 3 if jstoop ~=.


egen jobdiff = group(jphys1 jlift1 jstoop1 reject_dis)


* Health Variables
xtile bmigrp = bmi, n(4)

egen agegender = group(age female reject_dis)

egen agereg = group(agecat cenreg)

* Tab Vars

quietly tab agegender, gen(agegender_)



* groups

egen healthgroup1 = group(back psyche arthr agecat bmigrp heart)
egen backgroup = group(back agecat reject_dis)
egen psychegroup = group(psyche agecat reject_dis)
egen arthrgroup = group(arthr agecat reject_dis)
egen bmigroup = group(bmigrp agecat reject_dis)
egen heartgroup = group(heart agecat reject_dis)
egen cancrgroup = group(cancr agecat reject_dis)
egen diabgroup = group(diab agecat reject_dis)
egen lunggroup = group(lung agecat reject_dis)

quietly tab jobdiff, gen(jobdiff_)
quietly tab jobchar, gen(jobchar_)
quietly tab healthgroup1, gen(healthgroup1_)
quietly tab backgroup, gen(backgroup_)
quietly tab psychegroup, gen(psychegroup_)
quietly tab arthrgroup, gen(arthrgroup_)
quietly tab bmigroup, gen(bmigroup_)
quietly tab heartgroup, gen(heartgroup_)
quietly tab agereg, gen(agereg_)
quietly tab cancrgroup, gen(cancrgroup_)
quietly tab diabgroup, gen(diabgroup_)
quietly tab lunggroup, gen(lunggroup_)



egen back_r = group(back reject_dis)
egen psych_r = group(psyche reject_dis)
egen cancr_r = group(cancr reject_dis)
egen diab_r = group(diab reject_dis)
egen lung_r = group(lung reject_dis)
egen arthr_r = group(arthr reject_dis)
egen heart_r = group(heart reject_dis)

quietly tab back_r , gen(back_r_)
quietly tab psych_r , gen(psych_r_)
quietly tab cancr_r , gen(cancr_r_)
quietly tab diab_r , gen(diab_r_)
quietly tab lung_r , gen(lung_r_)
quietly tab arthr_r , gen(arthr_r_)
quietly tab heart_r , gen(heart_r_)


/* Subjective Probabilities */

replace worklm = worklm / 100

/*
foreach a in 0 1 2 3 4 5 6 {
foreach r in 0 1 {
foreach j in 1 2 3 4 5 {
local k = 10*`a' + 5*`r' + `j'-1
if `j' < 4 {
gen w`k' = 0 if worklm ~=.
replace w`k' = worklm^`j' if agecat == `a' & (reject_dis == `r' | reject_dis == `r'*(`r'+1))
}
if `j' == 4 {
gen w`k' = 1-worklm
replace w`k' = 0 if worklm > 0 & worklm ~=.
}
if `j' == 5 {
gen w`k' = worklm
replace w`k' = 0 if worklm < 1
}
}
}
}
*/

gen agep = (age - 55)/10
gen agep_0 = 1
gen agep_1 = agep
gen agep_2 = 2*agep^2 - 1
gen agep_3 = 4*agep^3 - 3*agep
gen agep_4 = 8*agep^4 - 8*agep^2 + 1
gen agep_5 = 16*agep^5 - 20*agep^3 + 5*agep

gen agep_1f = agep_1*female
gen agep_2f = agep_2*female
gen agep_3f = agep_3*female

gen p_use = 2*(worklm - .5)

local k = 0

foreach r in 0 1 2 {
foreach q in 0 1 {
foreach j in 1 2 4 5 {

local k = `k' + 1

if `j' == 1 {
gen pdc`k' = 0 if worklm ~=.
replace pdc`k' = agep_`q' * p_use^`j' if reject_dis == `r'
}
if `j' == 2 {
gen pdc`k' = 0 if worklm ~=.
replace pdc`k' = agep_`q' *(2*p_use^`j'-1)  if reject_dis == `r'
}
if `j' == 3 {
gen pdc`k' = 0 if worklm ~=.
replace pdc`k' = agep_`q' *(4*p_use^`j'-3*p_use)  if reject_dis == `r'
}
if `j' == 4 {
gen pdc`k' = 0 if worklm ~=.
replace pdc`k' = agep_`q' if worklm == 0 & reject_dis == `r'
}
if `j' == 5 {
gen pdc`k' = 0 if worklm ~=.
replace pdc`k' = agep_`q' if worklm == 1 & reject_dis == `r'
}
}
}
}

* Use this to incorporate females 
/*
foreach r in 0 1 2 {
foreach q in 0 1 {
foreach a in 0 1 {
foreach j in 1 2 4 5 {

local k = `k' + 1

if `j' == 1 {
gen pdc`k' = 0 if worklm ~=.
replace pdc`k' = agep_`q' * p_use^`j' if reject_dis == `r' & female == `a'
}
if `j' == 2 {
gen pdc`k' = 0 if worklm ~=.
replace pdc`k' = agep_`q' *(2*p_use^`j'-1)  if reject_dis == `r' & female == `a'
}
if `j' == 3 {
gen pdc`k' = 0 if worklm ~=.
replace pdc`k' = agep_`q' *(4*p_use^`j'-3*p_use)  if reject_dis == `r' & female == `a'
}
if `j' == 4 {
gen pdc`k' = 0 if worklm ~=.
replace pdc`k' = agep_`q' if worklm == 0 & reject_dis == `r'  & female == `a'
}
if `j' == 5 {
gen pdc`k' = 0 if worklm ~=.
replace pdc`k' = agep_`q' if worklm == 1 & reject_dis == `r'  & female == `a'
}
}
}
}
}
*/





gen worklm2 = worklm^2
gen worklm3 = worklm^3


gen age5 = agecat
replace age5 = 7 if age >= 85 & age ~= .
replace age5 = 8 if age >= 90 & age ~= .


egen finegroup_full_t = group(cenreg reject_dis age5 female) if cenreg ~=5 
/* 
replace finegroup_full_t = 1 if finegroup_full_t == 2
replace finegroup_full_t = 9 if finegroup_full_t == 10
replace finegroup_full_t = 21 if finegroup_full_t == 22
replace finegroup_full_t = 31 if finegroup_full_t == 32
replace finegroup_full_t = 43 if finegroup_full_t == 44
replace finegroup_full_t = 65 if finegroup_full_t == 66
replace finegroup_full_t = 75 if finegroup_full_t == 76
replace finegroup_full_t = 87 if finegroup_full_t == 88
*/
egen finegroup_full = group(finegroup_full_t)
egen finegroup = group(reject_dis age5) 


compress

save data/hrs_using_dis, replace

}
	
	
