/* Merge Rand file with HRS/Ahead files */


clear all
set mem 500m
set more off
set maxvar 20000

* do "C:\Users\Nathan\Desktop\Research\Insurance - Empirical\HRS Analysis\mergerand"

/* Death Tracker */

cd "data/Raw_HRS_Data/death"
do TRK2008.do
rename HHID hhid
rename PN pn
rename DEATHYR deathyr
rename DEATHMO deathmo
keep hhid pn deathyr deathmo
sort hhid pn
save death, replace
clear
cd ..
cd ..
cd ..

/* HRS 1992 */

cd "data/Raw_HRS_Data/h92"

do HEALTH.DO
rename HHID hhid
rename PN pn

rename V337 r1cancer
replace r1cancer = 0 if r1cancer == 5 
rename V339 r1cncrlyr
replace r1cncrlyr = 0 if r1cncrlyr == 5 
rename V340 r1cncrorg

rename V342 r1cncrcmo
replace r1cncrcmo = 0 if r1cncrcmo == 5 
rename V343 r1cncrsrg
replace r1cncrsrg = 0 if r1cncrsrg == 5 
rename V344 r1cncrrad
replace r1cncrrad = 0 if r1cncrrad == 5 
rename V407 r1hrtatt
replace r1hrtatt = 0 if r1hrtatt == 5 
rename V408 r1hrtattyr
replace r1hrtattyr = 0 if r1hrtattyr == 5 
rename V409 r1hrtanga
replace r1hrtanga = 0 if r1hrtanga == 5 
rename V410 r1hrtmeds
replace r1hrtmeds = 0 if r1hrtmeds == 5 
rename V411 r1hrtchf
replace r1hrtchf = 0 if r1hrtchf == 5 
rename V412 r1hrtchfmeds
replace r1hrtchfmeds = 0 if r1hrtchfmeds == 5 

rename V428 r1arthrmeds
replace r1arthrmeds = 0 if r1arthrmeds == 5 
rename V336 r1diabinsul
replace r1diabinsul = 0 if r1diabinsul == 5
rename V335 r1diabmeds
replace r1diabmeds = 0 if r1diabmeds == 5
rename V5105 r1wordrec

rename V329 r1hibpmed 

keep hhid pn r1cncrlyr r1cncrorg r1cncrcmo r1cncrsrg r1cncrrad r1hrtatt r1hrtattyr r1hrtanga r1hrtmeds r1hrtchf r1hrtchfmeds r1arthrmeds r1diabinsul r1diabmed r1wordrec r1hibpmed

sort hhid pn

save h92 , replace
clear

/*
do HOUSEHLD.DO

rename HHID hhid
rename PN pn

rename V6634 medigap
replace medigap = 1 if V6635 == 1
replace medigap = 0 if medigap == 5 | medigap == 9

rename V6638 mgpremraw
rename V6639 mgpremt

rename V6640 insrej
rename V6641 insrejwhy
rename V6804 medicaid
replace medicaid = 0 if medicaid > 1 & medicaid < 10

keep hhid pn medigap mgpremraw mgpremt insrej insrejwhy medicaid
sort hhid pn
save h92, replace
*/

clear
cd ..
cd ..
cd ..

/* Ahead 1993 */

cd "data/Raw_HRS_Data/a93"

do BR21.DO
rename HHID hhid
rename PN pn

rename V224 r2diabinsul
replace r2diabinsul = 0 if V219 == 5
replace r2diabinsul = 0 if r2diabinsul == 5
rename V223 r2diabmed 
replace r2diabmed = 0 if V219 == 5
replace r2diabmed = 0 if r2diabmed == 5

rename V231 r2cncrorg
gen r2cncrcmo = 0 if V225 == 1 | V225 == 0
replace r2cncrcmo = 1 if V232A1 == 1 | V232A2 | V232A3 == 1
gen r2cncrsrg = 0 if V225 == 1 | V225 == 0
replace r2cncrsrg = 1 if V232A1 == 2 | V232A2 == 2 | V232A3 == 2 
gen r2cncrrad = 0 if V225 == 1 | V225 == 0
replace r2cncrrad = 1 if V232A1 == 3 | V232A2 == 3 | V232A3 == 3

rename V244 r1hrtatt 
replace r1hrtatt = 0 if V242 == 5
rename V254 r2hrtanga
replace r2hrtanga = 0 if V242 == 5

rename V277 r2hipfe
replace r2hipfe = 0 if r2hipfe == 5
rename V280 r2jnt
replace r2jnt = 0 if r2jnt == 5 

rename V282 r2incont
replace r2incont = 0 if r2incont == 5
rename V284 r2incontpad
replace r2incontpad = 0 if r2incontpad == 5
replace r2incontpad = 0 if r2incont == 0

rename V294 r2hlthoth
replace r2hlthoth = 0 if r2hlthoth == 5 | r2hlthoth == 9



rename V295A1 r2hlthotha
rename V295A2 r2hlthothb

rename IMMWORDC r2wordrec
rename COG r2cog
rename COGIMM r2cogimm

rename V814 r2toilhlp
replace r2toilhlp = 0 if r2toilhlp == 5
rename MEAL r2mealhlp
rename GROC r2shophlp
rename MEDICINE r2medhlp


rename V1281 r2pnhm5y
replace r2pnhm5y = . if r2pnhm5y > 100

gen r2mgnosupp = 0
replace r2mgnosupp = 1 if V1865A1 == 2 | V1865A2 == 2 | V1865A3 == 2 | V1865A4 == 2

gen r2medigap = r2mgnosupp
replace r2medigap = 1 if V1865A1 == 3 | V1865A2 == 3 | V1865A3 == 3 | V1865A4 == 3

rename V1838 r2medicaid
replace r2medicaid = 0 if r2medicaid ~= 1 

keep hhid pn r2diabinsul r2cncrorg r2cncrcmo r2cncrsrg r2cncrrad r1hrtatt r2hrtanga r2hipfe r2jnt r2incont r2incontpad r2hlthoth r2hlthotha r2hlthothb r2wordrec r2cog r2cogimm  r2pnhm5y r2mealhlp r2medhlp r2shophlp r2medigap r2mgnosupp r2medicaid

sort hhid pn
save a93 , replace
clear
cd ..
cd ..
cd ..

/* HRS 1994 */

cd "data/Raw_HRS_Data/h94"

do W2B.DO
rename HHID hhid
rename PN pn

rename W329 r2hibpmed
replace r2hibpmed = 0 if r2hibpmed == 5 | r2hibpmed == 8 | r2hibpmed == 9

rename W337 r2diabmed
replace r2diabmed = 0 if r2diabmed == 5 | r2diabmed == 8 | r2diabmed == 9

rename W338 r2diabinsul
replace r2diabinsul = 0 if r2diabinsul == 5 | r2diabinsul == 8 | r2diabinsul == 9


rename W343 r2cncrorg
gen r2cncrcmo = 0
replace r2cncrcmo = 1 if W345 == 1 | W346 == 1 | W347 == 1
gen r2cncrsrg = 0
replace r2cncrsrg = 1 if W345 == 2 | W346 == 2 | W347 == 2
gen r2cncrrad = 0
replace r2cncrrad = 1 if W345 == 3 | W346 == 3 | W347 == 3


rename W369 r2hrtatt
replace r2hrtatt = 0 if r2hrtatt == 5 | r2hrtatt == 8 | r2hrtatt == 9
rename W371 r2hrtanga 
replace r2hrtanga = 0 if r2hrtanga == 5 | r2hrtanga == 8 | r2hrtanga == 9
rename W372 r2hrtmeds 
replace r2hrtmeds = 0 if r2hrtmeds == 5 | r2hrtmeds == 8 | r2hrtmeds == 9
rename W373 r2hrtchf 
replace r2hrtchf = 0 if r2hrtchf == 5 | r2hrtchf == 8 | r2hrtchf == 9


rename W406 r2hlthoth
replace r2hlthoth = 0 if r2hlthoth == 5 | r2hlthoth == 8 | r2hlthoth == 9

rename W407 r2hlthotha
rename W408 r2hlthothb
rename W409 r2hlthothc


keep hhid pn r2hibpmed r2diabinsul r2cncrorg r2cncrcmo r2cncrsrg r2cncrrad r2hrtatt r2hrtanga r2hrtmeds r2hrtchf r2hlthoth r2hlthotha r2hlthothb r2hlthothc 
sort hhid pn
save w2b_t, replace

clear

do W2C.DO
rename HHID hhid
rename PN pn

rename W5832 r2wordrec
replace r2wordrec = . if r2wordrec == 96

rename W5848 r2pnhm5y 
replace r2pnhm5y = . if r2pnhm5y > 100

keep hhid pn r2wordrec r2pnhm5y
sort hhid pn
save w2c_t, replace
clear

do W2R.DO
rename HHID hhid
rename PN pn

gen r2mgnosupp = 0
replace r2mgnosupp = 1 if W6758 == 2 | W6759 == 2
gen r2medigap = r2mgnosupp
replace r2medigap = 1 if W6758 == 3 | W6759 == 3

gen r2medicaid = 0 
replace r2medicaid = 1 if W6701 == 2 | W6702 == 2 

keep hhid pn r2mgnosupp r2medigap r2medicaid

sort hhid pn
merge hhid pn using w2b_t , _merge(W2_m)
tab W2_m
drop W2_m
sort hhid pn
merge hhid pn using w2c_t , _merge(W2_m)
drop W2_m

sort hhid pn
save h94, replace

/* Ahead 1995 */

clear
cd ..
cd ..
cd ..

cd "data/Raw_HRS_Data/a95"
do A95B_R.DO

rename HHID hhid
rename PN pn

rename D782 r3hibpmed
replace r3hibpmed = 0 if D781 == 5 | D781 == 3 | r3hibpmed == 5
rename D790 r3diabinsul
replace r3diabinsul = 0 if D788 == 5 | D788 == 3 | D788 == 8 | r3diabinsul == 5

gen r3cncrcmo = 0
replace r3cncrcmo = 1 if D804M1 == 1 | D804M2 == 1 | D804M3 == 1 | D804M4 == 1
gen r3cncrsrg = 0
replace r3cncrsrg = 1 if D804M1 == 2 | D804M2 == 2 | D804M3 == 2 | D804M4 == 2
gen r3cncrrad = 0
replace r3cncrrad = 1 if D804M1 == 3 | D804M2 == 3 | D804M3 == 3 | D804M4 == 3

rename D829 r3hrtmeds
replace r3hrtmeds = 0 if r3hrtmeds ~= 1
rename D834 r3hrtatt
replace r3hrtatt = 0 if r3hrtatt ~= 1
rename D840 r3hrtanga
replace r3hrtanga = 0 if r3hrtanga ~= 1
rename D843 r3hrtchf
replace r3hrtchf = 0 if r3hrtchf ~= 1

rename D887 r3hipfe 
replace r3hipfe = . if r3hipfe == 8
replace r3hipfe = 0 if r3hipfe == 5

rename D892 r3incont
replace r3incont = . if r3incont == 8 | r3incont == 9
replace r3incont = 0 if r3incont == 5

rename D896 r3incontpad
replace r3incontpad = . if r3incontpad == 8 | r3incontpad == 9
replace r3incontpad = 0 if r3incont == 0 | r3incontpad == 5

rename D915 r3hlthoth
replace r3hlthoth = 0 if r3hlthoth == 5
replace r3hlthoth = . if r3hlthoth == 8 | r3hlthoth == 9


keep hhid pn r3hibpmed r3diabinsul r3cncrcmo r3cncrsrg r3cncrrad r3hrtmeds r3hrtatt r3hrtanga r3hrtchf r3hipfe r3incont r3incontpad r3hlthoth

sort hhid pn
save a95b, replace
clear
do A95C_R.DO
rename HHID hhid
rename PN pn

gen r3wordrec = .
replace r3wordrec = 11 if D1174M11 > 40 
replace r3wordrec = 10 if D1174M10 > 40 
replace r3wordrec = 9 if D1174M9 > 40 
replace r3wordrec = 8 if D1174M8 > 40 
replace r3wordrec = 7 if D1174M7 > 40 
replace r3wordrec = 6 if D1174M6 > 40 
replace r3wordrec = 5 if D1174M5 > 40 
replace r3wordrec = 4 if D1174M4 > 40 
replace r3wordrec = 3 if D1174M3 > 40 
replace r3wordrec = 2 if D1174M2 > 40 
replace r3wordrec = 1 if D1174M1 > 40 

keep hhid pn r3wordrec
sort hhid pn
save a95c, replace
clear

do A95R_R.DO
rename HHID hhid
rename PN pn

gen r3medicaid = 0
replace r3medicaid = 1 if D5155 == 1

keep hhid pn r3medicaid
sort hhid pn

save a95r, replace


clear
do x95CS_R.do
rename HHID hhid
rename PN pn
rename N226 r3wdie
rename N249 r3wliv
rename N419 r3wliv_mo
rename N418 r3wliv_yr

keep hhid pn r3wdie r3wliv*
sort hhid pn
save x95, replace

clear
do A95H_R.DO
rename HHID hhid
rename PN pn
rename D3792 r3pnhm5y
replace r3pnhm5y = . if r3pnhm5y > 100
keep hhid pn r3pnhm5y 
sort hhid pn
merge hhid pn using a95b
tab _merge
drop _merge

sort hhid pn
merge hhid pn using a95c
tab _merge
drop _merge

sort hhid pn
merge hhid pn using a95r
drop _merge

sort hhid pn
merge hhid pn using x95
drop _merge

sort hhid pn
save a95, replace


clear
cd ..
cd ..
cd ..

/* HRS 1996 */

cd "data/Raw_HRS_Data/h96"
do H96B_R.DO
rename HHID hhid
rename PN pn

rename E782 r3hibpmed 
replace r3hibpmed  = . if r3hibpmed  == 8 
replace r3hibpmed  = 0 if E781 == 5 | r3hibpmed == 5

rename E790 r3diabinsul
replace r3diabinsul = . if  r3diabinsul == 8 | r3diabinsul == 9
replace r3diabinsul = 0 if r3diabinsul == 5 | E788 == 5


gen r3cncrcmo = 0
replace r3cncrcmo = 1 if E804M1 == 1 | E804M2 == 1 | E804M3 == 1 | E804M4 == 1
gen r3cncrsrg = 0
replace r3cncrsrg = 1 if E804M1 == 2 | E804M2 == 2 | E804M3 == 2 | E804M4 == 2
gen r3cncrrad = 0
replace r3cncrrad = 1 if E804M1 == 3 | E804M2 == 3 | E804M3 == 3 | E804M4 == 3

rename E829 r3hrtmeds
replace r3hrtmeds = 0 if r3hrtmeds ~= 1
rename E834 r3hrtatt
replace r3hrtatt = 0 if r3hrtatt ~= 1
rename E840 r3hrtanga
replace r3hrtanga = 0 if r3hrtanga ~= 1
rename E843 r3hrtchf
replace r3hrtchf = 0 if r3hrtchf ~= 1


rename E887 r3hipfe 
replace r3hipfe = . if r3hipfe == 8
replace r3hipfe = 0 if r3hipfe == 5

rename E892 r3incont
replace r3incont = . if r3incont == 8 | r3incont == 9
replace r3incont = 0 if r3incont == 5

rename E896 r3incontpad
replace r3incontpad = . if r3incontpad == 8 | r3incontpad == 9
replace r3incontpad = 0 if r3incont == 0 | r3incontpad == 5

rename E915 r3hlthoth
replace r3hlthoth = 0 if r3hlthoth == 5
replace r3hlthoth = . if r3hlthoth == 8 | r3hlthoth == 9


keep hhid pn r3hibpmed r3diabinsul r3cncrcmo r3cncrsrg r3cncrrad r3hrtmeds r3hrtatt r3hrtanga r3hrtchf r3hipfe r3incont r3incontpad r3hlthoth

sort hhid pn
save h96b, replace
clear
do H96C_R.DO
rename HHID hhid
rename PN pn

gen r3wordrec = .
replace r3wordrec = 11 if E1174M11 > 40 
replace r3wordrec = 10 if E1174M10 > 40 
replace r3wordrec = 9 if E1174M9 > 40 
replace r3wordrec = 8 if E1174M8 > 40 
replace r3wordrec = 7 if E1174M7 > 40 
replace r3wordrec = 6 if E1174M6 > 40 
replace r3wordrec = 5 if E1174M5 > 40 
replace r3wordrec = 4 if E1174M4 > 40 
replace r3wordrec = 3 if E1174M3 > 40 
replace r3wordrec = 2 if E1174M2 > 40 
replace r3wordrec = 1 if E1174M1 > 40 

keep hhid pn r3wordrec
sort hhid pn
save h96c, replace


clear
do x96CS_R.do
rename HHID hhid
rename PN pn
rename P226 r3wdie
rename P249 r3wliv
rename P419 r3wliv_mo
rename P418 r3wliv_yr

keep hhid pn r3wdie r3wliv*
sort hhid pn
save x96, replace


clear
do H96R_R.DO
rename HHID hhid
rename PN pn

gen r3medigap = 0 
replace r3medigap = 1 if E5206 == 1 
gen r3mglet = 0
replace r3mglet = E5207 if E5206 == 1
gen r3mgpay = 0
replace r3mgpay = E5209 if E5209 < 50000
gen r3mgpayt = E5210

gen r3medicaid = 0
replace r3medicaid = 1 if E5136 == 1

keep hhid pn r3medigap r3mglet r3mgpay r3mgpayt r3medicaid
sort hhid pn
save h96r, replace

sort hhid pn
merge hhid pn using h96b
tab _merge
drop _merge
sort hhid pn
merge hhid pn using h96r
drop _merge
sort hhid pn
merge hhid pn using x96
drop _merge

sort hhid pn
save h96, replace
clear
cd ..
cd ..
cd ..

/* HRS 1998 */

cd "data/Raw_HRS_Data/h98"
do H98B_R.DO

rename HHID hhid
rename PN pn

rename F1110 r4hibpmed 
replace r4hibpmed  = . if r4hibpmed  > 5
replace r4hibpmed  = 0 if F1109 == 5 | r4hibpmed == 5

rename F1118 r4diabinsul
replace r4diabinsul = . if r4diabinsul > 5
replace r4diabinsul = 0 if r4diabinsul == 5 | F1116 == 5


gen r4cncrcmo = 0
replace r4cncrcmo = 1 if F1132M1 == 1 | F1132M2 == 1 | F1132M3 == 1 | F1132M4 == 1
gen r4cncrsrg = 0
replace r4cncrsrg = 1 if F1132M1 == 2 | F1132M2 == 2 | F1132M3 == 2 | F1132M4 == 2
gen r4cncrrad = 0
replace r4cncrrad = 1 if F1132M1 == 3 | F1132M2 == 3 | F1132M3 == 3 | F1132M4 == 3

rename F1157 r4hrtmeds
replace r4hrtmeds = 0 if r4hrtmeds ~= 1
rename F1162 r4hrtatt
replace r4hrtatt = 0 if r4hrtatt ~= 1
rename F1168 r4hrtanga
replace r4hrtanga = 0 if r4hrtanga ~= 1
rename F1171 r4hrtchf
replace r4hrtchf = 0 if r4hrtchf ~= 1


rename F1215 r4hipfe 
replace r4hipfe = . if r4hipfe == 8
replace r4hipfe = 0 if r4hipfe == 5

rename F1220 r4incont
replace r4incont = . if r4incont == 8 | r4incont == 9
replace r4incont = 0 if r4incont == 5

rename F1224 r4incontpad
replace r4incontpad = . if r4incontpad == 8 | r4incontpad == 9
replace r4incontpad = 0 if r4incont == 0 | r4incontpad == 5

gen r4hlthoth = 0 if F1243M1M == 996
replace r4hlthoth = 1 if F1243M1M < 996

gen r4hlthotha = F1243M1M


keep hhid pn r4hibpmed r4diabinsul r4cncrcmo r4cncrsrg r4cncrrad r4hrtmeds r4hrtatt r4hrtanga r4hrtchf r4hipfe r4incont r4incontpad r4hlthoth r4hlthotha 

sort hhid pn
save h98b, replace

clear
do H98R_R.DO
rename HHID hhid
rename PN pn
gen r4medicaid = 0
replace r4medicaid = 1 if F5869 == 1
keep hhid pn r4medicaid
sort hhid pn
save h98r, replace

clear
do x98CS_R.do
rename HHID hhid
rename PN pn
rename Q491 r4wdie
rename Q519 r4wliv
rename Q720 r4wliv_mo
rename Q721 r4wliv_yr

keep hhid pn r4wdie r4wliv*
sort hhid pn
save x98, replace


clear
do H98C_R.DO
rename HHID hhid
rename PN pn

gen r4wordrec = .
replace r4wordrec = 11 if F1491M11 > 40 
replace r4wordrec = 10 if F1491M10 > 40 
replace r4wordrec = 9 if F1491M9 > 40 
replace r4wordrec = 8 if F1491M8 > 40 
replace r4wordrec = 7 if F1491M7 > 40 
replace r4wordrec = 6 if F1491M6 > 40 
replace r4wordrec = 5 if F1491M5 > 40 
replace r4wordrec = 4 if F1491M4 > 40 
replace r4wordrec = 3 if F1491M3 > 40 
replace r4wordrec = 2 if F1491M2 > 40 
replace r4wordrec = 1 if F1491M1 > 40 

keep hhid pn r4wordrec
sort hhid pn
save h98c, replace

sort hhid pn
merge hhid pn using h98b
tab _merge
drop _merge

sort hhid pn
merge hhid pn using h98r
tab _merge
drop _merge

sort hhid pn
merge hhid pn using x98
tab _merge
drop _merge

sort hhid pn
save h98, replace
clear
cd ..
cd ..
cd ..

/* HRS 2000 */

cd "data/Raw_HRS_Data/h00"
do H00B_R.DO

rename HHID hhid
rename PN pn

rename G1239 r5hibpmed 
replace r5hibpmed  = . if r5hibpmed  > 5
replace r5hibpmed  = 0 if G1238 == 5 | r5hibpmed == 5

rename G1249 r5diabinsul
replace r5diabinsul = . if r5diabinsul > 5
replace r5diabinsul = 0 if r5diabinsul == 5 | G1245 == 5


gen r5cncrcmo = 0
replace r5cncrcmo = 1 if G1265M1 == 1 | G1265M2 == 1 | G1265M3 == 1 | G1265M4 == 1
gen r5cncrsrg = 0
replace r5cncrsrg = 1 if G1265M1 == 2 | G1265M2 == 2 | G1265M3 == 2 | G1265M4 == 2
gen r5cncrrad = 0
replace r5cncrrad = 1 if G1265M1 == 3 | G1265M2 == 3 | G1265M3 == 3 | G1265M4 == 3

rename G1290 r5hrtmeds
replace r5hrtmeds = 0 if r5hrtmeds ~= 1
rename G1295 r5hrtatt
replace r5hrtatt = 0 if r5hrtatt ~= 1
rename G1301 r5hrtanga
replace r5hrtanga = 0 if r5hrtanga ~= 1
rename G1304 r5hrtchf
replace r5hrtchf = 0 if r5hrtchf ~= 1


rename G1348 r5hipfe 
replace r5hipfe = . if r5hipfe == 8
replace r5hipfe = 0 if r5hipfe == 5

rename G1353 r5incont
replace r5incont = . if r5incont == 8 | r5incont == 9
replace r5incont = 0 if r5incont == 5

rename G1357 r5incontpad
replace r5incontpad = . if r5incontpad == 8 | r5incontpad == 9
replace r5incontpad = 0 if r5incont == 0 | r5incontpad == 5

rename G1376 r5hlthoth
replace r5hlthoth = 0 if  r5hlthoth >= 5 & r5hlthoth ~=.

rename G1377M1M r5hlthotha


keep hhid pn r5hibpmed r5diabinsul r5cncrcmo r5cncrsrg r5cncrrad r5hrtmeds r5hrtatt r5hrtanga r5hrtchf r5hipfe r5incont r5incontpad r5hlthoth r5hlthotha 

sort hhid pn
save h00b, replace
clear

clear
do H00R_R.DO
rename HHID hhid
rename PN pn
gen r5medicaid = 0
replace r5medicaid = 1 if G6242 == 1
keep hhid pn r5medicaid
sort hhid pn
save h00r, replace

clear
do x00CS_R.do
rename HHID hhid
rename PN pn
rename R525 r5wdie
rename R558 r5wliv
rename R789 r5wliv_mo
rename R790 r5wliv_yr

keep hhid pn r5wdie r5wliv*
sort hhid pn
save x00, replace

clear
do H00C_R.DO
rename HHID hhid
rename PN pn

gen r5wordrec = .
replace r5wordrec = 11 if G1666M11 > 40 
replace r5wordrec = 10 if G1666M10 > 40 
replace r5wordrec = 9 if G1666M9 > 40 
replace r5wordrec = 8 if G1666M8 > 40 
replace r5wordrec = 7 if G1666M7 > 40 
replace r5wordrec = 6 if G1666M6 > 40 
replace r5wordrec = 5 if G1666M5 > 40 
replace r5wordrec = 4 if G1666M4 > 40 
replace r5wordrec = 3 if G1666M3 > 40 
replace r5wordrec = 2 if G1666M2 > 40 
replace r5wordrec = 1 if G1666M1 > 40 

keep hhid pn r5wordrec
sort hhid pn
save h00c, replace

sort hhid pn
merge hhid pn using h00b
tab _merge
drop _merge

sort hhid pn
merge hhid pn using h00r
tab _merge
drop _merge

sort hhid pn
merge hhid pn using x00
tab _merge
drop _merge

sort hhid pn
save h00, replace
clear
cd ..
cd ..
cd ..

/* HRS 2002 */
cd "data/Raw_HRS_Data/h02"
do H02C_R.do

rename HHID hhid
rename PN pn


rename HC006 r6hibpmed 
replace r6hibpmed  = . if r6hibpmed  > 5
replace r6hibpmed  = 0 if HC005 == 5 | r6hibpmed == 5

rename HC012 r6diabinsul
replace r6diabinsul = . if r6diabinsul > 5
replace r6diabinsul = 0 if r6diabinsul == 5 | HC010 == 5


gen r6cncrcmo = 0
replace r6cncrcmo = 1 if HC021M1 == 1 | HC021M2 == 1 | HC021M3 == 1 | HC021M4 == 1
gen r6cncrsrg = 0
replace r6cncrsrg = 1 if HC021M1 == 2 | HC021M2 == 2 | HC021M3 == 2 | HC021M4 == 2
gen r6cncrrad = 0
replace r6cncrrad = 1 if HC021M1 == 3 | HC021M2 == 3 | HC021M3 == 3 | HC021M4 == 3

rename HC037 r6hrtmeds
replace r6hrtmeds = 0 if r6hrtmeds ~= 1
rename HC040 r6hrtatt
replace r6hrtatt = 0 if r6hrtatt ~= 1
rename HC045 r6hrtanga
replace r6hrtanga = 0 if r6hrtanga ~= 1
rename HC048 r6hrtchf
replace r6hrtchf = 0 if r6hrtchf ~= 1


rename HC082 r6hipfe 
replace r6hipfe = . if r6hipfe == 8
replace r6hipfe = 0 if r6hipfe == 5

rename HC087 r6incont
replace r6incont = . if r6incont == 8 | r6incont == 9
replace r6incont = 0 if r6incont == 5

rename HC094 r6incontpad
replace r6incontpad = . if r6incontpad == 8 | r6incontpad == 9
replace r6incontpad = 0 if r6incont == 0 | r6incontpad == 5

rename HC107 r6hlthoth
replace r6hlthoth = 0 if  r6hlthoth >= 5 & r6hlthoth~=.

rename HC108M1M r6hlthotha


keep hhid pn r6hibpmed r6diabinsul r6cncrcmo r6cncrsrg r6cncrrad r6hrtmeds r6hrtatt r6hrtanga r6hrtchf r6hipfe r6incont r6incontpad r6hlthoth r6hlthotha 

sort hhid pn
save h02c, replace

clear
do H02N_R.do
rename HHID hhid
rename PN pn
gen r6medicaid = 0
replace r6medicaid = 1 if HN006 == 1
keep hhid pn r6medicaid
sort hhid pn
save h02n, replace

clear
do x02A_R.do
rename HHID hhid
rename PN pn
rename SA124 r6wdie
rename SA028 r6wliv
rename SA065 r6wliv_mo
rename SA066 r6wliv_yr

keep hhid pn r6wdie r6wliv*
sort hhid pn
save x02, replace

clear
do H02D_R.do
rename HHID hhid
rename PN pn

gen r6wordrec = .
replace r6wordrec = 10 if HD182M10 > 40 
replace r6wordrec = 9 if HD182M9 > 40 
replace r6wordrec = 8 if HD182M8 > 40 
replace r6wordrec = 7 if HD182M7 > 40 
replace r6wordrec = 6 if HD182M6 > 40 
replace r6wordrec = 5 if HD182M5 > 40 
replace r6wordrec = 4 if HD182M4 > 40 
replace r6wordrec = 3 if HD182M3 > 40 
replace r6wordrec = 2 if HD182M2 > 40 
replace r6wordrec = 1 if HD182M1 > 40 

keep hhid pn r6wordrec
sort hhid pn
save h02d, replace
clear

do H02A_R.do
rename HHID hhid
rename PN pn
rename HA065 r6nhmo
rename HA066 r6nhyr
sort hhid pn
keep hhid pn r6nhmo r6nhyr

sort hhid pn
merge hhid pn using h02c
tab _merge
drop _merge
sort hhid pn
merge hhid pn using h02d
tab _merge
drop _merge
sort hhid pn
merge hhid pn using h02n
tab _merge
drop _merge

sort hhid pn
merge hhid pn using x02
tab _merge
drop _merge

sort hhid pn
save h02, replace
clear
cd ..
cd ..
cd ..

/* HRS 2004 */

cd "data/Raw_HRS_Data/h04"

do H04C_R.do

rename HHID hhid
rename PN pn


rename JC006 r7hibpmed 
replace r7hibpmed  = . if r7hibpmed  > 5
replace r7hibpmed  = 0 if JC005 == 5 | r7hibpmed == 5

rename JC012 r7diabinsul
replace r7diabinsul = . if r7diabinsul > 5
replace r7diabinsul = 0 if r7diabinsul == 5 | JC010 == 5


gen r7cncrcmo = 0
replace r7cncrcmo = 1 if JC021M1 == 1 | JC021M2 == 1 | JC021M3 == 1 | JC021M4 == 1
gen r7cncrsrg = 0
replace r7cncrsrg = 1 if JC021M1 == 2 | JC021M2 == 2 | JC021M3 == 2 | JC021M4 == 2
gen r7cncrrad = 0
replace r7cncrrad = 1 if JC021M1 == 3 | JC021M2 == 3 | JC021M3 == 3 | JC021M4 == 3

rename JC037 r7hrtmeds
replace r7hrtmeds = 0 if r7hrtmeds ~= 1
rename JC040 r7hrtatt
replace r7hrtatt = 0 if r7hrtatt ~= 1
rename JC045 r7hrtanga
replace r7hrtanga = 0 if r7hrtanga ~= 1
rename JC048 r7hrtchf
replace r7hrtchf = 0 if r7hrtchf ~= 1


rename JC082 r7hipfe 
replace r7hipfe = . if r7hipfe == 8
replace r7hipfe = 0 if r7hipfe == 5

rename JC087 r7incont
replace r7incont = . if r7incont == 8 | r7incont == 9
replace r7incont = 0 if r7incont == 5


rename JC107 r7hlthoth
replace r7hlthoth = 0 if  r7hlthoth >= 5 & r7hlthoth ~=.

rename JC108M1M r7hlthotha


keep hhid pn r7hibpmed r7diabinsul r7cncrcmo r7cncrsrg r7cncrrad r7hrtmeds r7hrtatt r7hrtanga r7hrtchf r7hipfe r7incont r7hlthoth r7hlthotha 

sort hhid pn
save h04c, replace
clear

clear
do H04N_R.do
rename HHID hhid
rename PN pn
gen r7medicaid = 0
replace r7medicaid = 1 if JN006 == 1
keep hhid pn r7medicaid
sort hhid pn
save h04n, replace

clear
do x04A_R.do
rename HHID hhid
rename PN pn
rename TA124 r7wdie
rename TA167 r7wliv
rename TA065 r7wliv_mo
rename TA066 r7wliv_yr

keep hhid pn r7wdie r7wliv*
sort hhid pn
save x04, replace

clear
do H04D_R.do
rename HHID hhid
rename PN pn

gen r7wordrec = .
replace r7wordrec = 12 if JD182M12 > 40 
replace r7wordrec = 11 if JD182M11 > 40 
replace r7wordrec = 10 if JD182M10 > 40 
replace r7wordrec = 9 if JD182M9 > 40 
replace r7wordrec = 8 if JD182M8 > 40 
replace r7wordrec = 7 if JD182M7 > 40 
replace r7wordrec = 6 if JD182M6 > 40 
replace r7wordrec = 5 if JD182M5 > 40 
replace r7wordrec = 4 if JD182M4 > 40 
replace r7wordrec = 3 if JD182M3 > 40 
replace r7wordrec = 2 if JD182M2 > 40 
replace r7wordrec = 1 if JD182M1 > 40 

keep hhid pn r7wordrec
sort hhid pn
save h04d, replace
clear
do H04A_R.do
rename HHID hhid
rename PN pn

rename JA065 r7nhmo
rename JA066 r7nhyr

keep hhid pn r7nhmo r7nhyr

sort hhid pn
merge hhid pn using h04c
tab _merge
drop _merge
sort hhid pn
merge hhid pn using h04d
tab _merge
drop _merge
sort hhid pn
merge hhid pn using h04n
tab _merge
drop _merge
sort hhid pn
merge hhid pn using x04
tab _merge
drop _merge

sort hhid pn
save h04, replace
clear
cd ..
cd ..
cd ..

/* HRS 2006 */


cd "data/Raw_HRS_Data/h06"

do H06C_R.do

rename HHID hhid
rename PN pn


rename KC006 r8hibpmed 
replace r8hibpmed  = . if r8hibpmed  > 5
replace r8hibpmed  = 0 if KC005 == 5 | r8hibpmed == 5

rename KC012 r8diabinsul
replace r8diabinsul = . if r8diabinsul > 5
replace r8diabinsul = 0 if r8diabinsul == 5 | KC010 == 5


gen r8cncrcmo = 0
replace r8cncrcmo = 1 if KC021M1 == 1 | KC021M2 == 1 | KC021M3 == 1 | KC021M4 == 1
gen r8cncrsrg = 0
replace r8cncrsrg = 1 if KC021M1 == 2 | KC021M2 == 2 | KC021M3 == 2 | KC021M4 == 2
gen r8cncrrad = 0
replace r8cncrrad = 1 if KC021M1 == 3 | KC021M2 == 3 | KC021M3 == 3 | KC021M4 == 3

rename KC037 r8hrtmeds
replace r8hrtmeds = 0 if r8hrtmeds ~= 1
rename KC040 r8hrtatt
replace r8hrtatt = 0 if r8hrtatt ~= 1
rename KC045 r8hrtanga
replace r8hrtanga = 0 if r8hrtanga ~= 1
rename KC048 r8hrtchf
replace r8hrtchf = 0 if r8hrtchf ~= 1


rename KC082 r8hipfe 
replace r8hipfe = . if r8hipfe == 8 | r8hipfe == 9
replace r8hipfe = 0 if r8hipfe == 5

rename KC087 r8incont
replace r8incont = . if r8incont == 8 | r8incont == 9
replace r8incont = 0 if r8incont == 5


rename KC107 r8hlthoth
replace r8hlthoth = 0 if  r8hlthoth >= 5 & r8hlthoth~=.

rename KC108M1M r8hlthotha


keep hhid pn r8hibpmed r8diabinsul r8cncrcmo r8cncrsrg r8cncrrad r8hrtmeds r8hrtatt r8hrtanga r8hrtchf r8hipfe r8incont r8hlthoth r8hlthotha 

sort hhid pn
save h06c, replace
clear

clear
do H06N_R.do
rename HHID hhid
rename PN pn
gen r8medicaid = 0
replace r8medicaid = 1 if KN006 == 1
keep hhid pn r8medicaid
sort hhid pn
save h06n, replace
clear

do X06A_R.do
rename HHID hhid
rename PN pn
rename UA124 r8wdie
rename UA167 r8wliv
rename UA065 r8wliv_mo
rename UA066 r8wliv_yr

keep hhid pn r8wdie r8wliv*
sort hhid pn
save x06, replace
clear

do H06D_R.do
rename HHID hhid
rename PN pn

gen r8wordrec = .
replace r8wordrec = 10 if KD182M10 > 40 
replace r8wordrec = 9 if KD182M9 > 40 
replace r8wordrec = 8 if KD182M8 > 40 
replace r8wordrec = 7 if KD182M7 > 40 
replace r8wordrec = 6 if KD182M6 > 40 
replace r8wordrec = 5 if KD182M5 > 40 
replace r8wordrec = 4 if KD182M4 > 40 
replace r8wordrec = 3 if KD182M3 > 40 
replace r8wordrec = 2 if KD182M2 > 40 
replace r8wordrec = 1 if KD182M1 > 40 

keep hhid pn r8wordrec
sort hhid pn
save h06d, replace
clear
do H06A_R.do
rename HHID hhid
rename PN pn


rename KA065 r8nhmo
rename KA066 r8nhyr

keep hhid pn r8nhmo r8nhyr


sort hhid pn
merge hhid pn using h06c
tab _merge
drop _merge
sort hhid pn
merge hhid pn using h06d
tab _merge
drop _merge
sort hhid pn
merge hhid pn using h06n
tab _merge
drop _merge
sort hhid pn
merge hhid pn using x06
tab _merge
drop _merge

sort hhid pn
save h06, replace
clear
cd ..
cd ..
cd ..


/* HRS 2008 */


cd "data/Raw_HRS_Data/h08"

do H08C_R.do

rename HHID hhid
rename PN pn


rename LC006 r9hibpmed 
replace r9hibpmed  = . if r9hibpmed  > 5
replace r9hibpmed  = 0 if LC005 == 5 | r9hibpmed == 5

rename LC012 r9diabinsul
replace r9diabinsul = . if r9diabinsul > 5
replace r9diabinsul = 0 if r9diabinsul == 5 | LC010 == 5


gen r9cncrcmo = 0
replace r9cncrcmo = 1 if LC021M1 == 1 | LC021M2 == 1 | LC021M3 == 1 | LC021M4 == 1
gen r9cncrsrg = 0
replace r9cncrsrg = 1 if LC021M1 == 2 | LC021M2 == 2 | LC021M3 == 2 | LC021M4 == 2
gen r9cncrrad = 0
replace r9cncrrad = 1 if LC021M1 == 3 | LC021M2 == 3 | LC021M3 == 3 | LC021M4 == 3

rename LC037 r9hrtmeds
replace r9hrtmeds = 0 if r9hrtmeds ~= 1
rename LC040 r9hrtatt
replace r9hrtatt = 0 if r9hrtatt ~= 1
rename LC045 r9hrtanga
replace r9hrtanga = 0 if r9hrtanga ~= 1
rename LC048 r9hrtchf
replace r9hrtchf = 0 if r9hrtchf ~= 1


rename LC082 r9hipfe 
replace r9hipfe = . if r9hipfe == 8 | r9hipfe == 9
replace r9hipfe = 0 if r9hipfe == 5

rename LC087 r9incont
replace r9incont = . if r9incont == 8 | r9incont == 9
replace r9incont = 0 if r9incont == 5


rename LC107 r9hlthoth
replace r9hlthoth = 0 if  r9hlthoth >= 5 & r9hlthoth~=.

rename LC108M1M r9hlthotha


keep hhid pn r9hibpmed r9diabinsul r9cncrcmo r9cncrsrg r9cncrrad r9hrtmeds r9hrtatt r9hrtanga r9hrtchf r9hipfe r9incont r9hlthoth r9hlthotha 

sort hhid pn
save h08c, replace

clear
do H08N_R.do
rename HHID hhid
rename PN pn
gen r9medicaid = 0
replace r9medicaid = 1 if LN006 == 1
keep hhid pn r9medicaid
sort hhid pn
save h08n, replace

clear
do X08A_R.do
rename HHID hhid
rename PN pn
rename VA124 r9wdie
rename VA167 r9wliv
rename VA065 r9wliv_mo
rename VA066 r9wliv_yr

keep hhid pn r9wdie r9wliv*
sort hhid pn
save x08, replace
clear

do H08D_R.do
rename HHID hhid
rename PN pn

gen r9wordrec = .
replace r9wordrec = 10 if LD182M10 > 40 
replace r9wordrec = 9 if LD182M9 > 40 
replace r9wordrec = 8 if LD182M8 > 40 
replace r9wordrec = 7 if LD182M7 > 40 
replace r9wordrec = 6 if LD182M6 > 40 
replace r9wordrec = 5 if LD182M5 > 40 
replace r9wordrec = 4 if LD182M4 > 40 
replace r9wordrec = 3 if LD182M3 > 40 
replace r9wordrec = 2 if LD182M2 > 40 
replace r9wordrec = 1 if LD182M1 > 40 

keep hhid pn r9wordrec
sort hhid pn
save h08d, replace
clear
do H08A_R.do
rename HHID hhid
rename PN pn
rename LA065 r9nhmo
rename LA066 r9nhyr
keep hhid pn r9nhmo r9nhyr

sort hhid pn
merge hhid pn using h08c
tab _merge
drop _merge
sort hhid pn
merge hhid pn using h08d
tab _merge
drop _merge
sort hhid pn
merge hhid pn using h08n
tab _merge
drop _merge
sort hhid pn
merge hhid pn using x08
tab _merge
drop _merge

sort hhid pn
save h08, replace
clear
cd ..

/* MERGE! */

use h92/h92
sort hhid pn
merge m:m hhid pn using a93/a93, nogen
merge m:m hhid pn using h94/h94, nogen update
merge m:m hhid pn using a95/a95, nogen update
merge m:m hhid pn using h96/h96, nogen update
merge m:m hhid pn using h98/h98, nogen
merge m:m hhid pn using h00/h00, nogen
merge m:m hhid pn using h02/h02, nogen
merge m:m hhid pn using h04/h04, nogen
merge m:m hhid pn using h06/h06, nogen
merge m:m hhid pn using h08/h08, nogen
merge m:m hhid pn using death/death, nogen


* Data Fixing *

replace r7hlthoth = r6hlthoth if r7hlthoth == .

sort hhid pn
cd ..
save rawmerge, replace
clear
cd ..




