
clear all
set mem 1500m
set maxvar 30000
set more off
set matsize 11000


* Settings *
global samplemarker = 0
global analysis = 0
global sumstats = 1
global bootstrap = 0

global std = "vce(cluster hhid)"
global breps = 1000
global bcluster = "cluster(hhid)"
*********************
/* Global Variables */
*********************

* LTC Covariates *
global ltcagegender = "agegender_* "
*global ltcagegender = " age agesq female agefemale agesqfemale "
global ltccovariatesfull = " agegender_* lowword i_adl_num psych diab lung arthr heart cancr stroke hibp numconditionsagecat1_* numconditionsagecat2_* numadlagerej_* famcat_* homcarage_* agereg_* ageinc_* " 
*global ltccovariatesprice = " pricegroup_* " 
global ltccovariatesmat = "age agesq female agefemale agesqfemale lowword i_adl_num psych diab lung arthr heart cancr stroke hibp "
global ltccovariatesprice = "age agesq female agefemale agesqfemale lowword i_adl_num psych diab lung arthr heart cancr stroke hibp "

/*
global ltcsubj = ""
foreach a in 2 3 4 5 6 {
foreach r in 0 1 {
foreach j in 1 2 3 {
local k = 10*`a' + 5*`r' + `j'-1
global ltcsubj = "$ltcsubj n`k' m`k'"
}
}
}
*/
global ltcsubj = "pnc*"

global ltcsubj_s = "sp sp2 sp3 "

* Life Covariates *
global lifeagegender = "agegender_* yearsquestion_*"
*global lifecovariatesprice = "agegenbmi_* agecatsmoke_* ageinc_* heart_r_* strok_r_* cancr_r_* lung_r_* diab_r_* agedg_* " 
global lifecovariatesfull = " agegender_* bmigrp obese agecatsmoke_* ageinc_* heartgroup_* strokgroup_* cancrgroup_* lunggroup_* hibpgroup_* diabgroup_* agereg_* agedg_* yearsquestion_* parentb460" 
global lifecovariatesmat = "age agesq female agefemale agesqfemale smoken bmi psych diab lung arthr heart cancr stroke hibp incomecat_* yearsquestion_* parentb460"
global lifecovariatesprice = "age agesq female agefemale agesqfemale smoken bmi psych diab lung arthr heart cancr stroke hibp incomecat_* yearsquestion_* parentb460"
global lifecovariatescancr =  " agegender_* bmigrp obese agecatsmoke_* ageinc_* heartgroup_* strokgroup_* cancrgroup_* lunggroup_* hibpgroup_* diabgroup_* agereg_* agedg_* yearsquestion_* parentb460 cncrorg_*" 

/*
global lifesubj = ""
foreach a in 0 1 2 3 4 5 6 {
foreach r in 0 1 {
foreach j in 1 2 3 {
local k = 10*`a' + 5*`r' + `j'-1
global lifesubj = "$lifesubj l`k'"
}
}
}
*/
global lifesubj = "plc*"
*global lifesubj = "age0liv75 age1liv75 age2liv75 age3liv75 age4liv75 age5liv75 age6liv75 age0liv75_2 age1liv75_2 age2liv75_2 age3liv75_2 age4liv75_2 age5liv75_2 age6liv75_2 age0liv75_3 age1liv75_3 age2liv75_3 age3liv75_3 age4liv75_3 age5liv75_3 age6liv75_3 "
global lifesubj_s = "liv liv_2 liv_3"

* Disability Covariates *
global disagegender = "agegender_* "
global discovariatesfull = " agegender_* jobchar_* jobdiff_* backgroup_* psychegroup_* cancrgroup_* diabgroup_* lunggroup_* arthrgroup_* bmigroup_* heartgroup_* agereg_* "
*global discovariatesprice = "agegender_* jobchar_* back_r_* psych_r_* cancr_r_* diab_r_* lung_r_* arthr_r_* heart_r_*  "
global discovariatesmat = "age agesq female agefemale agesqfemale slfemp obese psych back wagecat_* diab lung arthr heart cancr stroke hibp bmi "
global discovariatesprice = "age agesq female agefemale agesqfemale slfemp obese psych back wagecat_* diab lung arthr heart cancr stroke hibp bmi "

*global dissubj = " a*wlmr* "
global dissubj_s = " worklm worklm2 worklm3 "

/*
global dissubj = ""
foreach a in 0 1 2 3 4 5 6 {
foreach r in 0 1 {
foreach j in 1 2 3{
local k = 10*`a' + 5*`r' + `j'-1
global dissubj = "$dissubj w`k'"
}
}
}
*/
global dissubj = "pdc*"




* global std = "vce(bootstrap, cluster(hhid))"
do makestats_program
*set seed 10234
set seed 1
global setseed = 1


do makefine_program
do makefine_upper_program
do makem_program
do makep_program
do makem_noM_program

*************************
/* Sample Restrictions */
*************************

if $samplemarker == 1 {
/*
* LTC Sample *	
use data/hrs_using_ltc, clear
*drop nrshom5y
*rename nrshom5y_f nrshom5y
gen sampleltc = 1
replace sampleltc = 0 if nrshom == 1 
replace sampleltc = 0 if nrshom5y == . 
replace sampleltc = 0 if age < 65 
replace sampleltc = 0 if iwstat ~=1 
*replace sampleltc = 0 if homcar == 1
*replace sampleltc = 0 if hlthoth == 1 & reject_ltc == 0
*replace sampleltc = 0 if (heart == 1 | lung == 1) & reject_ltc == 0
replace sampleltc = 0 if wav >= 8
replace sampleltc = 0 if wav <= 1
egen missingsltc = rowmiss($ltccovariatesfull $ltcsubj $ltccovariatesmat )
replace sampleltc = 0 if missingsltc > 0
keep if sampleltc == 1

cap drop finegroup
gen finegroup = 1 if age >= 65 & age < 74 & reject == 0
replace finegroup = 2 if age >= 65 & age < 74 & reject == 1
replace finegroup = 3 if age >= 74 & age < 81 & reject == 0
replace finegroup = 4 if age >= 74 & age < 81 & reject == 1
replace finegroup = 5 if age >= 81 & reject == 0
replace finegroup = 6 if age >= 81 & reject == 1
replace finegroup = 7 if age >= 65 & age < 74 & reject == 2
replace finegroup = 8 if age >= 74 & age < 81 & reject == 2
replace finegroup = 9 if age >= 81 & reject == 2

cap drop finegroup_full_t
rename finegroup_full finegroup_full_t
egen finegroup_full = group(finegroup_full_t)
drop finegroup_full_t
cap drop finegroup_age*
gen finegroup_age = age - 64
replace finegroup_age = 1 if age < 65
replace finegroup_age = 26 if age > 90
gen finegroup_age_r = finegroup_age if reject == 0
replace finegroup_age_r = finegroup_age + 26 if reject == 1
replace finegroup_age_r = finegroup_age + 2*26 if reject == 2

gen reject_list = reject_ltc + 1

save data/hrs_using_ltc_sample, replace

gen sampleltcnoins = sampleltc
replace sampleltcnoins = 0 if ltcins == 1 | medicaid == 1
keep if sampleltcnoins == 1

save data/hrs_using_ltc_sample_noins, replace



clear

* Life Sample *

use data/hrs_using_life
gen samplelife = 0
drop if wav == 1
replace samplelife = 1 if age < deathgroup & iwstat == 1 
replace samplelife = 0 if liv == .
*replace samplelife = 0 if age > 65
*replace samplelife = 0 if hlthoth == 1
egen missingslife = rowmiss($lifecovariatesfull $lifesubj $lifecovariatesmat )
*egen missingslifeprice = rowmiss($lifecovariatesprice $lifesubj )
replace samplelife = 0 if missingslife > 0
*gen samplelife_full = samplelife
replace samplelife = 0 if yrsseen + age < deathgroup
*replace samplelife = 0 if hlthoth == 1 & reject_life == 0
*replace samplelife = 0 if age > 80
gen samplelifenoins = samplelife
replace samplelifenoins = 0 if lifein == 1

egen minwav_life = min(wav) if samplelife == 1 , by(hhidpn)
egen maxwav_life = max(wav) if samplelife == 1 , by(hhidpn)

gen samplelife_max = samplelife
replace samplelife_max = 0 if wav ~= maxwav_life
gen samplelife_min = samplelife
replace samplelife_min = 0 if wav ~=minwav_life

*replace samplelife = samplelife_min

egen missingslife_full = rowmiss($lifecovariatesfull $lifesubj $lifecovariatesmat)
gen samplelife_full = samplelife
replace samplelife_full = 0 if missingslife_full > 0

keep if samplelife == 1

cap drop finegroup
gen finegroup = 1 if age >= 61 & age < 71 & reject_life == 0
replace finegroup = 2 if age >= 61 & age < 71 & reject_life == 1
replace finegroup = 3 if age >= 71 & reject_life == 0
replace finegroup = 4 if age >= 71 & reject_life == 1
replace finegroup = 5 if age >= 61 & age < 71 & reject_life == 2
replace finegroup = 6 if age >= 71 & reject_life == 2


cap drop finegroup_full_t
rename finegroup_full finegroup_full_t
egen finegroup_full = group(finegroup_full_t)
drop finegroup_full_t
cap drop finegroup_age_r
gen finegroup_age_r = age - 60 if reject_life == 0
replace finegroup_age_r = age - 40 if reject_life == 1
replace finegroup_age_r = age - 20 if reject_life == 2
replace finegroup_age_r = . if age > 80
gen reject_list = reject_life + 1
gen dieprob = 1-liv

save data/hrs_using_life_sample, replace
drop if lifein == 1 
save data/hrs_using_life_sample_noins, replace

*/


* Disability Sample *

use data/hrs_using_dis
drop reject_dis
gen reject_dis = reject_dis_ni
drop if wav == 1
gen sampledis = 0
replace sampledis = 1 if work == 1 & hlthlm == 0
*replace sampledis = 1 if hlthoth == 1
replace sampledis = 0 if worklm == . 
replace sampledis = 0 if hlthlm == . 
egen missingsdis = rowmiss($discovariatesfull $dissubj hlthlm_r5f $discovariatesmat)
replace sampledis = 0 if missingsdis > 0
replace sampledis = 0 if age > 60  
replace sampledis = 0 if age < 40
replace sampledis = 0 if yrsseen < 10
*replace sampledis = 0 if hlthoth == 1 & reject_dis == 0
*replace sampledis = 0 if lung == 1 & reject_dis == 0

*egen minview = min(wav) if sampledis == 1 , by(hhidpn)
*replace sampledis = 0 if wav ~= minview
keep if sampledis == 1

cap drop finegroup
/*
gen finegroup = 1 if age < 55 & reject_dis == 0
replace finegroup = 2 if age < 55 & reject_dis == 1
replace finegroup = 3 if age >= 55 & age < 60 & reject_dis == 0
replace finegroup = 4 if age >= 55 & age < 60 & reject_dis == 1
replace finegroup = 5 if age >= 60 & reject_dis == 0
replace finegroup = 6 if age >= 60 & reject_dis == 1
replace finegroup = 7 if age < 55 & reject_dis == 2
replace finegroup = 8 if age >= 55 & age < 60 & reject_dis == 2
replace finegroup = 9 if age >= 60 & reject_dis == 2
*/
gen finegroup = 1 if age < 60 & reject_dis == 0
replace finegroup = 2 if age < 60 & reject_dis == 1
replace finegroup = 3 if age >= 60 & reject_dis == 0
replace finegroup = 4 if age >= 60 & reject_dis == 1
replace finegroup = 5 if age < 60 & reject_dis == 2
replace finegroup = 6 if age >= 60 & reject_dis == 2


cap drop finegroup_full_t
rename finegroup_full finegroup_full_t
egen finegroup_full = group(finegroup_full_t)
drop finegroup_full_t
gen reject_list = reject_dis + 1
cap drop finegroup_age_r
gen finegroup_age_r = age - 51 if reject_dis == 0 & female == 0
replace finegroup_age_r = age - 51 + 9 if reject_dis == 0 & female == 1
replace finegroup_age_r = age - 51 + 18 if reject_dis == 1 & female == 0
replace finegroup_age_r = age - 51 + 27 if reject_dis == 1 & female == 1
replace finegroup_age_r = age - 51 + 36 if reject_dis == 2 & female == 0
replace finegroup_age_r = age - 51 + 45 if reject_dis == 2 & female == 1
replace finegroup_age_r = . if age <= 51
save data/hrs_using_dis_sample, replace
clear


}



************************
/* Summary Statistics */
************************
if $sumstats == 1 {


global sample = "data/hrs_using_ltc_sample"
global subj = "selfprob5y"
global loss = "nrshom5y"
global reject = "reject_ltc"
global doins = 1
global sample_ins = "data/hrs_using_ltc_sample"
global ins = "ltcins"
global domedicaid = 1
do sumstats
matrix demo_out = demo


global sample = "data/hrs_using_dis_sample"
global subj = "worklm"
global loss = "hlthlm_r5f"
global reject = "reject_dis"
global doins = 0
global domedicaid = 0
do sumstats
matrix demo_out = demo_out , demo


global sample = "data/hrs_using_life_sample"
global subj = "dieprob"
global loss = "dead"
global reject = "reject_life"
global doins = 1
global domedicaid = 0
global sample_ins = "data/hrs_using_life_sample"
global ins = "lifein"
do sumstats
matrix demo_out = demo_out , demo
esttab matrix(demo_out) using demo_out.csv, replace


/*
/* Trim Covariates */
use data/hrs_using_ltc_sample, clear
_rmcoll $ltcagegender , forcedrop
global ltcagegender `r(varlist)'
_rmcoll $ltccovariatesprice , forcedrop
global ltccovariatesprice `r(varlist)'
_rmcoll $ltccovariatesfull , forcedrop
global ltccovariatesfull `r(varlist)'

use data/hrs_using_life_sample, clear
_rmcoll $lifeagegender , forcedrop
global lifeagegender `r(varlist)'
_rmcoll $lifecovariatesprice , forcedrop
global lifecovariatesprice `r(varlist)'
_rmcoll $lifecovariatesfull , forcedrop
global lifecovariatesfull `r(varlist)'

use data/hrs_using_dis_sample, clear
_rmcoll $disagegender , forcedrop
global disagegender `r(varlist)'
_rmcoll $discovariatesfull , forcedrop
global discovariatesfull `r(varlist)'
_rmcoll $discovariatesprice , forcedrop
global discovariatesprice `r(varlist)'
*/


/* Subjective Probability Graphs */

use data/hrs_using_ltc_sample, clear
label var selfprob5y "Subj Prob Nrs Home 5 Yrs"
hist selfprob5y if sampleltc == 1, title("Subj Prob of Nursing Home in 5 Years") name(subjprob_ltc, replace)
graph save subjprob_ltc , replace
graph export subjprob_ltc.eps, replace as(eps) name(subjprob_ltc)

use data/hrs_using_life_sample, clear
label var liv "Subj Prob Live 10-15 Years"
hist liv if samplelife == 1 , title("Subj Prob of Living 10-15 Years") name(subjprob_life, replace)
graph save subjprob_life , replace
graph export subjprob_life.eps, replace as(eps) name(subjprob_life)

use data/hrs_using_dis_sample, clear
label var worklm "Subj Prob Health Limits Work"
hist worklm if sampledis == 1 , title("Subj Prob of Health Limiting Work in Next 10 Years") name(subjprob_dis, replace)
graph save subjprob_dis , replace
graph export subjprob_dis.eps , replace as(eps) name(subjprob_dis)


/* Rejection Classification */

use data/hrs_using_ltc_sample, clear
count if sampleltc == 1 & reject_ltc == 0
matrix class_ltc = r(N)
count if sampleltc == 1 & reject_ltc == 1
matrix class_ltc = class_ltc \ r(N)
count if sampleltc == 1 & reject_ltc == 2
matrix class_ltc = class_ltc \ r(N)
count if sampleltc == 1
matrix class_ltc = class_ltc \ r(N)
tabstat nrshom5y if sampleltc == 1 & reject_ltc == 0 , save
matrix class_ltc = class_ltc \ r(StatTotal)
tabstat nrshom5y if sampleltc == 1 & reject_ltc == 1 , save
matrix class_ltc = class_ltc \ r(StatTotal)
tabstat nrshom5y if sampleltc == 1 & reject_ltc == 2 , save
matrix class_ltc = class_ltc \ r(StatTotal)
tabstat nrshom5y if sampleltc == 1 , save
matrix class_ltc = class_ltc \ r(StatTotal)

use data/hrs_using_life_sample, clear
count if samplelife == 1 & reject_life == 0
matrix class_life = r(N) 
count if samplelife == 1 & reject_life == 1
matrix class_life = class_life \ r(N)
count if samplelife == 1 & reject_life == 2
matrix class_life = class_life \ r(N)
count if samplelife == 1
matrix class_life = class_life \ r(N)
tabstat dead if samplelife == 1 & reject_life == 0 , save
matrix class_life = class_life \ r(StatTotal)
tabstat dead if samplelife == 1 & reject_life == 1 , save
matrix class_life = class_life \ r(StatTotal)
tabstat dead if samplelife == 1 & reject_life == 2 , save
matrix class_life = class_life \ r(StatTotal)
tabstat dead if samplelife == 1 , save
matrix class_life = class_life \ r(StatTotal)

use data/hrs_using_dis_sample, clear
count if sampledis == 1 & reject_dis == 0
matrix class_dis = r(N)
count if sampledis == 1 & reject_dis == 1
matrix class_dis = class_dis \ r(N)
count if sampledis == 1 & reject_dis == 2
matrix class_dis = class_dis \ r(N)
count if sampledis == 1
matrix class_dis = class_dis \ r(N)
tabstat hlthlm_r5f if sampledis == 1 & reject_dis == 0 , save
matrix class_dis = class_dis \ r(StatTotal)
tabstat hlthlm_r5f if sampledis == 1 & reject_dis == 1 , save
matrix class_dis = class_dis \ r(StatTotal)
tabstat hlthlm_r5f if sampledis == 1 & reject_dis == 2 , save
matrix class_dis = class_dis \ r(StatTotal)
tabstat hlthlm_r5f if sampledis == 1, save
matrix class_dis = class_dis \ r(StatTotal)

matrix class_out = class_ltc , class_dis , class_life


* Add insurance coverage
use data/hrs_using_ltc_sample, clear
tabstat ltcins , by(reject_ltc) save
matrix ins_ltc = r(Stat1)\r(Stat2)\r(Stat3)\r(StatTotal)
use data/hrs_using_life_sample, clear
tabstat lifein , by(reject_life) save
matrix ins_life = r(Stat1)\r(Stat2)\r(Stat3)\r(StatTotal)
matrix ins_dis = J(4,1,.)
matrix ins_out = ins_ltc,ins_dis,ins_life
matrix class_out = class_out \ ins_out

esttab matrix(class_out) using class_out.csv, replace


/* Partition Summary Stats */

use data/hrs_using_ltc_sample, clear
tab finegroup, matcell(part_ltc)
matrix part_ltc = part_ltc \ .
use data/hrs_using_dis_sample, clear
tab finegroup, matcell(part_dis)
matrix part_dis = part_dis \ .
use data/hrs_using_life_sample, clear
tab finegroup, matcell(part_life)
matrix part_out = part_ltc \ part_dis \ part_life
esttab matrix(part_out) using part_out.csv, replace


clear


/*


use data/hrs_using_ltc_sample
global sample = "sampleltc == 1"
global ins = "ltcins"
global reject = "reject_ltc"
do sumstatsltc
matrix demoltc = demo
global sample = "sampleltcnoins == 1"
do sumstatsltc
matrix demoltc = demoltc , demo
esttab matrix(demoltc) using demoltc.csv, replace


use data/hrs_using_life_sample, clear
global reject = "reject_life"
global sample = "samplelife == 1"
global ins = "lifein"
do sumstatslife
matrix demolife = demo
matrix list demolife
esttab matrix(demolife) using demolife.csv, replace


use data/hrs_using_dis_sample, clear
global sample = "sampledis == 1"
global reject = "reject_dis"
global ins = "*****"
do sumstatsdis
matrix demodis = demo
matrix list demodis
esttab matrix(demodis) using demodis.csv, replace

*/

do makerejtable
matrix rej_out = rej_ltc \ . \ rej_dis \ . \ rej_life
esttab matrix(rej_out) using rej_out.csv, replace

}

if $analysis == 1 {
*****************************
/*       M(X) Table        */
*****************************

/* LTC */

use data/hrs_using_ltc_sample, clear

global outcome = "nrshom5y"
global sample = "sampleltc == 1"
global subj = "$ltcsubj"
global finelist = "reject_list"
global cov = "$ltcagegender"
global reject = "reject_ltc"
global aglist = "finegroup_age_r"
global rollup = "finegroup_age_r"
global graphs = 0
global probit = 1 


_rmcoll $cov , forcedrop
global cov_use `r(varlist)'

_rmcoll $subj , forcedrop
global subj_use `r(varlist)'


makem
matrix M_t = M 
matrix F_t = [F , .]
matrix S_t = [.,.,.,.]


if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsltc_n_all, replace) : makem
matrix temp = vecdiag(e(V))
mata: temp = sqrt(st_matrix("temp"))
use data/bsltc_f_all, clear
gen p = (_b_c4 <= 0)
tabstat p , save stats(mean)
matrix p = r(StatTotal)
matrix F_t[1,4] = p[1,1]
mata: st_matrix("S_t",temp)
restore
}



matrix Mltc = [M_t \ S_t \F_t ]'
matrix Mltc = vec(Mltc')




global cov = "$ltccovariatesprice"
global subj = "$ltcsubj"
global rollup = "finegroup_age_r"

_rmcoll $cov , forcedrop
global cov_use `r(varlist)'

_rmcoll $subj , forcedrop
global subj_use `r(varlist)'

global graphs = 1


makem


if $graphs {


kdensity r_p_1 , nograph gen(x_1 r_1) n(50) 
kdensity r_p_2 , nograph gen(x_2 r_2) n(50)


label var r_1 "No Reject"
label var r_2 "Reject"



#delimit ;
twoway (line r_1 x_1 if x_1 > -.1 & x_1 < .1, lpattern(dash) lwidth(thick) lcolor(dknavy)) (line r_2 x_2  if x_2 > -.1 & x_2 < .1, lpattern(solid) lwidth(thick) lcolor(dknavy)),
	name(res_ltc, replace) title("Estimated Residual Private Info")
	subtitle("LTC") 
	ytitle("Density")
	xtitle("Estimated Residual Private Information")
	;
graph save res_ltc, replace; 
graph export res_ltc.eps , replace name(res_ltc) as(eps);

#delimit cr

 
}





matrix M_t = M[1,1..4]
matrix F_t = [F,.]
matrix S_t = [.,.,.,.]

if $bootstrap {
matrix M_temp_a = M[1,5...]
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsltc_p_all, replace) : makem
matrix temp = vecdiag(e(V))
mata: temp = sqrt(st_matrix("temp"))

if $graphs {
matrix ci = e(ci_bc)
matrix ci_temp = ci[1..2,5...]
matrix M_graph_ci = M_temp_a' , ci_temp'
local ages = 26
matrix M_graph_ci0 = M_graph_ci[1..26,1...]
matrix M_graph_ci1 = M_graph_ci[27..52,1...]
matrix M_graph_ci2 = M_graph_ci[53..78,1...]

svmat M_graph_ci0 , names("M_graph_ci0")
svmat M_graph_ci1 , names("M_graph_ci1")
svmat M_graph_ci2 , names("M_graph_ci2")

rename M_graph_ci01 M_graph_0est
rename M_graph_ci02 M_graph_05
rename M_graph_ci03 M_graph_095
rename M_graph_ci11 M_graph_1est
rename M_graph_ci12 M_graph_15
rename M_graph_ci13 M_graph_195
rename M_graph_ci21 M_graph_2est
rename M_graph_ci22 M_graph_25
rename M_graph_ci23 M_graph_295

gen xlab = _n if _n < 27

label var M_graph_0est "No Reject"
label var M_graph_05 "2.5"
label var M_graph_095 "97.5"
label var M_graph_1est "Reject"
label var M_graph_15 "2.5"
label var M_graph_195 "97.5"
label var M_graph_2est "Uncertain"
label var M_graph_25 "2.5"
label var M_graph_295 "97.5"
label var xlab "Age"
gen age_n = _n+64 if _n < 27

keep M_graph_* age_* 
save data/fig3ltc, replace

}
use data/bsltc_p_all, clear
gen p = (_b_c4 <= 0)
tabstat p , save stats(mean)
matrix p = r(StatTotal)
matrix F_t[1,4] = p[1,1]
mata: st_matrix("S_t",temp)
matrix S_t = S_t[1,1..4]
restore
}



matrix Mltc_t = [M_t \ S_t \F_t ]'
matrix Mltc = Mltc , vec(Mltc_t')



global graphs = 0
global cov = "$ltccovariatesfull"
global probit = 0

_rmcoll $cov , forcedrop
global cov_use `r(varlist)'

_rmcoll $subj , forcedrop
global subj_use `r(varlist)'


makem
matrix M_t = M
matrix F_t = [F,.]
matrix S_t = [.,.,.,.]

if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsltc_f_all, replace): makem
matrix temp = vecdiag(e(V))
mata: temp = sqrt(st_matrix("temp"))
use data/bsltc_f_all, clear
gen p = (_b_c4 <= 0)
tabstat p , save stats(mean)
matrix p = r(StatTotal)
matrix F_t[1,4] = p[1,1]
mata: st_matrix("S_t",temp)
restore
}
matrix Mltc_t = [M_t \ S_t \F_t ]'
matrix Mltc = Mltc , vec(Mltc_t')


global graphs = 0



/* Disability */

use data/hrs_using_dis_sample, clear
drop if wav == 1

global outcome = "hlthlm_r5f"
global subj = "$dissubj"
global sample = "sampledis == 1"
global finelist = "reject_list"
global cov = "$disagegender"
global reject = "reject_dis"
global rollup = "finegroup_age_r"
global aglist = "finegroup_age_r"
global probit = 1 

_rmcoll $cov , forcedrop
global cov_use `r(varlist)'

_rmcoll $subj , forcedrop
global subj_use `r(varlist)'


makem
matrix M_t = M
matrix F_t = [F,.]
matrix S_t = [.,.,.,.]

if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsdis_n_all, replace): makem
matrix temp = vecdiag(e(V))
mata: temp = sqrt(st_matrix("temp"))
use data/bsdis_n_all, clear
gen p = (_b_c4 <= 0)
tabstat p , save stats(mean)
matrix p = r(StatTotal)
matrix F_t[1,4] = p[1,1]
mata: st_matrix("S_t",temp)
restore
}

matrix Mdis = [M_t \ S_t \F_t ]'
matrix Mdis = vec(Mdis')


global cov = "$discovariatesprice"
global subj = "$dissubj"
global rollup = "finegroup_age_r"

_rmcoll $cov , forcedrop
global cov_use `r(varlist)'

_rmcoll $subj , forcedrop
global subj_use `r(varlist)'

global graphs = 1 

makem



if $graphs {


kdensity r_p_1 , nograph gen(x_1 r_1) n(50) 
kdensity r_p_2 , nograph gen(x_2 r_2) n(50)


label var r_1 "No Reject"
label var r_2 "Reject"



#delimit ;
twoway (line r_1 x_1 if x_1 > -.2 & x_1 < .2, lpattern(dash) lwidth(thick)  lcolor(dknavy)) (line r_2 x_2  if x_2 > -.2 & x_2 < .2, lpattern(solid) lwidth(thick) lcolor(dknavy)),
	name(res_dis, replace) title("Estimated Residual Private Info")
	subtitle("Disability") 
	ytitle("Density")
	xtitle("Estimated Residual Private Information")
	;
graph save res_dis, replace; 
graph export res_dis.eps , replace as(eps) name(res_dis);

#delimit cr
 
}



matrix M_t = M[1,1..4]
matrix F_t = [F,.]
matrix S_t = [.,.,.,.]

if $bootstrap {
matrix M_temp_a = M[1,5...]
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsdis_p_all, replace): makem
matrix temp = vecdiag(e(V))
mata: temp = sqrt(st_matrix("temp"))


if $graphs {
matrix ci = e(ci_bc)
matrix ci_temp = ci[1..2,5...]
matrix M_graph_ci = M_temp_a' , ci_temp'
local ages = 26
matrix M_graph_ci0m = M_graph_ci[1..9,1...]
matrix M_graph_ci0f = M_graph_ci[10..18,1...]
matrix M_graph_ci1m = M_graph_ci[19..27,1...]
matrix M_graph_ci1f = M_graph_ci[28..36,1...]
matrix M_graph_ci2m = M_graph_ci[37..45,1...]
matrix M_graph_ci2f = M_graph_ci[46..54,1...]

svmat M_graph_ci0m , names("M_graph_ci0m")
svmat M_graph_ci1m , names("M_graph_ci1m")
svmat M_graph_ci2m , names("M_graph_ci2m")
svmat M_graph_ci0f , names("M_graph_ci0f")
svmat M_graph_ci1f , names("M_graph_ci1f")
svmat M_graph_ci2f , names("M_graph_ci2f")

rename M_graph_ci0m1 M_graph_0mest
rename M_graph_ci0m2 M_graph_0m5
rename M_graph_ci0m3 M_graph_0m95
rename M_graph_ci1m1 M_graph_1mest
rename M_graph_ci1m2 M_graph_1m5
rename M_graph_ci1m3 M_graph_1m95
rename M_graph_ci2m1 M_graph_2mest
rename M_graph_ci2m2 M_graph_2m5
rename M_graph_ci2m3 M_graph_2m95
rename M_graph_ci0f1 M_graph_0fest
rename M_graph_ci0f2 M_graph_0f5
rename M_graph_ci0f3 M_graph_0f95
rename M_graph_ci1f1 M_graph_1fest
rename M_graph_ci1f2 M_graph_1f5
rename M_graph_ci1f3 M_graph_1f95
rename M_graph_ci2f1 M_graph_2fest
rename M_graph_ci2f2 M_graph_2f5
rename M_graph_ci2f3 M_graph_2f95

gen xlab = _n if _n < 27

label var M_graph_0mest "No Reject"
label var M_graph_0m5 "2.5"
label var M_graph_0m95 "97.5"
label var M_graph_1mest "Reject"
label var M_graph_1m5 "2.5"
label var M_graph_1m95 "97.5"
label var M_graph_2mest "Uncertain"
label var M_graph_2m5 "2.5"
label var M_graph_2m95 "97.5"
label var M_graph_0fest "No Reject"
label var M_graph_0f5 "2.5"
label var M_graph_0f95 "97.5"
label var M_graph_1fest "Reject"
label var M_graph_1f5 "2.5"
label var M_graph_1f95 "97.5"
label var M_graph_2fest "Uncertain"
label var M_graph_2f5 "2.5"
label var M_graph_2f95 "97.5"
label var xlab "Age"
gen age_n = _n+50 if _n < 11

keep M_graph_* age_* 
save data/fig3dis, replace



}
use data/bsdis_p_all, clear
gen p = (_b_c4 <= 0)
tabstat p , save stats(mean)
matrix p = r(StatTotal)
matrix F_t[1,4] = p[1,1]
mata: st_matrix("S_t",temp)
matrix S_t = S_t[1,1..4]
restore
}
matrix Mdis_t = [M_t \ S_t \F_t ]'
matrix Mdis = Mdis , vec(Mdis_t')
global graphs = 0


global cov = "$discovariatesfull"
global subj = "$dissubj"
global probit = 0

_rmcoll $cov , forcedrop
global cov_use `r(varlist)'

_rmcoll $subj , forcedrop
global subj_use `r(varlist)'


makem
matrix M_t = M
matrix F_t = [F,.]
matrix S_t = [.,.,.,.]

if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsdis_f_all, replace): makem
matrix temp = vecdiag(e(V))
mata: temp = sqrt(st_matrix("temp"))
use data/bsdis_f_all, clear
gen p = (_b_c4 <= 0)
tabstat p , save stats(mean)
matrix p = r(StatTotal)
matrix F_t[1,4] = p[1,1]
mata: st_matrix("S_t",temp)
restore
}
matrix Mdis_t = [M_t \ S_t \F_t ]'
matrix Mdis = Mdis , vec(Mdis_t')




/* Life */

use data/hrs_using_life_sample, clear
drop if wav == 1

global outcome = "dead"
global subj = "$lifesubj"
global sample = "samplelife == 1"
global finelist = "reject_list"
global cov = "$lifeagegender"
global reject = "reject_life"
global aglist = "finegroup_age_r"
global rollup = "finegroup_age_r"
global graphs = 0
global probit = 1 

_rmcoll $cov , forcedrop
global cov_use `r(varlist)'

_rmcoll $subj , forcedrop
global subj_use `r(varlist)'


makem
matrix M_t = M
matrix F_t = [F,.]
matrix S_t = [.,.,.,.]

if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bslife_n_all, replace): makem
matrix temp = vecdiag(e(V))
mata: temp = sqrt(st_matrix("temp"))
use data/bslife_n_all, clear
gen p = (_b_c4 <= 0)
tabstat p , save stats(mean)
matrix p = r(StatTotal)
matrix F_t[1,4] = p[1,1]
mata: st_matrix("S_t",temp)
restore
}

matrix Mlife = [M_t \ S_t \F_t ]'
matrix Mlife = vec(Mlife')


global cov = "$lifecovariatesprice"
global subj = "$lifesubj"
global rollup = "finegroup_age_r"


_rmcoll $cov , forcedrop
global cov_use `r(varlist)'

_rmcoll $subj , forcedrop
global subj_use `r(varlist)'

global graphs =1 

makem


if $graphs {


kdensity r_p_1 , nograph gen(x_1 r_1) n(50) 
kdensity r_p_2 , nograph gen(x_2 r_2) n(50)


label var r_1 "No Reject"
label var r_2 "Reject"



#delimit ;
twoway (line r_1 x_1 if x_1 > -.2 & x_1 < .2, lpattern(dash) lwidth(thick) lcolor(dknavy)) (line r_2 x_2  if x_2 > -.2 & x_2 < .2, lpattern(solid) lwidth(thick) lcolor(dknavy)),
	name(res_life, replace) title("Estimated Residual Private Info")
	subtitle("Life") 
	ytitle("Density")
	xtitle("Estimated Residual Private Information")
	;
graph save res_life, replace; 
#delimit cr
graph export res_life.eps , replace as(eps) name(res_life)
 
}



matrix M_t = M[1,1..4]
matrix F_t = [F,.]
matrix S_t = [.,.,.,.]

if $bootstrap {
preserve
matrix M_temp_a = M[1,5...]
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bslife_p_all, replace): makem
matrix temp = vecdiag(e(V))
mata: temp = sqrt(st_matrix("temp"))

if $graphs {
matrix ci = e(ci_bc)
matrix ci_temp = ci[1..2,5...]
matrix M_graph_ci = M_temp_a' , ci_temp'
local ages = 26
matrix M_graph_ci0 = M_graph_ci[1..20,1...]
matrix M_graph_ci1 = M_graph_ci[21..40,1...]
matrix M_graph_ci2 = M_graph_ci[41..60,1...]

svmat M_graph_ci0 , names("M_graph_ci0")
svmat M_graph_ci1 , names("M_graph_ci1")
svmat M_graph_ci2 , names("M_graph_ci2")

rename M_graph_ci01 M_graph_0est
rename M_graph_ci02 M_graph_05
rename M_graph_ci03 M_graph_095
rename M_graph_ci11 M_graph_1est
rename M_graph_ci12 M_graph_15
rename M_graph_ci13 M_graph_195
rename M_graph_ci21 M_graph_2est
rename M_graph_ci22 M_graph_25
rename M_graph_ci23 M_graph_295

gen xlab = _n if _n < 27

label var M_graph_0est "No Reject"
label var M_graph_05 "2.5"
label var M_graph_095 "97.5"
label var M_graph_1est "Reject"
label var M_graph_15 "2.5"
label var M_graph_195 "97.5"
label var M_graph_2est "Uncertain"
label var M_graph_25 "2.5"
label var M_graph_295 "97.5"
label var xlab "Age"
gen age_n = _n+60 if _n < 21


keep M_graph_* age_* 
save data/fig3life, replace

}
use data/bslife_p_all, clear
gen p = (_b_c4 <= 0)
tabstat p , save stats(mean)
matrix p = r(StatTotal)
matrix F_t[1,4] = p[1,1]
mata: st_matrix("S_t",temp)
matrix S_t = S_t[1,1..4]
restore
}

matrix Mlife_t = [M_t \ S_t \F_t ]'
matrix Mlife = Mlife , vec(Mlife_t')
global graphs = 0


global sample = "samplelife == 1"
global cov = "$lifecovariatesfull"
global probit = 0

_rmcoll $cov , forcedrop
global cov_use `r(varlist)'

_rmcoll $subj , forcedrop
global subj_use `r(varlist)'


makem


matrix M_t = M
matrix F_t = [F,.]
matrix S_t = [.,.,.,.]

if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bslife_f_all, replace): makem
matrix temp = vecdiag(e(V))
mata: temp = sqrt(st_matrix("temp"))
use data/bslife_f_all, clear
gen p = (_b_c4 <= 0)
tabstat p , save stats(mean)
matrix p = r(StatTotal)
matrix F_t[1,4] = p[1,1]
mata: st_matrix("S_t",temp)
restore
}

matrix Mlife_t = [M_t \ S_t \F_t ]'
matrix Mlife = Mlife , vec(Mlife_t')

matrix M_out = Mltc , Mdis , Mlife
esttab matrix(M_out) using M_out.csv, replace

esttab matrix(Mlife) using M_life.csv, replace


* Construct cross-specification p-value

if $bootstrap {
preserve
use data/bsltc_f_all, clear
rename _b_c2 full_reject
mkmat full_reject
use data/bsltc_n_all, clear
rename _b_c1 agegennr
mkmat agegennr
clear
svmat agegennr, names(col)
svmat full_reject, names(col)
gen p = (full_reject < agegennr)
tabstat p , save stats(mean)
matrix cross_p_ltc = r(StatTotal)
restore

preserve
use data/bsdis_f_all, clear
rename _b_c2 full_reject
mkmat full_reject
use data/bsdis_n_all, clear
rename _b_c1 agegennr
mkmat agegennr
clear
svmat agegennr, names(col)
svmat full_reject, names(col)
gen p = (full_reject < agegennr)
tabstat p , save stats(mean)
matrix cross_p_dis = r(StatTotal)
restore

preserve
use data/bslife_f_all, clear
rename _b_c2 full_reject
mkmat full_reject
use data/bslife_n_all, clear
rename _b_c1 agegennr
mkmat agegennr
clear
svmat agegennr, names(col)
svmat full_reject, names(col)
gen p = (full_reject < agegennr)
tabstat p , save stats(mean)
matrix cross_p_life = r(StatTotal)
restore

matrix cross_p = [cross_p_ltc , cross_p_dis , cross_p_life]
esttab matrix(cross_p) using cross_p.csv , replace


}


* LTC No Rejection Conditions Graph

use data/hrs_using_ltc_sample, clear
keep if reject == 0
cap drop reject_list
gen reject_list = reject_ltc + 1 

global outcome = "nrshom5y"
global sample = "sampleltc == 1"
global subj = "$ltcsubj"
global finelist = "reject_list"
global cov = "$ltcagegender"
global reject = "reject_ltc"
global aglist = "finegroup_age_r"
global graphs = 0
global probit = 1 
global cov = "$ltccovariatesprice"
global subj = "$ltcsubj"
global rollup = "finegroup_age_r"

_rmcoll $cov , forcedrop
global cov_use `r(varlist)'

_rmcoll $subj , forcedrop
global subj_use `r(varlist)'

global graphs = 1


makem_noM
matrix M_temp_a = M[1,3...]

if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsltc_p_all, replace) : makem_noM


if $graphs {
matrix ci = e(ci_bc)
matrix ci_temp = ci[1..2,3...]
matrix M_graph_ci = M_temp_a' , ci_temp'
local ages = 26
matrix M_graph_ci0 = M_graph_ci[1..26,1...]

svmat M_graph_ci0 , names("M_graph_ci0")


rename M_graph_ci01 M_graph_0est
rename M_graph_ci02 M_graph_05
rename M_graph_ci03 M_graph_095

gen xlab = _n if _n < 27

label var M_graph_0est "No Reject Conditions"
label var M_graph_05 "2.5"
label var M_graph_095 "97.5"
gen age_n = _n+64 if _n < 26
label var age_n "Age"

keep M_graph_* age_* 
save data/fig3ltcnorej, replace


}
restore
}





* Make graphs 

do makefig3


* Subgroup Analysis

*do subgroup
*esttab matrix(Mltc_age) using Mltc_age.csv, replace

* With Insurance

do addins
esttab matrix(Mltc_noins) using Mltc_noins.csv, replace
do addnoins_life
matrix M_robust = Mltc_noins , Mlife_noins
esttab matrix(M_robust) using M_robust.csv, replace

* With Cancer Controls

do withcancer
esttab matrix(Mlifecncr) using Mlifecncr.csv, replace






/*
*****************************
/*       Partitions        */
*****************************

/* LTC */

use data/hrs_using_ltc_sample, clear

global outcome = "nrshom5y"
global sample = "sampleltc == 1"
global cov = "$ltccovariatesprice"
*global cov = ""
global subj = "$ltcsubj"
global finelist = "finegroup"
global reject = "reject_ltc"
global aglist = "finegroup_age_r"
_rmcoll $cov , forcedrop
global cov_use `r(varlist)'

_rmcoll $subj , forcedrop
global subj_use `r(varlist)'

makep

matrix M_ltc = M'
matrix reject_track_ltc = reject_track'
matrix reject_N_ltc = reject_N'
matrix mean_risk_ltc = mean_risk'

if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/ltc_part_5, replace): makep
matrix temp = e(ci_percentile)
matrix M_ltc = M_ltc , temp'
restore


svmat M_ltc , names("M_ltc")
svmat reject_track_ltc , names("reject_track_ltc")
svmat reject_N_ltc , names("reject_N_ltc")
svmat mean_risk_ltc , names("mean_risk_ltc")
rename M_ltc1 M_ltc
rename M_ltc2 M_ltc_l
rename M_ltc3 M_ltc_u
rename reject_track_ltc1 reject_track_ltc
rename reject_N_ltc1 reject_N_ltc
rename mean_risk_ltc1 mean_risk_ltc

gen xlab = _n if _n < 13

label var M_ltc "M"
label var M_ltc_l "2.5"
label var M_ltc_u "97.5"
preserve
keep M_ltc xlab M_ltc_u M_ltc_l xlab 
save data/ltc_graph_5, replace
restore
}


global std = ""
makem



if $bootstrap {
preserve
clear
use data/ltc_graph_5
label var xlab ""

matrix F_pval_ltc = F'
svmat F_pval_ltc , names("f_p")
replace M_ltc_l = 0 if f_p1 > .05


#delimit ;
twoway (scatter M_ltc xlab, msize(huge) mcolor(dknavy)) (rcap M_ltc_u M_ltc_l xlab, lpattern(dash) lcolor(dknavy)) if _n < 7 ,
	xlabel(1 "No Reject" 2 "Reject" 3 "No Reject" 4 "Reject" 5 "Rej (NC)" 6 "Rej (C)")
	name(predictmarketgroup_ltc, replace) title("Subgroup Test - LTC") 
	subtitle("By Market (Age Bins); Excluding Uncertain Classification") 
	ytitle("E[M(X)]")
	xline(2.5, lcolor(gs12)) xline(4.5, lcolor(gs12)) xline(6.5, lcolor(gs12))
	text(.075 1.6 "Age 65-73")
	text(.075 3.6 "Age 74-80")
	text(.075 5.6 "Age 81+")
	xtitle("")
	;
graph save predictmarketgroup_ltc, replace; 

#delimit ;
twoway (scatter M_ltc xlab, msize(huge) mcolor(dknavy)) (rcap M_ltc_u M_ltc_l xlab, lpattern(dash) lcolor(dknavy)) if _n < 5 ,
	xlabel(1 "No Reject" 2 "Reject" 3 "No Reject" 4 "Reject" )
	name(predictmarketgroup_ltc_n80, replace) title("Subgroup Test - LTC") 
	subtitle("By Market (Age Bins); Excluding Uncertain Classification") 
	ytitle("E[M(X)]")
	xline(2.5, lcolor(gs12)) xline(4.5, lcolor(gs12))
	text(.05 1.8 "Age 65-73")
	text(.05 3.6 "Age 74-80")
	xtitle("")
	;
graph save predictmarketgroup_ltc_n80, replace; 

/*
twoway (scatter M_ltc xlab) (rcap M_ltc_u M_ltc_l xlab) if _n < 13 ,
	xlabel(1 "65-70, NR" 2 "65-70, R" 3 "71-75, NR" 4 "71-75 R" 5 "76-80 NR" 6 "76-80 R" 7 "80+ NC" 8 "80+ C" 9 "65-70 U" 10 "71-75 U" 11 "76-80 U" 12 "80+ U")
	name(predictmarketgroup_ltc_u, replace) title("Subgroup Test - LTC") 
	subtitle("By Market (5yr Age Bins); Including Uncertain Classification") 
	ytitle("M(X)")
	xline(2.5) xline(4.5) xline(6.5) xline(8.5)
	text(.07 1.6 "Age 65-70")
	text(.07 3.6 "Age 71-75")
	text(.07 5.6 "Age 76-80")
	text(.07 7.6 "Age 81+")
	xtitle("")
	;
	
graph save predictmarketgroup_ltc_u, replace ;
	*/
	
 
#delimit cr

 
restore
}
/*

*twoway (scatter M_ltc xlab) (rcap M_ltc_u M_ltc_l xlab) if _n < 9 , xlabel(1 "No Rej" 2 "Rej" 3 "No Rej" 4 "Rej" 5 "No Rej" 6 "Rej" 7 "Rej (NC)" 8 "Rej (C)") name(predictmarketgroup_ltc, replace) title("Fine Test - LTC")  subtitle("By Market (5yr Age Bins); Excluding Uncertain Classification")  ytitle("M(X)") xline(2.5) xline(4.5) xline(6.5) text(.075 1.6 "Age 65-70") text(.075 3.6 "Age 71-75") text(.075 5.6 "Age 76-80") text(.075 7.6 "Age 81+") xtitle("")

if $bootstrap == 0 {

svmat M_ltc , names("M_ltc")
svmat reject_track_ltc , names("reject_track_ltc")
svmat reject_N_ltc , names("reject_N_ltc")
svmat mean_risk_ltc , names("mean_risk_ltc")
rename M_ltc1 M_ltc
rename reject_track_ltc1 reject_track_ltc
rename reject_N_ltc1 reject_N_ltc
rename mean_risk_ltc1 mean_risk_ltc

twoway (scatter reject_track_ltc M_ltc) if reject_track_ltc < 2 , name(predictmarketgroup_ltc, replace) title("Market Shutdown versus E[M(X)] - LTC") subtitle("By Market (5yr Age Bins); Excluding Uncertain Classification") xtitle("E[M(X)]") ytitle("Indicator of Market Shutdown")
graph save predictmarket_ltc, replace

reg reject_track_ltc M_ltc 
estimates store regtest_ltc

twoway scatter reject_track_ltc M_ltc if  M_ltc > 0 , name(predictmarketgroup_ltc_wunc, replace) title("Market Shutdown versus E[M(X)] - LTC") subtitle("By Market (5yr Age Bins) ") xtitle("E[M(X)]") ytitle("Rejection Classification")
graph save predictmarket_ltc_wunc, replace

}
*/
* Age Test *
/*

global cov = "$ltccovariatesprice"
global subj = "$ltcsubj"
global finelist = "finegroup_age_r"
global reject = "reject_ltc"
global sample = "sampleltc == 1 & age <= 90"
global aglist = "finegroup_age_r"

makep

matrix M_ltc = M'
matrix M_ltc0 = M[1,1..26]'
matrix M_ltc1 = M[1,27..52]'
matrix M_ltc2 = M[1,53..78]'


if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/ltc_part_1, replace): makep
matrix temp = e(ci_percentile)
matrix M_ltc = M_ltc , temp'
restore

matrix M_ltc0ci = M_ltc[1..26,2..3]
matrix M_ltc1ci = M_ltc[27..52,2..3]
matrix M_ltc2ci = M_ltc[53..78,2..3]

matrix reject_track_ltc = reject_track'
matrix reject_N_ltc = reject_N'
matrix mean_risk_ltc = mean_risk'
svmat M_ltc0 , names("M_ltc_age0")
svmat M_ltc1 , names("M_ltc_age1")
svmat M_ltc2 , names("M_ltc_age2")
svmat M_ltc0ci , names("M_ltc_age0ci")
svmat M_ltc1ci , names("M_ltc_age1ci")
svmat M_ltc2ci , names("M_ltc_age2ci")

rename M_ltc_age01 M_ltc_age0
rename M_ltc_age11 M_ltc_age1
rename M_ltc_age21 M_ltc_age2


gen age_n = _n+64 if _n < 26
preserve
keep M_ltc* age_n
save data/ltc_graph_1, replace
restore
}

if $bootstrap == 0 {
matrix reject_track_ltc = reject_track'
matrix reject_N_ltc = reject_N'
matrix mean_risk_ltc = mean_risk'
svmat M_ltc0 , names("M_ltc_age0")
svmat M_ltc1 , names("M_ltc_age1")
svmat M_ltc2 , names("M_ltc_age2")

rename M_ltc_age01 M_ltc_age0
rename M_ltc_age11 M_ltc_age1
rename M_ltc_age21 M_ltc_age2

gen age_n = _n+64 if _n < 26
}
/*
global sample = "sampleltc == 1 & reject == 1 & age <= 90"

makep

matrix M_ltc = M'
matrix reject_track_ltc = reject_track'
matrix reject_N_ltc = reject_N'
matrix mean_risk_ltc = mean_risk'
svmat M_ltc , names("M_ltc_age")
svmat reject_track_ltc , names("reject_track_ltc_age")
svmat reject_N_ltc , names("reject_N_ltc_age")
svmat mean_risk_ltc , names("mean_risk_ltc_age")
rename M_ltc_age1 M_ltc_age_r
rename reject_track_ltc_age1 reject_track_ltc_age_r
rename reject_N_ltc_age1 reject_N_ltc_age_r
rename mean_risk_ltc_age1 mean_risk_ltc_age_r
gen age_n_r = _n+64 if _n < 26
*/

label var M_ltc_age0 "No Rej Cond"
label var M_ltc_age1 "Reject Condition"


if $bootstrap {
preserve
clear
use data/ltc_graph_1

label var M_ltc_age0 "No Reject Conditions"
label var M_ltc_age1 "Reject Conditions"
label var M_ltc_age2 "Uncertain"
label var M_ltc_age0ci1 "2.5"
label var M_ltc_age0ci2 "97.5"
label var M_ltc_age1ci1 "2.5"
label var M_ltc_age1ci2 "97.5"
label var M_ltc_age2ci1 "2.5"
label var M_ltc_age2ci2 "97.5"

gen M_ltc_age0ci2_c = M_ltc_age0ci2
replace M_ltc_age0ci2_c = .04 if M_ltc_age0ci2 > .04 & M_ltc_age0ci2 ~=.
label var M_ltc_age0ci2_c "97.5"



#delimit ;

twoway (scatter M_ltc_age1 age_n, mcolor(cranberry)) 
	(rcap M_ltc_age1ci2 M_ltc_age1ci1 age_n , lcolor(cranberry)) 
	(scatter M_ltc_age0 age_n , mcolor(dknavy)) 
	(rcap M_ltc_age0ci2 M_ltc_age0ci1 age_n , lcolor(dknavy)), 
	name(predictLTCagetest_ci, replace) 
	title("E[M(X)|Age] by Age - LTC") 
	xtitle("Age") 
	ytitle("E[M(X)|Age]")
	;
graph save predictLTCagetest_ci , replace ; 

twoway (scatter M_ltc_age0 age_n, mcolor(dknavy) msize(vlarge))
	(rcap M_ltc_age0ci2_c M_ltc_age0ci1 age_n , lpattern(dash) lcolor(dknavy) ),
	name(predictLTCagetest_nr_ci, replace) 
	title("E[M(X)|Age] by Age - LTC") 
	subtitle("Restricted to No Rejection Conditions") 
	xtitle("Age") ytitle("E[M(X)|Age]") 
	note("Note: CI censored above at 0.04 for display")
	xline(80.5, lpattern(dash) lcolor(cranberry))
	text(.035 78 "Not Rejected")
	text(.002 85 "Rejected Based on Age")
	;
graph save predictLTCagetest_nr_ci , replace ;
*twoway (scatter M_ltc_age0 age_n) (rcap M_ltc_age0ci2_c M_ltc_age0ci1 age_n ) , name(predictLTCagetest_nr_ci, replace) title("E[M(X)|Age] by Age - LTC") subtitle("Restricted to No Rejection Conditions") xtitle("Age") ytitle("E[M(X)|Age]") note("Note: CI censored above at 0.05") ;

#delimit cr


restore

}
/*
if $bootstrap == 0 {
twoway (scatter M_ltc_age1 age_n, mcolor(cranberry)) (scatter M_ltc_age0 age_n , mcolor(dknavy)), name(predictLTCagetest, replace) title("E[M(X)|Age] by Age - LTC") xtitle("Age") ytitle("E[M(X)|Age]")
graph save predictLTCagetest , replace
twoway (scatter M_ltc_age0 age_n) , name(predictLTCagetest_nr, replace) title("E[M(X)|Age] by Age - LTC") subtitle("Restricted to No Rejection Conditions") xtitle("Age") ytitle("E[M(X)|Age]")
graph save predictLTCagetest_nr , replace
}



*/


*/
/* Disability */

use data/hrs_using_dis_sample, clear
drop if wav == 1

global outcome = "hlthlm_r5f"
global subj = "$dissubj"
global sample = "sampledis == 1"
global finelist = "finegroup"
global cov = "$discovariatesprice"
global reject = "reject_dis"
global aglist = "finegroup_age_r"


_rmcoll $cov , forcedrop
global cov_use `r(varlist)'

_rmcoll $subj , forcedrop
global subj_use `r(varlist)'


makep
matrix M_dis = M'
matrix reject_track_dis = reject_track'
matrix reject_N_dis = reject_N'
matrix mean_risk_dis = mean_risk'


if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/dis_part_5, replace): makep
matrix temp = e(ci_percentile)
matrix M_dis = M_dis , temp'
restore


svmat M_dis , names("M_dis")
svmat reject_track_dis , names("reject_track_dis")
svmat reject_N_dis , names("reject_N_dis")
svmat mean_risk_dis , names("mean_risk_dis")
rename M_dis1 M_dis
rename M_dis2 M_dis_l
rename M_dis3 M_dis_u
rename reject_track_dis1 reject_track_dis
rename reject_N_dis1 reject_N_dis
rename mean_risk_dis1 mean_risk_dis

gen xlab = _n if _n < 10

label var M_dis "M"
label var M_dis_l "2.5"
label var M_dis_u "97.5"
preserve
keep M_dis xlab M_dis_u M_dis_l xlab 
save data/dis_graph_5, replace
restore
}



makem

 
if $bootstrap {
preserve
clear
use data/dis_graph_5

matrix F_pval_dis = F'
svmat F_pval_dis , names("f_p")
replace M_dis_l = 0 if f_p1 > .05


#delimit ;


twoway (scatter M_dis xlab, msize(huge) mcolor(dknavy)) (rcap M_dis_u M_dis_l xlab, lpattern(dash) lcolor(dknavy)) if _n < 5 ,
	xlabel(1 "No Reject" 2 "Reject" 3 "No Reject" 4 "Reject" )
	name(predictmarketgroup_dis, replace) title("Subgroup Test - Disability") 
	subtitle("By Age Bins; Excluding Uncertain Classification") 
	ytitle("M(X)")
	xline(2.5, lcolor(gs12))
	xtitle("")
	text(.075 1.6 "Age < 60")
	text(.075 3.6 "Age 60-65")
	;
graph save predictmarketgroup_dis, replace ;

/*
twoway (scatter M_dis xlab, msize(huge) mcolor(dknavy)) (rcap M_dis_u M_dis_l xlab, lpattern(dash) lcolor(dknavy)) if _n < 7 ,
	xlabel(1 "No Reject" 2 "Reject" 3 "No Reject" 4 "Reject" 5 "No Reject" 6 "Reject")
	name(predictmarketgroup_dis, replace) title("Subgroup Test - Disability") 
	subtitle("By Market (5yr Age Bins); Excluding Uncertain Classification") 
	ytitle("M(X)")
	xline(2.5, lcolor(gs12)) xline(4.5, lcolor(gs12))
	xtitle("")
	text(.075 1.6 "Age < 55")
	text(.075 3.6 "Age 55-59")
	text(.075 5.6 "Age 60-65")
	;
graph save predictmarketgroup_dis, replace ;


twoway (scatter M_dis xlab) (rcap M_dis_u M_dis_l xlab) if _n < 10 ,
	xlabel(1 "65-70, NR" 2 "65-70, R" 3 "71-75, NR" 4 "71-75 R" 5 "76-80 NR" 6 "76-80 R" 7 "80+ NC" 8 "80+ C" 9 "65-70 U" 10 "71-75 U" 11 "76-80 U" 12 "80+ U")
	xlabel(1 "<55, NR" 2 "<55, R" 3 "55-59, NR" 4 "55-59 R" 5 "60-65 NR" 6 "60-65 R" 7 "<55 U" 8 "55-59 U" 9 "60-65 U")
	name(predictmarketgroup_dis_u, replace) title("Subgroup Test - Disability") 
	subtitle("By Market (5yr Age Bins); Including Uncertain Classification") 
	ytitle("M(X)")
	xline(2.5) xline(4.5) xline(6.5)
	text(.07 1.6 "Age < 55")
	text(.07 3.6 "Age 55-59")
	text(.07 5.6 "Age 60-65")
	;
	
graph save predictmarketgroup_dis_u, replace ;	
	
 */
 
#delimit cr

*twoway (scatter M_dis xlab) (rcap M_dis_u M_dis_l xlab) if _n < 7 ,	xlabel(1 "No Rej" 2 "Reject" 3 "No Rej" 4 "Reject" 5 "No Rej" 6 "Reject") name(predictmarketgroup_dis, replace) title("Fine Test - Disability")  subtitle("By Market (5yr Age Bins); Excluding Uncertain Classification") ytitle("M(X)") xline(2.5) xline(4.5) text(.07 1.6 "Age < 55") text(.07 3.6 "Age 55-59") text(.07 5.6 "Age 60-65") xtitle("")

restore
}
/*

if $bootstrap == 0 {

svmat M_dis , names("M_dis")
svmat reject_track_dis , names("reject_track_dis")
svmat reject_N_dis , names("reject_N_dis")
svmat mean_risk_dis , names("mean_risk_dis")
rename M_dis1 M_dis
rename reject_track_dis1 reject_track_dis
rename reject_N_dis1 reject_N_dis
rename mean_risk_dis1 mean_risk_dis

twoway scatter reject_track_dis M_dis if reject_track_dis < 2 , name(predictmarketgroup_dis, replace) title("Market Shutdown versus E[M(X)] - Disability") subtitle("By Market (5yr Age Bins); Excluding Uncertain Classification") xtitle("E[M(X)]") ytitle("Indicator of Market Shutdown")
graph save predictmarket_dis, replace

reg reject_track_dis M_dis 
estimates store regtest_dis

twoway scatter reject_track_dis M_dis  , name(predictmarketgroup_dis_wunc, replace) title("Market Shutdown versus E[M(X)] - Disability") subtitle("By Market (5yr Age Bins) ") xtitle("E[M(X)]") ytitle("Rejection Classification")
graph save predictmarket_dis_wunc, replace

}
*/

/* Life */


use data/hrs_using_life_sample, clear
drop if wav == 1

global outcome = "dead"
global subj = "$lifesubj"
global sample = "samplelife == 1"
global finelist = "finegroup"
global cov = "$lifecovariatesprice"
global reject = "reject_life"
global aglist = "finegroup_age_r"
_rmcoll $cov , forcedrop
global cov_use `r(varlist)'

_rmcoll $subj , forcedrop
global subj_use `r(varlist)'


makep
matrix M_life = M'
matrix reject_track_life = reject_track'
matrix reject_N_life = reject_N'
matrix mean_risk_life = mean_risk'


if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/life_part_5, replace): makep
matrix temp = e(ci_percentile)
matrix M_life = M_life , temp'
restore


svmat M_life , names("M_life")
svmat reject_track_life , names("reject_track_life")
svmat reject_N_life , names("reject_N_life")
svmat mean_risk_life , names("mean_risk_life")
rename M_life1 M_life
rename M_life2 M_life_l
rename M_life3 M_life_u
rename reject_track_life1 reject_track_life
rename reject_N_life1 reject_N_life
rename mean_risk_life1 mean_risk_life

gen xlab = _n if _n < 10

label var M_life "M"
label var M_life_l "2.5"
label var M_life_u "97.5"
preserve
keep M_life xlab M_life_u M_life_l xlab 
save data/life_graph_5, replace
restore
}




makem
 

if $bootstrap {
preserve
clear
use data/life_graph_5

matrix F_pval_life = F'
svmat F_pval_life , names("f_p")
replace M_life_l = 0 if f_p1 > .05

#delimit ;
twoway (scatter M_life xlab, msize(huge) mcolor(dknavy) ) (rcap M_life_u M_life_l xlab, lpattern(dash) lcolor(dknavy)) if _n < 5 ,
	xlabel(1 "No Reject" 2 "Reject" 3 "No Reject" 4 "Reject" )
	name(predictmarketgroup_life, replace) title("Subgroup Test - Life") 
	subtitle("By Market (10yr Age Bins); Excluding Uncertain Classification") 
	ytitle("M(X)")
	xline(2.5, lcolor(gs12))
	text(.07 1.6 "Age 61-70")
	text(.07 3.4 "Age >70")
	;
graph save predictmarketgroup_life, replace ;
	
twoway (scatter M_life xlab) (rcap M_life_u M_life_l xlab) if _n < 7 ,
	xlabel(1 "61-70, NR" 2 "61-70, R" 3 "71-80, NR" 4 "71-80 R" 5 "61-70 U" 6 "71-80 U")
	name(predictmarketgroup_life_u, replace) title("Subgroup Test - Life") 
	subtitle("By Market (10yr Age Bins); Including Uncertain Classification") 
	ytitle("M(X)")
	xline(2.5) xline(4.5)
	text(.11 1.6 "Age 61-70")
	text(.11 3.6 "Age 71-80")
	;
	
graph save predictmarketgroup_life_u, replace ;
	
 
#delimit cr

*twoway (scatter M_life xlab) (rcap M_life_u M_life_l xlab) if _n < 5 , xlabel(1 "No Rej" 2 "Reject" 3 "No Reject" 4 "Reject" ) name(predictmarketgroup_life, replace) title("Fine Test - Life")  subtitle("By Market (5yr Age Bins); Excluding Uncertain Classification")  ytitle("M(X)") xline(2.5) text(.11 1.6 "Age 61-70") text(.11 3.6 "Age 71-80") xtitle("")
*twoway (scatter M_life xlab, msize(huge) mcolor(dknavy) ) (rcap M_life_u M_life_l xlab, lpattern(dash) lcolor(dknavy)) if _n < 5 , xlabel(1 "No Reject" 2 "Reject" 3 "No Reject" 4 "Reject" ) name(predictmarketgroup_life, replace) title("Subgroup Test - Life")  subtitle("By Market (10yr Age Bins); Excluding Uncertain Classification")  ytitle("M(X)") xline(2.5, lcolor(gs12)) text(.07 1.6 "Age 61-70") text(.07 3.4 "Age >70")
 

restore
}
/*
if $bootstrap == 0 {


svmat M_life , names("M_life")
svmat reject_track_life , names("reject_track_life")
svmat reject_N_life , names("reject_N_life")
svmat mean_risk_life , names("mean_risk_life")
rename M_life1 M_life
rename reject_track_life1 reject_track_life
rename reject_N_life1 reject_N_life
rename mean_risk_life1 mean_risk_life

twoway scatter reject_track_life M_life if reject_track_life < 2 , name(predictmarketgroup_life, replace) title("Market Shutdown versus E[M(X)] - Life") subtitle("By Market (5yr Age Bins); Excluding Uncertain Classification") xtitle("E[M(X)]") ytitle("Indicator of Market Shutdown")
graph save predictmarket_life, replace

reg reject_track_life M_life 
estimates store regtest_life

twoway scatter reject_track_life M_life  , name(predictmarketgroup_life_wunc, replace) title("Market Shutdown versus E[M(X)] - Life") subtitle("By Market (5yr Age Bins) ") xtitle("E[M(X)]") ytitle("Rejection Classification")
graph save predictmarket_life_wunc, replace

}
*/

/* Conditional and Unconditional Test Table */

clear

matrix cond_test = J(8,3,.)

use data/ltc_graph_5

matrix cond_test[1,1] = M_ltc[2] - M_ltc[1]
matrix cond_test[2,1] = M_ltc[4] - M_ltc[3]

clear
use data/dis_graph_5
matrix cond_test[3,1] = M_dis[2] - M_dis[1]
matrix cond_test[4,1] = M_dis[4] - M_dis[3]

clear
use data/life_graph_5
matrix cond_test[5,1] = M_life[2] - M_life[1]
matrix cond_test[6,1] = M_life[4] - M_life[3]

clear

use data/ltc_part_5
gen age6573 = (_b_c1 >= _b_c2)
gen age7380 = (_b_c3 >= _b_c4)

tabstat age6573 , save
matrix cond_test[1,2] = r(StatTotal)
tabstat age7380 , save
matrix cond_test[2,2] = r(StatTotal)


clear

use data/dis_part_5 
gen age5059 = (_b_c1 >= _b_c2)
gen age6065 = (_b_c3 >= _b_c4)

tabstat age5059 , save
matrix cond_test[3,2] = r(StatTotal)
tabstat age6065 , save
matrix cond_test[4,2] = r(StatTotal)

clear

use data/life_part_5
gen age6170 = (_b_c1 >= _b_c2)
gen age7180 = (_b_c3 >= _b_c4)

tabstat age6170 , save
matrix cond_test[5,2] = r(StatTotal)
tabstat age7180 , save
matrix cond_test[6,2] = r(StatTotal)

matrix cond_test[1,3] = F_pval_ltc[2,1]
matrix cond_test[2,3] = F_pval_ltc[4,1]
matrix cond_test[3,3] = F_pval_dis[2,1]
matrix cond_test[4,3] = F_pval_dis[4,1]
matrix cond_test[5,3] = F_pval_life[2,1]
matrix cond_test[6,3] = F_pval_life[4,1]

esttab matrix(cond_test) using cond_test.csv, replace


clear

* Unconditional Test *

matrix uncond_test = J(3,1,.)

use data/ltc_part_5
gen min_r = min(_b_c2,_b_c4,_b_c6,_b_c7,_b_c8)
gen max_nr = max(_b_c1,_b_c3,_b_c5)
gen uncond = min_r >= max_nr
tabstat uncond , save
matrix uncond_test[1,1] = r(StatTotal)
clear

use data/dis_part_5
gen min_r = min(_b_c2,_b_c4,_b_c6)
gen max_nr = max(_b_c1,_b_c3,_b_c5)
gen uncond = min_r >= max_nr
tabstat uncond , save
matrix uncond_test[2,1] = r(StatTotal)
clear

use data/life_part_5
gen min_r = min(_b_c2,_b_c4)
gen max_nr = max(_b_c1,_b_c3)
gen uncond = min_r >= max_nr
tabstat uncond , save
matrix uncond_test[3,1] = r(StatTotal)
clear

esttab matrix(uncond_test) using uncond_test.csv, replace

*/
}

*estout regtest_ltc regtest_dis regtest_life using regtest.txt , cells( b(star fmt(%9.4f)) se(par(`"="("'`")""'))) keep(M_ltc M_dis M_life) title("Table I") style(tab) stats(N , fmt( 0 0 ) labels(N "No. Obs.")) label collabels(, none) starlevels(* .10 ** .05 *** .01) replace

/*




/*

global cov = "$ltccovariatesfull"
global subj = "$ltcsubj"
global finelist = "finegroup_full"
global reject = "reject_ltc"

makefine
makefine_upper

matrix astr_ltc_full = astr_p25'
matrix reject_track_ltc_full = reject_track'
matrix reject_N_ltc_full = reject_N'
matrix mean_risk_ltc_full = mean_risk'
matrix astr_upper_ltc_full = astr_upper_p25'

svmat astr_ltc_full , names("astr_ltc_full")
svmat reject_track_ltc_full , names("reject_track_ltc_full")
svmat reject_N_ltc_full , names("reject_N_ltc_full")
svmat mean_risk_ltc_full , names("mean_risk_ltc_full")
svmat astr_upper_ltc_full , names("astr_upper_ltc_full")

rename astr_ltc_full1 astr_ltc_full
rename reject_track_ltc_full1 reject_track_ltc_full
rename reject_N_ltc_full1 reject_N_ltc_full
rename mean_risk_ltc_full1 mean_risk_ltc_full
rename astr_upper_ltc_full1 astr_upper_ltc_full

lpoly reject_track_ltc_full astr_ltc_full , name(predictmarketgroup_ltc_full, replace) title("Market Shutdown versus T(p)") subtitle("By Market (5yr Age Bins, Gender, Census Region)") xtitle("T(p)") ytitle("Indicator of Market Shutdown")

graph save predictmarket_ltc_full, replace


lpoly reject_track_ltc_full astr_upper_ltc_full , name(predictmarketfull_upper_ltc, replace) title("Market Shutdown versus T(p), Upper Bound") subtitle("By Market (5yr Age Bins) ") xtitle("T_(p)") ytitle("Indicator of Market Shutdown")

graph save predictmarketfull_upper_ltc , replace

sort reject_track_ltc_full

twoway (rcap astr_upper_ltc_full astr_ltc_full finegroup_full if reject_track_ltc_full ==0 , lcolor(blue)) (rcap astr_upper_ltc_full astr_ltc_full finegroup_full if reject_track_ltc_full == 1 , lcolor(red)) , name(predictupperlower_ltc_full, replace) title("T_(p) by Market; Upper & Lower bounds") ytitle("T_(p) 25th Quantile") xtitle("Market Index") subtitle("80 markets")

graph save predictupperlower_ltc , replace


*/



* Subgroups - Reject vs No Reject


foreach reject in 0 1 {


global sample = "sampleltc == 1 & reject_ltc == `reject'"

global subj = "$ltcsubj_s"
global cov = ""
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix astr25_t = temp[1,16]
matrix fltc`reject' = f'
if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsltc_n_`reject', replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
matrix astr25_t = astr25_t \ temp[1,16]
restore
}
matrix sigmasltc`reject' = sigmas_t
matrix econltc`reject' = econ_t
matrix astrltc`reject' = astr_t
matrix astr25ltc`reject' = astr25_t



global subj = "$ltcsubj"
global cov = "$ltccovariatesprice"
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix astr25_t = temp[1,16]
matrix fltc`reject' = fltc`reject' , f'
if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsltc_p_`reject', replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
matrix astr25_t = astr25_t \ temp[1,16]
restore
}
matrix sigmasltc`reject' = sigmasltc`reject' , sigmas_t
matrix econltc`reject' = econltc`reject' , econ_t
matrix astrltc`reject' = astrltc`reject' , astr_t
matrix astr25ltc`reject' = astr25ltc`reject' , astr25_t

global graphs = 1
global cov = "$ltccovariatesfull"
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix astr25_t = temp[1,16]
matrix fltc`reject' = fltc`reject' , f'
if $bootstrap {
preserve
keep if $sample
global graphs = 0
bootstrap _b, reps($breps) $bcluster saving(data/bsltc_f_`reject', replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
matrix astr25_t = astr25_t \ temp[1,16]
restore
}
matrix sigmasltc`reject' = sigmasltc`reject' , sigmas_t
matrix econltc`reject' = econltc`reject' , econ_t
matrix astrltc`reject' = astrltc`reject' , astr_t
matrix astr25ltc`reject' = astr25ltc`reject' , astr25_t

rename G_i_out G_i_ltc`reject'
rename I_G_out I_G_ltc`reject'
rename i_x_p_out i_x_p_ltc`reject'
rename astr_out astr_ltc`reject'
rename e_x_p_out e_x_p_ltc`reject'
*graph rename mcac mcac_`reject'
global graphs = 0

count if $sample
matrix fltc`reject' = fltc`reject' , (r(N)\.)

}

matrix fltc_r = fltc0\fltc1
matrix sigmasltc_r = sigmasltc0\sigmasltc1
matrix econltc_r = econltc0\econltc1
matrix astrltc_r = astrltc0\astrltc1
matrix astr25ltc_r = astr25ltc0 \ astr25ltc1

label var G_i_ltc1 "Reject"
label var G_i_ltc0 "No Reject"
label var I_G_ltc1 "Reject"
label var I_G_ltc0 "No Reject"
sort i_x_p_ltc1 i_x_p_ltc0
twoway (line G_i_ltc1 i_x_p_ltc1 if i_x_p_ltc1 >-.05 & i_x_p_ltc1 < .05 , lpattern(solid) ) (line G_i_ltc0 i_x_p_ltc0 if i_x_p_ltc0 >-.05 & i_x_p_ltc0 < .05 , lpattern(dash)) , name(quants_ltc, replace) title("CDF of Residual Private Information") xtitle("i(p|X)") ytitle("CDF") subtitle("LTC")
twoway (line I_G_ltc1 i_x_p_ltc1 if i_x_p_ltc1 >-.05 & i_x_p_ltc1 < .05 , lpattern(solid) ) (line I_G_ltc0 i_x_p_ltc0 if i_x_p_ltc0 >-.05 & i_x_p_ltc0 < .05 , lpattern(dash)) , name(SOSD_ltc, replace) title("Integral of CDF") xtitle("i(p|X)") ytitle("Integral of CDF") subtitle("LTC") 

graph save quants_ltc quants_ltc, replace
graph save SOSD_ltc SOSD_ltc, replace


lpoly astr_ltc0 e_x_p_ltc0 , noscatter name(astr_0_e, replace) title("Price Ratio by Pr{L|X,z}") subtitle("No Reject") xtitle("Pr{L|X,z}") ytitle("Price Ratio") gen(x_e_ltc0 y_e_ltc0) n(50)
lpoly astr_ltc1 e_x_p_ltc1 , noscatter name(astr_1_e, replace) title("Price Ratio by Pr{L|X,z}") subtitle("Reject") xtitle("Pr{L|X,z}") ytitle("Price Ratio") gen(x_e_ltc1 y_e_ltc1) n(50)
lpoly astr_ltc0 G_i_ltc0 , noscatter name(astr_0_G, replace) title("Price Ratio by Q(i(z|X))") subtitle("No Reject") xtitle("Q(i(z|X))") ytitle("Price Ratio") gen(x_G_ltc0 y_G_ltc0) n(50)
lpoly astr_ltc1 G_i_ltc1 , noscatter name(astr_1_G, replace) title("Price Ratio by Q(i(z|X))") subtitle("Reject") xtitle("Q(i(z|X))") ytitle("Price Ratio") gen(x_G_ltc1 y_G_ltc1) n(50)

label var x_e_ltc0 "No Reject"
label var x_e_ltc1 "Reject"
label var y_e_ltc0 "No Reject"
label var y_e_ltc1 "Reject"
label var x_G_ltc0 "No Reject"
label var x_G_ltc1 "Reject"
label var y_G_ltc0 "No Reject"
label var y_G_ltc1 "Reject"

tabstat x_e_ltc1 if y_e_ltc1 < 2 , stats(max) save
matrix j = r(StatTotal)
local j = j[1,1]
gen x_use_ltc0 = 0
replace x_use_ltc0 = 1 if x_e_ltc0 <= `j'
gen x_use_ltc1 = 0
replace x_use_ltc1 = 1 if x_e_ltc1 <= `j'


twoway (line y_e_ltc0 x_e_ltc0 if x_use_ltc0 == 1 & y_e_ltc0 < 2 , lpattern(dash)) (line y_e_ltc1 x_e_ltc1 if x_use_ltc1 == 1 & y_e_ltc1 < 2 , lpattern(solid)) , name(astrltc_e, replace) title("Price Ratio by p=Pr{L|X,z}") subtitle("LTC") xtitle("p=Pr{L|X,z}") ytitle("Price Ratio = p_bar/(1-p_bar) / p/(1-p)") ysc(r(1 2)) ylabel(1(.2)2)
twoway (line y_G_ltc0 x_G_ltc0 if y_G_ltc0 < 2 , lpattern(dash)) (line y_G_ltc1 x_G_ltc1 if y_G_ltc1 < 2 , lpattern(solid)) , name(astrltc_G, replace) title("Price Ratio by Q(i(z|X))") subtitle("LTC") xtitle("Q(i(z|X))") ytitle("Price Ratio = p_bar/(1-p_bar) / p/(1-p)") ysc(r(1 2)) ylabel(1(.2)2)

graph save astrltc_e astrltc_e , replace
graph save astrltc_G astrltc_G , replace

* Compute p values: Fraction of repetitions in which less private info in reject = 0 than in reject = 1 *

if $bootstrap {
preserve
use data/bsltc_n_0, clear
rename _b_lambda lambda0
rename _b_ast ast0
rename _b_astr astr0
rename _b_sigma sigma0
rename _b_fracvar fracvar0
gen n = _n
sort n
save data/bsltc_n_0_t, replace
use data/bsltc_n_1, clear
rename _b_lambda lambda1
rename _b_ast ast1
rename _b_astr astr1
rename _b_sigma sigma1
rename _b_fracvar fracvar1
gen n=_n
sort n
merge n using data/bsltc_n_0_t
tab _merge
drop _merge
gen lambdamore = lambda1 < lambda0
gen astmore = ast1 < ast0
gen astrmore = astr1 < astr0
gen sigmamore = sigma1 < sigma0
gen fracvarmore = fracvar1 < fracvar0
tabstat lambdamore astmore astrmore sigmamore fracvarmore , stats(mean) save
matrix more_pvals_n = r(StatTotal)

use data/bsltc_p_0, clear
rename _b_lambda lambda0
rename _b_ast ast0
rename _b_astr astr0
rename _b_sigma sigma0
rename _b_fracvar fracvar0
gen n = _n
sort n
save data/bsltc_p_0_t, replace
use data/bsltc_p_1, clear
rename _b_lambda lambda1
rename _b_ast ast1
rename _b_astr astr1
rename _b_sigma sigma1
rename _b_fracvar fracvar1
gen n=_n
sort n
merge n using data/bsltc_p_0_t
tab _merge
drop _merge
gen lambdamore = lambda1 < lambda0
gen astmore = ast1 < ast0
gen astrmore = astr1 < astr0
gen sigmamore = sigma1 < sigma0
gen fracvarmore = fracvar1 < fracvar0
tabstat lambdamore astmore astrmore sigmamore fracvarmore , stats(mean) save
matrix more_pvals_p = r(StatTotal)

use data/bsltc_f_0, clear
rename _b_lambda lambda0
rename _b_ast ast0
rename _b_astr astr0
rename _b_sigma sigma0
rename _b_fracvar fracvar0
gen n = _n
sort n
save data/bsltc_f_0_t, replace
use data/bsltc_f_1, clear
rename _b_lambda lambda1
rename _b_ast ast1
rename _b_astr astr1
rename _b_sigma sigma1
rename _b_fracvar fracvar1
gen n=_n
sort n
merge n using data/bsltc_f_0_t
tab _merge
drop _merge
gen lambdamore = lambda1 < lambda0
gen astmore = ast1 < ast0
gen astrmore = astr1 < astr0
gen sigmamore = sigma1 < sigma0
gen fracvarmore = fracvar1 < fracvar0
tabstat lambdamore astmore astrmore sigmamore fracvarmore , stats(mean) save
matrix more_pvals_f = r(StatTotal)


matrix tempe = more_pvals_n[1,1..3],more_pvals_p[1,1..3],more_pvals_f[1,1..3]
matrix temps = more_pvals_n[1,4..5],more_pvals_p[1,4..5],more_pvals_f[1,4..5]
matrix econltc_r = econltc_r \ tempe
matrix sigmasltc_r = sigmasltc_r \ temps

restore
}

/*
foreach reject in 0 1 {
foreach agecat in 2 3 4 5 6 {

global sample = "sampleltc == 1 & reject == `reject' & agecat == `agecat' "

global cov = ""
global subj = "$ltcsubj_s"
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix fltc`reject'`agecat' = f'
if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsltc_n_`reject'`agecat', replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
restore
}
matrix econltc`reject'`agecat' =  econ_t
matrix sigmasltc`reject'`agecat' =  sigmas_t
matrix astrltc`reject'`agecat' = astr_t


global cov = "$ltccovariatesprice"
global subj = "$ltcsubj"
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix fltc`reject'`agecat' = fltc`reject'`agecat' , f'
if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsltc_p_`reject'`agecat', replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
restore
}
matrix econltc`reject'`agecat' = econltc`reject'`agecat' , econ_t
matrix sigmasltc`reject'`agecat' = sigmasltc`reject'`agecat' , sigmas_t
matrix astrltc`reject'`agecat' = astrltc`reject'`agecat' , astr_t


global cov = "$ltccovariatesfull"
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix fltc`reject'`agecat' = fltc`reject'`agecat' , f'
if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsltc_f_`reject'`agecat', replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
restore
}
matrix econltc`reject'`agecat' = econltc`reject'`agecat' , econ_t
matrix sigmasltc`reject'`agecat' = sigmasltc`reject'`agecat' , sigmas_t
matrix astrltc`reject'`agecat' = astrltc`reject'`agecat' , astr_t

count if $sample
matrix fltc`reject'`agecat' = fltc`reject'`agecat' , (r(N)\.)

}
}
matrix fltc_ra = fltc02\fltc12\fltc03\fltc13\fltc04\fltc14\fltc05\fltc15\fltc06\fltc16
matrix econltc_ra = econltc02\econltc12\econltc03\econltc13\econltc04\econltc14\econltc05\econltc15\econltc06\econltc16
matrix sigmasltc_ra = sigmasltc02\sigmasltc12\sigmasltc03\sigmasltc13\sigmasltc04\sigmasltc14\sigmasltc05\sigmasltc15\sigmasltc06\sigmasltc16
matrix astrltc_ra = astrltc02\astrltc12\astrltc03\astrltc13\astrltc04\astrltc14\astrltc05\astrltc15\astrltc06\astrltc16

matrix econltc_out = econltc \ econltc_r \econltc_ra
esttab matrix(econltc_out) using econltc_out.csv, replace
matrix sigmasltc_out = sigmasltc \ sigmasltc_r \ sigmasltc_ra
esttab matrix(sigmasltc_out) using sigmasltc_out.csv, replace
matrix fltc_out = fltc \ fltc_r \ fltc_ra
esttab matrix(fltc_out) using fltc_out.csv, replace
matrix astrltc_out = astrltc \ astrltc_r \ astrltc_ra
esttab matrix(astrltc_out) using astrltc_out.csv, replace

*/


*******************************
/* Estimation Results - Life */
*******************************

use data/hrs_using_life_sample, clear

*drop if samplelife == 0

global graphs = 0

global num = 20

* Overall

global outcome = "dead"
global subj = "$lifesubj_s"

global sample = "samplelife == 1"
global cov = ""
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix astr25_t = temp[1,16]
matrix flife = f'
if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bslife_n, replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
matrix astr25_t = astr25_t \ temp[1,16]
restore
}
matrix econlife = econ_t
matrix sigmaslife = sigmas_t
matrix astrlife = astr_t
matrix astr25life = astr25_t

global cov = "$lifecovariatesprice"
global subj = "$lifesubj"
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix astr25_t = temp[1,16]
matrix flife = flife , f'
if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bslife_p, replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
matrix astr25_t = astr25_t \ temp[1,16]
restore
}
matrix econlife = econlife , econ_t
matrix sigmaslife = sigmaslife , sigmas_t
matrix astrlife = astrlife , astr_t
matrix astr25life = astr25life , astr25_t

global sample = "samplelife_full == 1"
global cov = "$lifecovariatesfull"

makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix astr25_t = temp[1,16]
matrix flife = flife , f'
if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bslife_f, replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
matrix astr25_t = astr25_t \ temp[1,16]
restore
}
matrix econlife = econlife , econ_t
matrix sigmaslife = sigmaslife , sigmas_t
matrix astrlife = astrlife , astr_t
matrix astr25life = astr25life, astr25_t

global sample = "samplelife == 1"
count if $sample
matrix flife = flife , (r(N)\.)



* Predicting Market Shutdown 

global cov = "$lifecovariatesfull"
global subj = "$lifesubj"
global finelist = "finegroup"
global reject = "reject_life"

cap makefine

matrix astr_life = astr_p25'
matrix reject_track_life = reject_track'
matrix reject_N_life = reject_N'
matrix mean_risk_life = mean_risk'


svmat astr_life , names("astr_life")
svmat reject_track_life , names("reject_track_life")
svmat reject_N_life , names("reject_N_life")
svmat mean_risk_life , names("mean_risk_life")

rename astr_life1 astr_life
rename reject_track_life1 reject_track_life
rename reject_N_life1 reject_N_life
rename mean_risk_life1 mean_risk_life


twoway scatter reject_track_life astr_life , name(predictmarketgroup_life, replace) title("Market Shutdown versus T(X) - Life") subtitle("By Market (5yr Age Bins) ") xtitle("T(X)") ytitle("Indicator of Market Shutdown")

reg reject_track_life astr_life mean_risk_life

graph save predictmarket_life, replace

gen T_X = astr_life
reg reject_track_life T_X 
estimates store regtest_life






* Subgroups - Reject vs No Reject


foreach reject in 0 1 {
global sample = "samplelife == 1 & reject_life == `reject'"

global subj = "$lifesubj_s"
global cov = ""
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix astr25_t = temp[1,16]
matrix flife`reject' = f'
if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bslife_n_`reject', replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
matrix astr25_t = astr25_t \ temp[1,16]
restore
}
matrix econlife`reject' = econ_t
matrix sigmaslife`reject' = sigmas_t
matrix astrlife`reject' = astr_t
matrix astr25life`reject' = astr25_t


global subj = "$lifesubj"
global cov = "$lifecovariatesprice"
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix astr25_t = temp[1,16]
matrix flife`reject' = flife`reject' , f'
if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bslife_p_`reject', replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
matrix astr25_t = astr25_t \ temp[1,16]
restore
}
matrix econlife`reject' = econlife`reject' , econ_t
matrix sigmaslife`reject' = sigmaslife`reject' , sigmas_t
matrix astrlife`reject' = astrlife`reject' , astr_t
matrix astr25life`reject' = astr25life`reject' , astr25_t

global sample = "samplelife_full == 1 & reject_life == `reject'"
global graphs = 1
global cov = "$lifecovariatesfull"
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix astr25_t = temp[1,16]
matrix flife`reject' = flife`reject' , f'
if $bootstrap {
preserve
keep if $sample
global graphs = 0
bootstrap _b, reps($breps) $bcluster saving(data/bslife_f_`reject', replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
matrix astr25_t = astr25_t \ temp[1,16]
restore
}
matrix econlife`reject' = econlife`reject' , econ_t
matrix sigmaslife`reject' = sigmaslife`reject' , sigmas_t
matrix astrlife`reject' = astrlife`reject' , astr_t
matrix astr25life`reject' = astr25life`reject' , astr25_t

rename G_i_out G_i_life`reject'
rename I_G_out I_G_life`reject'
rename i_x_p_out i_x_p_life`reject'
rename astr_out astr_life`reject'
rename e_x_p_out e_x_p_life`reject'


global graphs = 0

global sample = "samplelife == 1 & reject_life == `reject'"
count if $sample
matrix flife`reject' = flife`reject' , (r(N)\.)

}

matrix flife_r = flife0\flife1
matrix econlife_r = econlife0\econlife1
matrix sigmaslife_r = sigmaslife0\sigmaslife1
matrix astrlife_r = astrlife0\astrlife1
matrix astr25life_r = astr25life0\astr25life1



if $bootstrap {
preserve
use data/bslife_n_0, clear
rename _b_lambda lambda0
rename _b_ast ast0
rename _b_astr astr0
rename _b_sigma sigma0
rename _b_fracvar fracvar0
gen n = _n
sort n
save data/bslife_n_0_t, replace
use data/bslife_n_1, clear
rename _b_lambda lambda1
rename _b_ast ast1
rename _b_astr astr1
rename _b_sigma sigma1
rename _b_fracvar fracvar1
gen n=_n
sort n
merge n using data/bslife_n_0_t
tab _merge
drop _merge
gen lambdamore = lambda1 < lambda0
gen astmore = ast1 < ast0
gen astrmore = astr1 < astr0
gen sigmamore = sigma1 < sigma0
gen fracvarmore = fracvar1 < fracvar0
tabstat lambdamore astmore astrmore sigmamore fracvarmore , stats(mean) save
matrix more_pvals_n = r(StatTotal)

use data/bslife_p_0, clear
rename _b_lambda lambda0
rename _b_ast ast0
rename _b_astr astr0
rename _b_sigma sigma0
rename _b_fracvar fracvar0
gen n = _n
sort n
save data/bslife_p_0_t, replace
use data/bslife_p_1, clear
rename _b_lambda lambda1
rename _b_ast ast1
rename _b_astr astr1
rename _b_sigma sigma1
rename _b_fracvar fracvar1
gen n=_n
sort n
merge n using data/bslife_p_0_t
tab _merge
drop _merge
gen lambdamore = lambda1 < lambda0
gen astmore = ast1 < ast0
gen astrmore = astr1 < astr0
gen sigmamore = sigma1 < sigma0
gen fracvarmore = fracvar1 < fracvar0
tabstat lambdamore astmore astrmore sigmamore fracvarmore , stats(mean) save
matrix more_pvals_p = r(StatTotal)

use data/bslife_f_0, clear
rename _b_lambda lambda0
rename _b_ast ast0
rename _b_astr astr0
rename _b_sigma sigma0
rename _b_fracvar fracvar0
gen n = _n
sort n
save data/bslife_f_0_t, replace
use data/bslife_f_1, clear
rename _b_lambda lambda1
rename _b_ast ast1
rename _b_astr astr1
rename _b_sigma sigma1
rename _b_fracvar fracvar1
gen n=_n
sort n
merge n using data/bslife_f_0_t
tab _merge
drop _merge
gen lambdamore = lambda1 < lambda0
gen astmore = ast1 < ast0
gen astrmore = astr1 < astr0
gen sigmamore = sigma1 < sigma0
gen fracvarmore = fracvar1 < fracvar0
tabstat lambdamore astmore astrmore sigmamore fracvarmore , stats(mean) save
matrix more_pvals_f = r(StatTotal)


matrix tempe = more_pvals_n[1,1..3],more_pvals_p[1,1..3],more_pvals_f[1,1..3]
matrix temps = more_pvals_n[1,4..5],more_pvals_p[1,4..5],more_pvals_f[1,4..5]
matrix econlife_r = econlife_r \ tempe
matrix sigmaslife_r = sigmaslife_r \ temps

restore
}


matrix econlife_out = econlife \ econlife_r 
esttab matrix(econlife_out) using econlife_out.csv, replace
matrix sigmaslife_out = sigmaslife \ sigmaslife_r
esttab matrix(sigmaslife_out) using sigmaslife_out.csv, replace
matrix flife_out = flife \ flife_r
esttab matrix(flife_out) using flife_out.csv, replace
matrix astrlife_out = astrlife \ astrlife_r
esttab matrix(astrlife_out) using astrlife_out.csv, replace

label var G_i_life1 "Reject"
label var G_i_life0 "No Reject"
label var I_G_life1 "Reject"
label var I_G_life0 "No Reject"
sort i_x_p_life1 i_x_p_life0
twoway (line G_i_life1 i_x_p_life1 if i_x_p_life1 >-.1 & i_x_p_life1 < .1  , lpattern(solid)) (line G_i_life0 i_x_p_life0 if i_x_p_life0 >-.1 & i_x_p_life0 < .1 , lpattern(dash)) , name(quants_life, replace) title("CDF of Residual Private Information") xtitle("i(p|X)") ytitle("CDF") subtitle("Life")
twoway (line I_G_life1 i_x_p_life1 if i_x_p_life1 >-.1 & i_x_p_life1 < .1  , lpattern(solid)) (line I_G_life0 i_x_p_life0 if i_x_p_life0 >-.1 & i_x_p_life0 < .1 , lpattern(dash)) , name(SOSD_life, replace) title("Integral of CDF") xtitle("i(p|X)") ytitle("Integral of CDF") subtitle("Life")

graph save quants_life quants_life, replace
graph save SOSD_life SOSD_life, replace

lpoly astr_life0 e_x_p_life0 , noscatter name(astrlife_0_e, replace) title("Life: Price Ratio by Pr{L|X,z}") subtitle("No Reject") xtitle("Pr{L|X,z}") ytitle("Price Ratio") gen(x_e_life0 y_e_life0) n(50)
lpoly astr_life1 e_x_p_life1 , noscatter name(astrlife_1_e, replace) title("Life: Price Ratio by Pr{L|X,z}") subtitle("Reject") xtitle("Pr{L|X,z}") ytitle("Price Ratio") gen(x_e_life1 y_e_life1) n(50)
lpoly astr_life0 G_i_life0 , noscatter name(astrlife_0_G, replace) title("Life: Price Ratio by Q(i(z|X))") subtitle("No Reject") xtitle("Q(i(z|X))") ytitle("Price Ratio") gen(x_G_life0 y_G_life0) n(50)
lpoly astr_life1 G_i_life1 , noscatter name(astrlife_1_G, replace) title("Life: Price Ratio by Q(i(z|X))") subtitle("Reject") xtitle("Q(i(z|X))") ytitle("Price Ratio") gen(x_G_life1 y_G_life1) n(50)

label var x_e_life0 "No Reject"
label var x_e_life1 "Reject"
label var y_e_life0 "No Reject"
label var y_e_life1 "Reject"
label var x_G_life0 "No Reject"
label var x_G_life1 "Reject"
label var y_G_life0 "No Reject"
label var y_G_life1 "Reject"


tabstat x_e_life1 if y_e_life1 < 2 , stats(max) save
matrix j = r(StatTotal)
local j = j[1,1]
gen x_use_life0 = 0
replace x_use_life0 = 1 if x_e_life0 <= `j'
gen x_use_life1 = 0
replace x_use_life1 = 1 if x_e_life1 <= `j'


twoway (line y_e_life0 x_e_life0 if x_use_life0 == 1 & y_e_life0 < 2 , lpattern(dash)) (line y_e_life1 x_e_life1 if x_use_life1 == 1 & y_e_life1 < 2 , lpattern(solid)) , name(astrlife_e, replace) title("Price Ratio by Pr{L|X,z}") subtitle("Life") xtitle("p=Pr{L|X,z}") ytitle("Price Ratio: p_bar/(1-p_bar) / (p/(1-p))")  ysc(r(1 2)) ylabel(1(.2)2)
twoway (line y_G_life0 x_G_life0 if y_G_life0 < 2 , lpattern(dash)) (line y_G_life1 x_G_life1 if y_G_life1 < 2, lpattern(solid)) , name(astrlife_G, replace) title("Price Ratio by Q(i(z|X))") subtitle("Life") xtitle("Q(i(z|X))") ytitle("Price Ratio: p_bar/(1-p_bar) / (p/(1-p))")  ysc(r(1 2)) ylabel(1(.2)2)

graph save astrlife_e astrlife_e , replace
graph save astrlife_G astrlife_G , replace





/*
label var G_i_1 "Reject"
label var G_i_0 "No Reject"
sort i_x_p_1 i_x_p_0
twoway (line G_i_1 i_x_p_1 if i_x_p_1 >-.1 & i_x_p_1 < .1  ) (line G_i_0 i_x_p_0 if i_x_p_0 >-.1 & i_x_p_0 < .1 ) , name(quants, replace) title("CDF of Residual Private Information") xtitle("i(p|X)") ytitle("CDF")
*/




*************************************
/* Estimation Results - Disability */
*************************************

use data/hrs_using_dis_sample, clear

global graphs = 0

global num = 20

* Overall

global outcome = "hlthlm_r5f"
global subj = "$dissubj_s"

global sample = "sampledis == 1"
global cov = ""
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix astr25_t = temp[1,16]
matrix fdis = f'
if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsdis_n, replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
matrix astr25_t = astr_t \ temp[1,16]
restore
}
matrix econdis = econ_t
matrix sigmasdis = sigmas_t
matrix astrdis = astr_t
matrix astr25dis = astr25_t

global cov = "$discovariatesprice"
global subj = "$dissubj"
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix astr25_t = temp[1,16]
matrix fdis = fdis , f'
if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsdis_p, replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
matrix astr25_t = astr25_t\ temp[1,16]
restore
}
matrix econdis = econdis , econ_t
matrix sigmasdis = sigmasdis , sigmas_t
matrix astrdis = astrdis , astr_t
matrix astr25dis = astr25dis, astr25_t


global cov = "$discovariatesfull"
global subj = "$dissubj"
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix astr25_t = temp[1,16]
matrix fdis = fdis , f'
if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsdis_f, replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
matrix astr25_t = astr25_t \ temp[1,16]
restore
}
matrix econdis = econdis , econ_t
matrix sigmasdis = sigmasdis , sigmas_t
matrix astrdis = astrdis , astr_t
matrix astr25dis = astr25dis , astr25_t

count if $sample
matrix fdis = fdis , (r(N)\.)




* Predicting Market Shutdown 

global cov = "$discovariatesfull"
global subj = "$dissubj"
global finelist = "finegroup"
global reject = "reject_dis"

makefine

matrix astr_dis = astr_p25'
matrix reject_track_dis = reject_track'
matrix reject_N_dis = reject_N'
matrix mean_risk_dis = mean_risk'


svmat astr_dis , names("astr_dis")
svmat reject_track_dis , names("reject_track_dis")
svmat reject_N_dis , names("reject_N_dis")
svmat mean_risk_dis , names("mean_risk_dis")

rename astr_dis1 astr_dis
rename reject_track_dis1 reject_track_dis
rename reject_N_dis1 reject_N_dis
rename mean_risk_dis1 mean_risk_dis


twoway scatter reject_track_dis astr_dis , name(predictmarketgroup_dis, replace) title("Market Shutdown versus T(X) - Disability") subtitle("By Market (5yr Age Bins) ") xtitle("T(X)") ytitle("Indicator of Market Shutdown")

reg reject_track_dis astr_dis mean_risk_dis

graph save predictmarket_dis, replace

gen T_X = astr_dis
reg reject_track_dis T_X 
estimates store regtest_dis



* By Rejection 



foreach reject in 0 1 {
global sample = "sampledis == 1 & reject_dis == `reject'"
global graphs = 0

global subj = "$dissubj_s"
global cov = ""
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix astr25_t = temp[1,16]
matrix fdis`reject' = f'
if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsdis_n_`reject', replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
matrix astr25_t = astr25_t \ temp[1,16]
restore
}
matrix econdis`reject' = econ_t
matrix sigmasdis`reject' = sigmas_t
matrix astrdis`reject' = astr_t
matrix astr25dis`reject' = astr25_t


global cov = "$discovariatesprice"
global subj = "$dissubj"
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix astr25_t = temp[1,16]
matrix fdis`reject' = fdis`reject' , f'
if $bootstrap {
preserve
keep if $sample
bootstrap _b, reps($breps) $bcluster saving(data/bsdis_p_`reject', replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
matrix astr25_t = astr25_t \ temp[1,16]
restore
}
matrix econdis`reject' = econdis`reject' , econ_t
matrix sigmasdis`reject' = sigmasdis`reject' , sigmas_t
matrix astrdis`reject' = astrdis`reject' , astr_t
matrix astr25dis`reject' = astr25dis`reject', astr25_t

global graphs = 1
global subj = "$dissubj"
global cov = "$discovariatesfull"
makestats
matrix temp = e(b)
matrix sigmas_t = temp[1,4..5]
matrix econ_t = temp[1,1..3]
matrix astr_t = temp[1,6..15]
matrix astr25_t = temp[1,16]
matrix fdis`reject' = fdis`reject' , f'
if $bootstrap {
preserve
keep if $sample
global graphs = 0
bootstrap _b, reps($breps) $bcluster saving(data/bsdis_f_`reject', replace): makestats
matrix temp = vecdiag(e(V))
foreach j in 1 2 3 4 5 {
matrix temp[1,`j'] = sqrt(temp[1,`j'])
}
matrix econ_t = econ_t \ temp[1,1..3]
matrix sigmas_t = sigmas_t \ temp[1,4..5]
matrix astr_t = astr_t \ temp[1,6..15]
matrix astr25_t = astr25_t \ temp[1,16]
restore
}
matrix econdis`reject' = econdis`reject' , econ_t
matrix sigmasdis`reject' = sigmasdis`reject' , sigmas_t
matrix astrdis`reject' = astrdis`reject' , astr_t
matrix astr25dis`reject' = astr25dis`reject' , astr25_t

rename G_i_out G_i_dis`reject'
rename I_G_out I_G_dis`reject'
rename i_x_p_out i_x_p_dis`reject'
rename astr_out astr_dis`reject'
rename e_x_p_out e_x_p_dis`reject'

global graphs = 0

count if $sample
matrix fdis`reject' = fdis`reject' , (r(N)\.)

}

matrix fdis_r = fdis0\fdis1
matrix econdis_r = econdis0\econdis1
matrix sigmasdis_r = sigmasdis0\sigmasdis1
matrix astrdis_r = astrdis0\astrdis1
matrix astr25dis_r = astr25dis0\astr25dis1

if $bootstrap {
preserve
use data/bsdis_n_0, clear
rename _b_lambda lambda0
rename _b_ast ast0
rename _b_astr astr0
rename _b_sigma sigma0
rename _b_fracvar fracvar0
gen n = _n
sort n
save data/bsdis_n_0_t, replace
use data/bsdis_n_1, clear
rename _b_lambda lambda1
rename _b_ast ast1
rename _b_astr astr1
rename _b_sigma sigma1
rename _b_fracvar fracvar1
gen n=_n
sort n
merge n using data/bsdis_n_0_t
tab _merge
drop _merge
gen lambdamore = lambda1 < lambda0
gen astmore = ast1 < ast0
gen astrmore = astr1 < astr0
gen sigmamore = sigma1 < sigma0
gen fracvarmore = fracvar1 < fracvar0
tabstat lambdamore astmore astrmore sigmamore fracvarmore , stats(mean) save
matrix more_pvals_n = r(StatTotal)

use data/bsdis_p_0, clear
rename _b_lambda lambda0
rename _b_ast ast0
rename _b_astr astr0
rename _b_sigma sigma0
rename _b_fracvar fracvar0
gen n = _n
sort n
save data/bsdis_p_0_t, replace
use data/bsdis_p_1, clear
rename _b_lambda lambda1
rename _b_ast ast1
rename _b_astr astr1
rename _b_sigma sigma1
rename _b_fracvar fracvar1
gen n=_n
sort n
merge n using data/bsdis_p_0_t
tab _merge
drop _merge
gen lambdamore = lambda1 < lambda0
gen astmore = ast1 < ast0
gen astrmore = astr1 < astr0
gen sigmamore = sigma1 < sigma0
gen fracvarmore = fracvar1 < fracvar0
tabstat lambdamore astmore astrmore sigmamore fracvarmore , stats(mean) save
matrix more_pvals_p = r(StatTotal)

use data/bsdis_f_0, clear
rename _b_lambda lambda0
rename _b_ast ast0
rename _b_astr astr0
rename _b_sigma sigma0
rename _b_fracvar fracvar0
gen n = _n
sort n
save data/bsdis_f_0_t, replace
use data/bsdis_f_1, clear
rename _b_lambda lambda1
rename _b_ast ast1
rename _b_astr astr1
rename _b_sigma sigma1
rename _b_fracvar fracvar1
gen n=_n
sort n
merge n using data/bsdis_f_0_t
tab _merge
drop _merge
gen lambdamore = lambda1 < lambda0
gen astmore = ast1 < ast0
gen astrmore = astr1 < astr0
gen sigmamore = sigma1 < sigma0
gen fracvarmore = fracvar1 < fracvar0
tabstat lambdamore astmore astrmore sigmamore fracvarmore , stats(mean) save
matrix more_pvals_f = r(StatTotal)


matrix tempe = more_pvals_n[1,1..3],more_pvals_p[1,1..3],more_pvals_f[1,1..3]
matrix temps = more_pvals_n[1,4..5],more_pvals_p[1,4..5],more_pvals_f[1,4..5]
matrix econdis_r = econdis_r \ tempe
matrix sigmasdis_r = sigmasdis_r \ temps

restore
}


matrix econdis_out = econdis \ econdis_r 
esttab matrix(econdis_out) using econdis_out.csv, replace
matrix sigmasdis_out = sigmasdis \ sigmasdis_r
esttab matrix(sigmasdis_out) using sigmasdis_out.csv, replace
matrix fdis_out = fdis \ fdis_r
esttab matrix(fdis_out) using fdis_out.csv, replace
matrix astrdis_out = astrdis \ astrdis_r
esttab matrix(astrdis_out) using astrdis_out.csv, replace




label var G_i_dis1 "Reject"
label var G_i_dis0 "No Reject"
label var I_G_dis1 "Reject"
label var I_G_dis0 "No Reject"
sort i_x_p_dis1 i_x_p_dis0
twoway (line G_i_dis1 i_x_p_dis1 if i_x_p_dis1 >-.15 & i_x_p_dis1 < .15 , lpattern(solid) ) (line G_i_dis0 i_x_p_dis0 if i_x_p_dis0 >-.15 & i_x_p_dis0 < .15, lpattern(dash) ) , name(quants_dis, replace) title("CDF of Residual Private Information") xtitle("i(p|X)") ytitle("CDF") subtitle("Disability")
twoway (line I_G_dis1 i_x_p_dis1 if i_x_p_dis1 >-.15 & i_x_p_dis1 < .15 , lpattern(solid) ) (line I_G_dis0 i_x_p_dis0 if i_x_p_dis0 >-.15 & i_x_p_dis0 < .15 , lpattern(dash)) , name(SOSD_dis, replace) title("Integral of CDF") xtitle("i(p|X)") ytitle("Integral of CDF") subtitle("Disability")

graph save quants_dis quants_dis, replace
graph save SOSD_dis SOSD_dis, replace


lpoly astr_dis0 e_x_p_dis0 , noscatter name(astrdis_0_e, replace) title("Disability: Price Ratio by Pr{L|X,z}") subtitle("No Reject") xtitle("Pr{L|X,z}") ytitle("Price Ratio") gen(x_e_dis0 y_e_dis0) n(50)
lpoly astr_dis1 e_x_p_dis1 , noscatter name(astrdis_1_e, replace) title("Disability: Price Ratio by Pr{L|X,z}") subtitle("Reject") xtitle("Pr{L|X,z}") ytitle("Price Ratio") gen(x_e_dis1 y_e_dis1) n(50)
lpoly astr_dis0 G_i_dis0 , noscatter name(astrdis_0_G, replace) title("Disability: Price Ratio by Q(i(z|X))") subtitle("No Reject") xtitle("Q(i(z|X))") ytitle("Price Ratio") gen(x_G_dis0 y_G_dis0) n(50)
lpoly astr_dis1 G_i_dis1 , noscatter name(astrdis_1_G, replace) title("Disability: Price Ratio by Q(i(z|X))") subtitle("Reject") xtitle("Q(i(z|X))") ytitle("Price Ratio") gen(x_G_dis1 y_G_dis1) n(50)

label var x_e_dis0 "No Reject"
label var x_e_dis1 "Reject"
label var y_e_dis0 "No Reject"
label var y_e_dis1 "Reject"
label var x_G_dis0 "No Reject"
label var x_G_dis1 "Reject"
label var y_G_dis0 "No Reject"
label var y_G_dis1 "Reject"

tabstat x_e_dis1 if y_e_dis1 < 2 , stats(max) save
matrix j = r(StatTotal)
local j = j[1,1]
gen x_use_dis0 = 0
replace x_use_dis0 = 1 if x_e_dis0 <= `j'
gen x_use_dis1 = 0
replace x_use_dis1 = 1 if x_e_dis1 <= `j'


twoway (line y_e_dis0 x_e_dis0 if x_use_dis0 == 1 & y_e_dis0 < 2 ) (line y_e_dis1 x_e_dis1 if x_use_dis1 == 1 & y_e_dis1 < 2) , name(astrdis_e, replace) title("Price Ratio by Pr{L|X,z}") subtitle("Disability") xtitle("p=Pr{L|X,z}") ytitle("Price Ratio: p_bar/(1-p_bar) / (p/(1-p))") ysc(r(1 2)) ylabel(1(.2)2)
twoway (line y_G_dis0 x_G_dis0 if y_G_dis0 < 2) (line y_G_dis1 x_G_dis1 if y_G_dis1 < 2) , name(astrdis_G, replace) title("Price Ratio by Q(i(z|X))") subtitle("Disability") xtitle("Q(i(z|X))") ytitle("Price Ratio: p_bar/(1-p_bar) / (p/(1-p))") ysc(r(1 2)) ylabel(1(.2)2)

graph save astrdis_e astrdis_e , replace
graph save astrdis_G astrdis_G , replace






/* Construct F test Table */

matrix F_ltc_temp = fltc[2,1..3]\fltc_r[2,1..3]\fltc_r[4,1..3]
matrix F_ltc = vec(F_ltc_temp)
matrix F_life_temp = flife[2,1..3]\flife_r[2,1..3]\flife_r[4,1..3]
matrix F_life = vec(F_life_temp)
matrix F_dis_temp = fdis[2,1..3]\fdis_r[2,1..3]\fdis_r[4,1..3]
matrix F_dis = vec(F_dis_temp)

matrix F_out = F_ltc , F_life , F_dis
esttab matrix(F_out) using F_out.csv, replace

/* Construct ASTR Table */

matrix temp_ltc = astr25ltc \ astr25ltc0 \ astr25ltc1
matrix temp_dis = astr25dis \ astr25dis0 \ astr25dis1
matrix temp_life = astr25life \ astr25life0 \ astr25life1

matrix astr25_table_ltc = vec(temp_ltc)
matrix astr25_table_life = vec(temp_dis)
matrix astr25_table_dis = vec(temp_life)
matrix astr25_table_out = astr25_table_ltc , astr25_table_dis , astr25_table_life
esttab matrix(astr25_table_out) using astr25_table_out.csv, replace



/* Save Matrices w/o overlapping bootstrapped results */

local boot = $bootstrap
cap esttab matrix(econltc_out) using econltc_out_`boot'.csv, replace
cap esttab matrix(econlife_out) using econlife_out_`boot'.csv, replace
cap esttab matrix(econdis_out) using econdis_out_`boot'.csv, replace
cap esttab matrix(sigmasltc_out) using sigmasltc_out_`boot'.csv, replace
cap esttab matrix(sigmaslife_out) using sigmaslife_out_`boot'.csv, replace
cap esttab matrix(sigmasdis_out) using sigmasdis_out_`boot'.csv, replace
cap esttab matrix(fltc_out) using fltc_out_`boot'.csv, replace
cap esttab matrix(flife_out) using flife_out_`boot'.csv, replace
cap esttab matrix(fdis_out) using fdis_out_`boot'.csv, replace
cap esttab matrix(astrltc_out) using astrltc_out_`boot'.csv, replace
cap esttab matrix(astrlife_out) using astrlife_out_`boot'.csv, replace
cap esttab matrix(astrdis_out) using astrdis_out_`boot'.csv, replace



/* Regression Test */

estout regtest_ltc regtest_dis regtest_life

estout regtest_ltc regtest_dis regtest_life using regtest.txt , cells( b(star fmt(%9.4f)) se(par(`"="("'`")""'))) keep(M_ltc M_life M_dis ) title("Table I") style(tab) stats(N , fmt( 0 0 ) labels(N "No. Obs.")) label collabels(, none) starlevels(* .10 ** .05 *** .01) replace















