


* Input "$finelist" , reject
* Input "$aglist" for aggregation (e.g. age by reject)

tabstat $finelist if $sample, stats(max) save
matrix temp = r(StatTotal)
local jmax = temp[1,1]


matrix define M_temp = J(1,`jmax',-1)
matrix define F = J(1,`jmax',-1)
matrix define reject_track = J(1,`jmax',0)
matrix define reject_N = J(1,`jmax',0)
matrix define mean_risk = J(1,`jmax',0)




forval j = 1(1)`jmax' {
cap drop r_p_`j'

tabstat $reject if $sample & $finelist == `j' , save
matrix reject_track[1,`j'] = r(StatTotal)

count if $sample & $finelist == `j'
matrix reject_N[1,`j'] = r(N)

tabstat $outcome if $sample & $finelist == `j' , stats(mean) save
matrix mean_risk[1,`j'] = r(StatTotal)

*Manually Implement Maximum Standard Errors
*global std_use = "$std"
*if ( `j' == 1 & "$outcome" == "nrshom5y" ) | (`j' == 2 & "$outcome" == "dead" ) {
*global std_use = ""
*}

* Separate Regression from Probit *
if $probit == 0 {
xi: reg $outcome $cov_use $subj_use  if $sample & $finelist == `j' ,  $std_use
test $subj_use
matrix F[1,`j'] = r(p) 
predict temp_e_x_p if $sample & $finelist == `j'

xi: reg $outcome $cov_use if $sample & $finelist == `j' , $std
predict temp_e_x if $sample & temp_e_x_p ~=. & $finelist == `j'
}

if $probit == 1 {

xi: probit $outcome $cov_use $subj_use  if $sample & $finelist == `j' ,  $std_use iter(50)
test $subj_use
matrix F[1,`j'] = r(p) 
predict temp_e_x_p if $sample & $finelist == `j'

xi: probit $outcome $cov_use if $sample & $finelist == `j' , $std iter(50)
predict temp_e_x if $sample & temp_e_x_p ~=. & $finelist == `j'

}
gen temp_i_x_p = temp_e_x_p - temp_e_x if $sample & $finelist == `j'


gsort $aglist - temp_i_x_p 
gen runner = 1 if _n == 1
replace runner = (runner[_n-1]+1)*($aglist[_n-1]==$aglist[_n]) + ($aglist[_n-1]~=$aglist[_n]) if _n > 1
by $aglist : gen temp_m = sum(temp_i_x_p) / runner - temp_i_x_p if $sample  & $finelist == `j'


tabstat temp_m if $sample & $finelist == `j' , save stats(mean)

matrix M_temp[1,`j'] = r(StatTotal)


if $graphs {

gen r_p_`j' = temp_i_x_p if $sample & $finelist == `j'

if `j' == 1 {
gen temper = temp_m if $sample & $finelist == `j'
}
if `j' > 1 {
replace temper = temp_m if $sample & $finelist == `j'
}

}
drop temp_e_x_p temp_e_x temp_i_x_p runner temp_m

}

	
if $graphs {
tabstat $rollup if $sample, stats(max) save
matrix temp = r(StatTotal)
local rmax = temp[1,1]
tabstat temper , save by($rollup)
local colnames = ""
forval r = 1(1)`rmax' {
if `r' == 1  {
matrix M_a = r(Stat`r')
}
if `r' > 1 {
matrix temp = r(Stat`r')
matrix colnames temp = "r`r'"
matrix M_a = M_a , temp
}
matrix M = M_temp , M_a
}
drop temper
}
if $graphs == 0 {
matrix M = M_temp
}


