


* Input "$finelist" , reject
* Input $aglist - provides aggregation by which construction of E[M(X)] occurs

tabstat $finelist if $sample, stats(max) save
matrix temp = r(StatTotal)
local jmax = temp[1,1]


matrix define M = J(1,`jmax',-1)
matrix define reject_track = J(1,`jmax',0)
matrix define reject_N = J(1,`jmax',0)
matrix define mean_risk = J(1,`jmax',0)

_rmcoll $cov , forcedrop
global cov `r(varlist)'
_rmcoll $subj , forcedrop
global subj `r(varlist)'


* New Analysis

xi: reg $outcome $cov $subj  if $sample  ,  $std
predict temp_e_x_p_all if $sample

xi: reg $outcome $cov if $sample , $std
predict temp_e_x_all if $sample & temp_e_x_p ~=. 

gen temp_i_x_p = temp_e_x_p_all - temp_e_x_all if $sample & temp_e_x_p ~=. 
gsort $aglist - temp_i_x_p 
gen runner = 1 if _n == 1
replace runner = (runner[_n-1]+1)*($aglist[_n-1]==$aglist[_n]) + ($aglist[_n-1]~=$aglist[_n]) if _n > 1
by $aglist : gen temp_m = sum(temp_i_x_p) / runner - temp_i_x_p if $sample 

tabstat temp_m , by($finelist) save
forval j = 1(1)`jmax' {
matrix M[1,`j'] = r(Stat`j')
}
tabstat $reject if $sample , by($finelist) save
forval j = 1(1)`jmax' {
matrix reject_track[1,`j'] = r(Stat`j')
}
tabstat $outcome if $sample , stats(mean) save
forval j = 1(1)`jmax' {
matrix mean_risk[1,`j'] = r(Stat`j')
}
forval j = 1(1)`jmax' {
count if $sample & $finelist == `j'
matrix reject_N[1,`j'] = r(N)
}


/*


forval j = 1(1)`jmax' {
tabstat $reject if $sample & $finelist == `j' , save
matrix reject_track[1,`j'] = r(StatTotal)

count if $sample & $finelist == `j'
matrix reject_N[1,`j'] = r(N)

tabstat $outcome if $sample & $finelist == `j' , stats(mean) save
matrix mean_risk[1,`j'] = r(StatTotal)

gen temp_e_x_p = temp_e_x_p_all if $sample & $finelist == `j'
gen temp_e_x = temp_e_x_all if $sample & temp_e_x_p ~=. & $finelist == `j'

gen temp_i_x_p = temp_e_x_p - temp_e_x if $sample & $finelist == `j'
sort temp_i_x_p

gsort - temp_i_x_p
gen temp_i_x_p_bar = sum(temp_i_x_p) / _n if $sample & $finelist == `j'
gen M = temp_i_x_p_bar - temp_i_x_p

tabstat M , stats(mean) save
matrix M[1,`j'] = r(StatTotal)


drop temp_e_x_p temp_e_x temp_i_x_p temp_i_x_p_bar M

}

*/

drop temp_e_x_p_all temp_e_x_all temp_i_x_p runner temp_m 

