
matrix stat = J(1,12,.)
matrix econ = J(1,3,.)
matrix f = J(1,2,.)
matrix sigmas = J(1,2,.)
matrix lambdas = J(1,3,.)
matrix astr = J(1,10,-1)
matrix astr25 = J(1,1,-1)

tabstat $outcome if $sample , stats(mean sd) save
matrix temp = r(StatTotal)
local base = temp[1,1]
matrix var_L = temp[2,1]*temp[2,1]

xi: reg $outcome $cov $subj  if $sample ,  $std
test  $subj
matrix stat[1,1] = r(F)
matrix stat[1,2] = r(p)
matrix f[1,1] = r(F)
matrix f[1,2] = r(p)
matrix r2_z = e(r2)

predict e_x_p if $sample

xi: reg $outcome $cov if $sample , $std
matrix r2 = e(r2)
matrix stat[1,3] = (r2_z[1,1]-r2[1,1])/(1-r2[1,1])
matrix stat[1,4] = (1-r2[1,1])*var_L[1,1]
predict e_x if $sample & e_x_p ~=.
gen i_x_p = e_x_p - e_x
tabstat i_x_p if $sample , stats(sd p5 p10 p25 p50 p75 p90 p95) save
matrix temp = r(StatTotal)
matrix stat[1,5] = temp'
matrix sigmas[1,1] = stat[1,5]
matrix sigmas[1,2] = stat[1,3]
matrix quant = temp[2...,1]'


*Lambda*

gen lambda_t_plus = 0 if $sample
replace lambda_t_plus = i_x_p/(e_x*(1-e_x)) if $sample & i_x_p > 0 & e_x >.01 & e_x < .99
gen lambda_t_minus = 0 if $sample
replace lambda_t_minus = i_x_p/(e_x*(1-e_x)) if $sample & i_x_p < 0 & e_x >.01 & e_x < .99

tabstat lambda_t_plus if $sample , save
matrix lambdas[1,2] = r(StatTotal)
tabstat lambda_t_minus if $sample , save
matrix lambdas[1,3] = r(StatTotal)
matrix econ[1,1] = .5*(lambdas[1,2]-lambdas[1,3])


*Adverse Selection Tax Level and Rate
tabstat i_x_p if $sample & i_x_p > 0 , save
matrix econ[1,2] = r(StatTotal)

gen astr_m = i_x_p/e_x if $sample
tabstat astr_m if $sample & i_x_p > 0 & e_x > .01 & e_x < .99, save
matrix econ[1,3] = r(StatTotal)



* Adverse Selection Tax Rate for each person

gsort - i_x_p
gen i_x_p_bar = sum(i_x_p) / _n if $sample
gen p_bar = e_x + i_x_p_bar if $sample
replace p_bar = .995 if p_bar > .995 & $sample
replace p_bar = .005 if p_bar < .005 & $sample
gen astr = (p_bar / (1-p_bar)) / (e_x_p / (1-e_x_p)) if $sample & e_x_p > .01 & e_x_p < .99

tabstat astr if $sample , stats(p25) save
matrix astr25[1,1] = r(StatTotal)


sort i_x_p
cumul i_x_p if $sample , gen(G_i_out)
sort i_x_p G_i_out
gen I_G_t = 0 if _n == 1
replace I_G_t = (i_x_p[_n] - i_x_p[_n-1])*(G_i_out[_n-1]+.5*(G_i_out[_n]-G_i_out[_n-1])) if $sample
gen I_G_out = sum(I_G_t) if $sample
drop I_G_t

foreach a in 1 2 3 4 5 6 7 8 9 10 {
tabstat astr if $sample & G_i_out <= `a'/10 & G_i_out > (`a'-1) / 10, save
matrix t = r(StatTotal)
if matmissing(t) == 0 { 
matrix astr[1,`a'] = r(StatTotal) 
} 
}

tabstat astr if $sample


rename G_i_out G_i_local
rename I_G_out I_G_local

if $graphs {
gen G_i_out = G_i_local
gen I_G_out = I_G_local
gen astr_out = astr
gen e_x_p_out = e_x_p
gen i_x_p_out = i_x_p
}


drop e_x e_x_p i_x_p  G_i_local I_G_local astr i_x_p_bar p_bar lambda_t_plus lambda_t_minus astr_m



