function f_p_X_use = f_p_X_use(p,q,parameters,num_beta)


cut = .005;

q = q.*(q<1-cut).*(q>cut) + cut.*(q<=cut) + (1-cut).*(q>=1-cut);


% Input vector is 3*num_beta long

w_i = parameters(1);
if num_beta > 1
v_t = parameters(2:num_beta);
v = [v_t ; 1-sum(v_t)];
end
if num_beta == 1
    v = 1;
end

%v = parameters(1:num_beta);                 % v is weight on mixes
w = parameters(num_beta+1:2*num_beta);      % w is weight on lower betas
a = parameters(2*num_beta+1:3*num_beta);           % a is q-mu_q added together
a_i = parameters(3*num_beta+1);             % center of main beta
%w_i = max(1-sum(v),0);                       % weight on main beta

%s_lower = parameters(3*num_beta+1:4*num_beta);
%s_upper = parameters(4*num_beta+1:end-1);
s_noncentral = parameters(end-1);
s_lower = ones(size(v,1),1).*s_noncentral;
s_upper = ones(size(v,1),1).*s_noncentral;
s_central = parameters(end);                        % Central variance

b = tril(ones(num_beta,num_beta),0)*a;


%% Trim to [0,1] interval

% Trim initial beta vs. rest of the betas

A = q-a_i;                    % Mean of uninformed distribution if no censoring
B = q+(w_i./(1-w_i)).*a_i;         % Mean of informed (Beta) distribution if no censoring
C = q./(1-w_i);               % Mean of informed (Beta) distribution if uninformed == 0
D = (q-w_i)./(1-w_i);           % Mean of informed (Beta) distribution if uninformed == 1
E = (q-(1-w_i).*cut)./w_i;       % Mean of uninformed distribution if informed == cut
F = (q-(1-w_i).*(1-cut))./w_i;   % Mean of uninformed distribution if informed == 1-cut

A_1 = (A < 1-cut);          % Indicator that lower betas is not above 1-cut 
A_0 = (A > cut);            % Indicator that lower betas are not below cut 
B_0 = (B > cut);            % Indicator that upper betas are not below cut 
B_1 = (B < 1-cut);          % Indicator that upper betas are not above 1-cut 
C_1 = (C < 1-cut);          % Indicator that the upper betas are not above 1-cut when the lower betas are equal to cut 
D_0 = (C > cut);            % Indicator that the upper betas are not below cut when the lower betas equal 1-cut 
E_1 = (E < 1-cut);          % Indicator that the lower betas are not above 1-cut when the upper betas equal cut 
F_0 = (F > cut);            % Indicator that the lower betas are not below cut when the upper betas equal 1-cut 

                            % Note that E_1 and F_0 allow me to know when
                            % the distribution has been pinned at 0 and 1
                            % (or cut/1-cut) so that we can adjust the
                            % weight, w, so that the mean stays equal to q

% Construct mean of informed and uninformed distributions (accounting for censoring)

mu_inf = A_1.*A_0.*B_1.*B_0.*B + (1-A_0).*(1-B_1).*(C_1.*C + (1-C_1).*(1-cut)) + (1-A_0).*B_1.*C + (1-B_1).*A_0.*(1-cut) + (1-A_1).*(1-B_0).*(D_0.*D + (1-D_0).*cut) + (1-A_1).*B_0.*D + (1-B_0).*A_1.*cut;

mu_uninf = A_1.*A_0.*B_1.*B_0.*A + A_0.*(1-B_1).*F + (1-A_1).*(1-B_0).*1 + (1-A_1).*B_0.*1 + (1-B_0).*A_1.*E;

mu_uninf = (mu_uninf==0).*cut + (mu_uninf~=0).*mu_uninf;

% Construct weights (adjusted in the event that the uninformed & informed are at corners

w_0_1 = ((1-cut-q)./(1-2*cut));      % Uninformed = 0 & Informed = 1-cut
w_1_0 = ((q-cut)./(1-2*cut));        % Uninformed = 1 & Informed = cut

wi_use = (1 - (1-A_0).*(1-B_1).*(1-C_1) - (1-A_1).*(1-B_0).*(1-D_0)).*w_i + (1-A_0).*(1-B_1).*(1-C_1).*(w_0_1) + (1-A_1).*(1-B_0).*(1-D_0).*w_1_0;











o_n = ones(num_beta,1);
o_q = ones(size(q,1),1);
    
A = mu_inf*o_n'-o_q*b';                                     % Mean of lower betas if no censoring
B = mu_inf*o_n'+o_q*((w./(1-w)).*b)';                       % Mean of upper beta if no censoring
C = (mu_inf*o_n'-(o_q*w').*cut)./(o_q*(o_n'-w'));           % Mean of upper beta if lower beta == cut 
D = (mu_inf*o_n'-(o_q*w').*(1-cut))./(o_q*(o_n'-w'));       % Mean of upper beta if lower beta = 1-cut 
E = (mu_inf*o_n'-o_q*(o_n'-w').*cut)./(o_q*w');             % Mean of lower beta if upper beta == cut
F = (mu_inf*o_n'-o_q*(o_n'-w').*(1-cut))./(o_q*w');         % Mean of lower beta if upper beta == 1-cut 

A_1 = (A < 1-cut);          % Indicator that lower betas is not above 1-cut 
A_0 = (A > cut);            % Indicator that lower betas are not below cut 
B_0 = (B > cut);            % Indicator that upper betas are not below cut 
B_1 = (B < 1-cut);          % Indicator that upper betas are not above 1-cut 
C_1 = (C < 1-cut);          % Indicator that the upper betas are not above 1-cut when the lower betas are equal to cut 
D_0 = (C > cut);            % Indicator that the upper betas are not below cut when the lower betas equal 1-cut 
E_1 = (E < 1-cut);          % Indicator that the lower betas are not above 1-cut when the upper betas equal cut 
F_0 = (F > cut);            % Indicator that the lower betas are not below cut when the upper betas equal 1-cut 

                            % Note that E_1 and F_0 allow me to know when
                            % the distribution has been pinned at 0 and 1
                            % (or cut/1-cut) so that we can adjust the
                            % weight, w, so that the mean stays equal to q
%% 
% Construct mean of informed and uninformed distributions (accounting for censoring)

%mu_beta_upper = A_0.*B_1.*B + (1-B_1).*(1-cut) + (1-A_0).*B_1.*(C_1.*C+(1-C_1).*(1-cut));

%mu_beta_lower = A_0.*B_1.*A + (1-A_0).*cut + A_0.*(1-B_1).*(F_0.*F+(1-F_0).*cut);

mu_beta_upper = A_1.*A_0.*B_1.*B_0.*B + (1-A_0).*(1-B_1).*(C_1.*C + (1-C_1).*(1-cut)) + (1-A_0).*B_1.*C + (1-B_1).*A_0.*(1-cut) + (1-A_1).*(1-B_0).*(D_0.*D + (1-D_0).*cut) + (1-A_1).*B_0.*D + (1-B_0).*A_1.*cut;

mu_beta_lower = A_1.*A_0.*B_1.*B_0.*A + A_0.*(1-B_1).*F + (1-A_1).*(1-B_0).*1 + (1-A_1).*B_0.*1 + (1-B_0).*A_1.*E;

mu_beta_lower = (mu_beta_lower==0).*cut + (mu_beta_lower~=0).*mu_beta_lower;

% Construct weights (adjusted in the event that the uninformed & informed are at corners

w_0_1 = ((1-cut-q)./(1-2*cut))*o_n';      % Uninformed = 0 & Informed = 1-cut
w_1_0 = ((q-cut)./(1-2*cut))*o_n';        % Uninformed = 1 & Informed = cut

w_use = (mu_beta_upper == 1-cut).*(mu_beta_lower == cut).*w_0_1 + (1-(mu_beta_upper == 1-cut).*(mu_beta_lower == cut)).*(o_q*w');
%w_use = (1 - (1-A_0).*(1-B_1).*(1-C_1) - (1-A_1).*(1-B_0).*(1-D_0)).*(o_q*w') + (1-A_0).*(1-B_1).*(1-C_1).*(w_0_1) + (1-A_1).*(1-B_0).*(1-D_0).*w_1_0;


%mu_beta_lower.*w_use + (1-w_use).*mu_beta_upper

%% Construct Betas 

    
% mu_beta_c = q;

% Alphas and Betas

alpha_1 = (mu_beta_lower.*(o_q*s_lower') > 1);
beta_1 = ((1-mu_beta_lower).*(o_q*s_lower') > 1);
alpha_2 = (mu_beta_upper.*(o_q*s_upper') > 1);
beta_2 = ((1-mu_beta_upper).*(o_q*s_upper') > 1);
alpha_c = (mu_uninf.*s_central > 1);
beta_c = ((1-mu_uninf).*s_central > 1);

v_use_1 = alpha_1.*beta_1.*(o_q*s_lower') + (1-alpha_1.*beta_1).*max(1./mu_beta_lower,1./(1-mu_beta_lower));
v_use_2 = alpha_2.*beta_2.*(o_q*s_upper') + (1-alpha_2.*beta_2).*max(1./mu_beta_upper,1./(1-mu_beta_upper));
v_use_c = alpha_c.*beta_c.*s_central + (1-alpha_c.*beta_c).*max(1./q,1./(1-q));

alpha_use_1 = mu_beta_lower.*v_use_1;
beta_use_1 = (1-mu_beta_lower).*v_use_1;
alpha_use_2 = mu_beta_upper.*v_use_2;
beta_use_2 = (1-mu_beta_upper).*v_use_2;
alpha_use_c = mu_uninf.*v_use_c;
beta_use_c = (1-mu_uninf).*v_use_c;

mixes = betapdf(p,alpha_use_1,beta_use_1).*w_use + betapdf(p,alpha_use_2,beta_use_2).*(1-w_use);
center = betapdf(p,alpha_use_c,beta_use_c);
f_p_X_use = center.*wi_use + (1-wi_use).*(mixes*v);

end







