function ln_like_X = ln_like_X(L,z,q,parameters,other,num_beta)


% num_beta = 2;

%% Set Parameters


% Cut

cut = .005;

q = q.*(q<1-cut).*(q>cut) + cut.*(q<=cut) + (1-cut).*(q>=1-cut);

tol = 1e-6; % Tolerance choice for quadv - 1e-4 increases speed...but may cause problems...

% Parameters

para_z_p = parameters(1:end-3*num_beta-4);
para_p = parameters(end-3*num_beta-3:end);
para_p_inf = para_p(2:end);

%% Make Likelihood

frac_uninf = para_p(1);

w_i = para_p_inf(1);
if num_beta > 1
v_t = para_p_inf(2:num_beta);
v = [v_t ; 1-sum(v_t)];
end
if num_beta == 1
    v = 1;
    v_t = 1;
end

%v = parameters(1:num_beta);                 % v is weight on mixes
w = para_p_inf(num_beta+1:2*num_beta);      % w is weight on lower betas
a = para_p_inf(2*num_beta+1:3*num_beta);           % a is q-mu_q added together
a_i = para_p_inf(3*num_beta+1);             % center of main beta
%w_i = max(1-sum(v),0);                       % weight on main beta

%s_lower = parameters(3*num_beta+1:4*num_beta);
%s_upper = parameters(4*num_beta+1:end-1);
s_noncentral = para_p_inf(end-1);
s_lower = ones(size(v,1),1).*s_noncentral;
s_upper = ones(size(v,1),1).*s_noncentral;
s_central = para_p_inf(end);                        % Central variance

b = tril(ones(num_beta,num_beta),0)*a;


s_v = sum(v_t);

    temp_inf = quadv(@(p) (p.^L).*((1-p).^(1-L)).*f_z_p_X_use(p,z,q,para_z_p,other).*f_p_X_use(p,q,para_p_inf,num_beta),0,1,tol);
    
    % Uninformed
    temp_uninf = (q.^L).*((1-q).^(1-L)).*f_z_p_X_use(q,z,q,para_z_p,other);
    temp1 = frac_uninf.*temp_uninf + (1-frac_uninf).*temp_inf;
    temp2 = temp1.*(temp1 > 0) + (10^-8)*(temp1 <= 0);

ln_like_X_temp = -sum(log(temp2));

if (max(b) >= 1) || (s_v > 1)
    ln_like_X_temp = 10^8;
end

ln_like_X = ln_like_X_temp;

