function ln_like_X_use = ln_like_X_use(L,z,q,parameters,other,num_beta)


% num_beta = 2;

%% Set Parameters


% Cut

cut = .005;

q = q.*(q<1-cut).*(q>cut) + cut.*(q<=cut) + (1-cut).*(q>=1-cut);

tol = 1e-4; % Tolerance choice - increases speed...

% Parameters

para_z_p = parameters(1:end-3*num_beta-3);
para_p = parameters(end-3*num_beta-2:end);

%% Make Likelihood


w_i = para_p(1);
if num_beta > 1
v_t = para_p(2:num_beta);
v = [v_t ; 1-sum(v_t)];
end
if num_beta == 1
    v = 1;
    v_t = 1;
end

%v = parameters(1:num_beta);                 % v is weight on mixes
w = para_p(num_beta+1:2*num_beta);      % w is weight on lower betas
a = para_p(2*num_beta+1:3*num_beta);           % a is q-mu_q added together
a_i = para_p(3*num_beta+1);             % center of main beta
%w_i = max(1-sum(v),0);                       % weight on main beta

%s_lower = parameters(3*num_beta+1:4*num_beta);
%s_upper = parameters(4*num_beta+1:end-1);
s_noncentral = para_p(end-1);
s_lower = ones(size(v,1),1).*s_noncentral;
s_upper = ones(size(v,1),1).*s_noncentral;
s_central = para_p(end);                        % Central variance

b = tril(ones(num_beta,num_beta),0)*a;


s_v = sum(v_t);

    temp_inf = quadv(@(p) f_dens_X_inf_use(p,L,z,q,parameters,other,num_beta),0,1,tol);
    temp1 = temp_inf;
    temp2 = temp1.*(temp1 > 0) + (10^-8)*(temp1 <= 0);
    
ln_like_X_use_temp = -sum(log(temp2));

if (max(b) >= 1) || (s_v > 1)
    ln_like_X_use_temp = 10^8;
end

ln_like_X_use = ln_like_X_use_temp;

