%% Make Figures for Paper

close all
clear

vol = 'nhendren'

%% Private Information

%% LTC
makegraphs_ltc
ltc_table = [pt_r' ; ci_low_r' ; ci_high_r' ; pt_nr' ; ci_low_nr' ; ci_high_nr' ; pt_diff' ; ci_low_diff' ; ci_high_diff'];
ltc_table_q = [pt_r(2) , pt_q_r(2,:) ; ci_low_r(2) , ci_low_q_r(2,:) ; ci_high_r(2) , ci_high_q_r(2,:) ; center_r , q_dis_r' ; pt_nr(2) , pt_q_nr(2,:) ; ci_low_nr(2) , ci_low_q_nr(2,:) ; ci_high_nr(2) , ci_high_q_nr(2,:) ; center_nr , q_dis_nr' ; pt_diff(2) , pt_diff_q(2,:) ; ci_low_diff(2) , ci_low_diff_q(2,:) ; ci_high_diff(2) , ci_high_diff_q(2,:) ];

cd /Users/nhendren/Research/'Insurance - Empirical'/'HRS Analysis'/Drafts
saveas(pdf_fig,'ltc_pdf.eps','epsc')
saveas(pdf_fig_std,'ltc_pdf_std.eps','epsc')
saveas(cdf_fig,'ltc_cdf.eps','epsc')
saveas(T_fig,'ltc_T.eps','epsc')
save('table_4','ltc_table','ltc_table_q');
cd /Users/nhendren

%% Dis
makegraphs_dis
dis_table = [pt_r' ; ci_low_r' ; ci_high_r' ; pt_nr' ; ci_low_nr' ; ci_high_nr' ; pt_diff' ; ci_low_diff' ; ci_high_diff'];
dis_table_q = [pt_r(2) , pt_q_r(2,:) ; ci_low_r(2) , ci_low_q_r(2,:) ; ci_high_r(2) , ci_high_q_r(2,:) ; center_r , q_dis_r' ; pt_nr(2) , pt_q_nr(2,:) ; ci_low_nr(2) , ci_low_q_nr(2,:) ; ci_high_nr(2) , ci_high_q_nr(2,:) ; center_nr , q_dis_nr' ; pt_diff(2) , pt_diff_q(2,:) ; ci_low_diff(2) , ci_low_diff_q(2,:) ; ci_high_diff(2) , ci_high_diff_q(2,:) ];
cd /Users/nhendren/Research/'Insurance - Empirical'/'HRS Analysis'/Drafts
saveas(pdf_fig,'dis_pdf.eps','epsc')
saveas(pdf_fig_std,'dis_pdf_std.eps','epsc')
saveas(cdf_fig,'dis_cdf.eps','epsc')
saveas(T_fig,'dis_T.eps','epsc')
save('table_4','dis_table','dis_table_q','-append');
cd /Users/nhendren

%% Life
makegraphs_life
life_table = [pt_r' ; ci_low_r' ; ci_high_r' ; pt_nr' ; ci_low_nr' ; ci_high_nr' ; pt_diff' ; ci_low_diff' ; ci_high_diff'];
life_table_q = [pt_r(2) , pt_q_r(2,:) ; ci_low_r(2) , ci_low_q_r(2,:) ; ci_high_r(2) , ci_high_q_r(2,:) ; center_r , q_dis_r' ; pt_nr(2) , pt_q_nr(2,:) ; ci_low_nr(2) , ci_low_q_nr(2,:) ; ci_high_nr(2) , ci_high_q_nr(2,:) ; center_nr , q_dis_nr' ; pt_diff(2) , pt_diff_q(2,:) ; ci_low_diff(2) , ci_low_diff_q(2,:) ; ci_high_diff(2) , ci_high_diff_q(2,:) ];
cd /Users/nhendren/Research/'Insurance - Empirical'/'HRS Analysis'/Drafts
saveas(pdf_fig,'life_pdf.eps','epsc')
saveas(pdf_fig_std,'life_pdf_std.eps','epsc')
saveas(cdf_fig,'life_cdf.eps','epsc')
saveas(T_fig,'life_T.eps','epsc')

load('table_4')
table = [ltc_table , dis_table , life_table ];
table_q = [ltc_table_q , dis_table_q , life_table_q ];
save('table_inf_T','table','-ascii','-tabs')
save('table_inf_T_q','table_q','-ascii','-tabs')
cd /Users/nhendren

%% Annuities

%makegraphs_annuity
%table_annuity = [pt_r' ; ci_low_r' ; ci_high_r' ; pt_nr' ; ci_low_nr' ; ci_high_nr'];
%cd /Users/nhendren/Research/'Insurance - Empirical'/'HRS Analysis'/Drafts
%save('table_annuity','table_annuity','-ascii','-tabs')
%cd /Volumes/nhendren/'HRSAnalysis'/matlab



%% Measurement Error Distribution

% LTC
load('est_ltc_r_uf')
est = est_final(1:4);
load('est_ltc_r_boot_par_uf')
boots = boot_est(1:4,:);

breps = size(boots,2);

error_sort = sort(boots,2);

comp = est*ones(1,breps);
C_theta = mean(boots < comp,2);
z_zero = norminv(C_theta);
low_95 = normcdf(2*z_zero - 1.96);
high_95 = normcdf(2*z_zero + 1.96);
index_low = max(ones(size(est,1),1),floor(low_95*breps));
index_high = max(ones(size(est,1),1),ceil(high_95*breps));
ci_low = zeros(size(est,1),1);
ci_high = zeros(size(est,1),1);
for j = 1:size(est,1)
    ci_low(j,1) = error_sort(j,index_low(j));
    ci_high(j,1) = error_sort(j,index_high(j));
end

boot_std = std(boots,0,2);
temp = [est,boot_std,ci_low,ci_high]';
meas_ltc_r = temp(:);


load('est_ltc_nr_f')
est = est_final(1:4);
load('est_ltc_nr_boot_f')
boots = boot_est(1:4,:);

breps = size(boots,2);

error_sort = sort(boots,2);

comp = est*ones(1,breps);
C_theta = mean(boots < comp,2);
z_zero = norminv(C_theta);
low_95 = normcdf(2*z_zero - 1.96);
high_95 = normcdf(2*z_zero + 1.96);
index_low = max(ones(size(est,1),1),floor(low_95*breps));
index_high = max(ones(size(est,1),1),ceil(high_95*breps));
ci_low = zeros(size(est,1),1);
ci_high = zeros(size(est,1),1);
for j = 1:size(est,1)
    ci_low(j,1) = error_sort(j,index_low(j));
    ci_high(j,1) = error_sort(j,index_high(j));
end

boot_std = std(boots,0,2);
temp = [est,boot_std,ci_low,ci_high]';
meas_ltc_nr = temp(:);



% Disability

load('est_dis_r_uf')
est = est_final(1:4);
load('est_dis_r_boot_par_uf')
boots = boot_est(1:4,:);

breps = size(boots,2);

error_sort = sort(boots,2);

comp = est*ones(1,breps);
C_theta = mean(boots < comp,2);
z_zero = norminv(C_theta);
low_95 = normcdf(2*z_zero - 1.96);
high_95 = normcdf(2*z_zero + 1.96);
index_low = max(ones(size(est,1),1),floor(low_95*breps));
index_high = max(ones(size(est,1),1),ceil(high_95*breps));
ci_low = zeros(size(est,1),1);
ci_high = zeros(size(est,1),1);
for j = 1:size(est,1)
    ci_low(j,1) = error_sort(j,index_low(j));
    ci_high(j,1) = error_sort(j,index_high(j));
end

boot_std = std(boots,0,2);
temp = [est,boot_std,ci_low,ci_high]';
meas_dis_r = temp(:);


load('est_dis_nr_f')
est = est_final(1:4);
load('est_dis_nr_boot_f')
boots = boot_est(1:4,:);

breps = size(boots,2);

error_r_mean = mean(boots,2);
error_sort = sort(boots,2);

comp = est*ones(1,breps);
C_theta = mean(boots < comp,2);
z_zero = norminv(C_theta);
low_95 = normcdf(2*z_zero - 1.96);
high_95 = normcdf(2*z_zero + 1.96);
index_low = max(ones(size(est,1),1),floor(low_95*breps));
index_high = max(ones(size(est,1),1),ceil(high_95*breps));
ci_low = zeros(size(est,1),1);
ci_high = zeros(size(est,1),1);
for j = 1:size(est,1)
    ci_low(j,1) = error_sort(j,index_low(j));
    ci_high(j,1) = error_sort(j,index_high(j));
end

boot_std = std(boots,0,2);
temp = [est,boot_std,ci_low,ci_high]';
meas_dis_nr = temp(:);



% Life


load('est_life_r_uf')
est = est_final(1:4);
load('est_life_r_boot_par_uf')
boots = boot_est(1:4,:);

breps = size(boots,2);

error_sort = sort(boots,2);

comp = est*ones(1,breps);
C_theta = mean(boots < comp,2);
z_zero = norminv(C_theta);
low_95 = normcdf(2*z_zero - 1.96);
high_95 = normcdf(2*z_zero + 1.96);
index_low = max(ones(size(est,1),1),floor(low_95*breps));
index_high = max(ones(size(est,1),1),ceil(high_95*breps));
ci_low = zeros(size(est,1),1);
ci_high = zeros(size(est,1),1);
for j = 1:size(est,1)
    ci_low(j,1) = error_sort(j,index_low(j));
    ci_high(j,1) = error_sort(j,index_high(j));
end

boot_std = std(boots,0,2);
temp = [est,boot_std,ci_low,ci_high]';
meas_life_r = temp(:);


load('est_life_nr_uf')
est = est_final(1:4);
load('est_life_nr_boot_par_uf')
boots = boot_est(1:4,:);

breps = size(boots,2);

error_r_mean = mean(boots,2);
error_sort = sort(boots,2);

comp = est*ones(1,breps);
C_theta = mean(boots < comp,2);
z_zero = norminv(C_theta);
low_95 = normcdf(2*z_zero - 1.96);
high_95 = normcdf(2*z_zero + 1.96);
index_low = max(ones(size(est,1),1),floor(low_95*breps));
index_high = max(ones(size(est,1),1),ceil(high_95*breps));
ci_low = zeros(size(est,1),1);
ci_high = zeros(size(est,1),1);
for j = 1:size(est,1)
    ci_low(j,1) = error_sort(j,index_low(j));
    ci_high(j,1) = error_sort(j,index_high(j));
end

boot_std = std(boots,0,2);
temp = [est,boot_std,ci_low,ci_high]';
meas_life_nr = temp(:);




% Export

meas_table = [meas_ltc_nr , meas_ltc_r , meas_dis_nr , meas_dis_r , meas_life_nr , meas_life_r]

%meas_table = [meas_table(3:4,:);meas_table(1:2,:);meas_table(5:8,:)];

cd /Users/nhendren/Research/'Insurance - Empirical'/'HRS Analysis'/Drafts
save('meas_table','meas_table','-ascii','-tabs')
cd /Users/nhendren




%% Beta Mix Parameters

% LTC
load('est_ltc_r_uf')
est = est_final(5:end);
load('est_ltc_r_boot_par_uf')
boots = boot_est(5:end,:);

est = [est(1);est(2)*(1-est(1));est(3:end)];
boots = [boots(1,:);boots(2,:).*(1-boots(1,:));boots(3:end,:)];

breps = size(boots,2);

error_sort = sort(boots,2);

comp = est*ones(1,breps);
C_theta = mean(boots < comp,2);
z_zero = norminv(C_theta);
low_95 = normcdf(2*z_zero - 1.96);
high_95 = normcdf(2*z_zero + 1.96);
index_low = max(ones(size(est,1),1),floor(low_95*breps));
index_high = max(ones(size(est,1),1),ceil(high_95*breps));
ci_low = zeros(size(est,1),1);
ci_high = zeros(size(est,1),1);
for j = 1:size(est,1)
    ci_low(j,1) = error_sort(j,index_low(j));
    ci_high(j,1) = error_sort(j,index_high(j));
end

boot_std = std(boots,0,2);
temp = [est,boot_std,ci_low,ci_high]';
meas_ltc_r = temp(:);


load('est_ltc_nr_f')
est = est_final(5:end);
load('est_ltc_nr_boot_f')
boots = boot_est(5:end,:);

est = [est(1);(1-est(1))*est(2);(1-est(1))*est(3)*(1-est(2));est(4:end)];
boots = [boots(1,:);(1-boots(1,:)).*boots(2,:);(1-boots(1,:)).*boots(3,:).*(1-boots(2,:));boots(4:end,:)];

breps = size(boots,2);

error_sort = sort(boots,2);

comp = est*ones(1,breps);
C_theta = mean(boots < comp,2);
z_zero = norminv(C_theta);
low_95 = normcdf(2*z_zero - 1.96);
high_95 = normcdf(2*z_zero + 1.96);
index_low = max(ones(size(est,1),1),floor(low_95*breps));
index_high = max(ones(size(est,1),1),ceil(high_95*breps));
ci_low = zeros(size(est,1),1);
ci_high = zeros(size(est,1),1);
for j = 1:size(est,1)
    ci_low(j,1) = error_sort(j,index_low(j));
    ci_high(j,1) = error_sort(j,index_high(j));
end

boot_std = std(boots,0,2);
temp = [est,boot_std,ci_low,ci_high]';
meas_ltc_nr = temp(:);



% Disability

load('est_dis_r_uf')
est = est_final(5:end);
load('est_dis_r_boot_par_uf')
boots = boot_est(5:end,:);

est = [est(1);est(2)*(1-est(1));est(3:end)];
boots = [boots(1,:);boots(2,:).*(1-boots(1,:));boots(3:end,:)];

breps = size(boots,2);

error_sort = sort(boots,2);

comp = est*ones(1,breps);
C_theta = mean(boots < comp,2);
z_zero = norminv(C_theta);
low_95 = normcdf(2*z_zero - 1.96);
high_95 = normcdf(2*z_zero + 1.96);
index_low = max(ones(size(est,1),1),floor(low_95*breps));
index_high = max(ones(size(est,1),1),ceil(high_95*breps));
ci_low = zeros(size(est,1),1);
ci_high = zeros(size(est,1),1);
for j = 1:size(est,1)
    ci_low(j,1) = error_sort(j,index_low(j));
    ci_high(j,1) = error_sort(j,index_high(j));
end

boot_std = std(boots,0,2);
temp = [est,boot_std,ci_low,ci_high]';
meas_dis_r = temp(:);


load('est_dis_nr_f')
est = est_final(5:end);
load('est_dis_nr_boot_f')
boots = boot_est(5:end,:);

est = [est(1);(1-est(1))*est(2);(1-est(1))*est(3)*(1-est(2));est(4:end)];
boots = [boots(1,:);(1-boots(1,:)).*boots(2,:);(1-boots(1,:)).*boots(3,:).*(1-boots(2,:));boots(4:end,:)];

breps = size(boots,2);

error_r_mean = mean(boots,2);
error_sort = sort(boots,2);

comp = est*ones(1,breps);
C_theta = mean(boots < comp,2);
z_zero = norminv(C_theta);
low_95 = normcdf(2*z_zero - 1.96);
high_95 = normcdf(2*z_zero + 1.96);
index_low = max(ones(size(est,1),1),floor(low_95*breps));
index_high = max(ones(size(est,1),1),ceil(high_95*breps));
ci_low = zeros(size(est,1),1);
ci_high = zeros(size(est,1),1);
for j = 1:size(est,1)
    ci_low(j,1) = error_sort(j,index_low(j));
    ci_high(j,1) = error_sort(j,index_high(j));
end

boot_std = std(boots,0,2);
temp = [est,boot_std,ci_low,ci_high]';
meas_dis_nr = temp(:);



% Life


load('est_life_r_uf')
est = est_final(5:end);
load('est_life_r_boot_par_uf')
boots = boot_est(5:end,:);

est = [est(1);est(2)*(1-est(1));est(3:end)];
boots = [boots(1,:);boots(2,:).*(1-boots(1,:));boots(3:end,:)];

breps = size(boots,2);

error_sort = sort(boots,2);

comp = est*ones(1,breps);
C_theta = mean(boots < comp,2);
z_zero = norminv(C_theta);
low_95 = normcdf(2*z_zero - 1.96);
high_95 = normcdf(2*z_zero + 1.96);
index_low = max(ones(size(est,1),1),floor(low_95*breps));
index_high = max(ones(size(est,1),1),ceil(high_95*breps));
ci_low = zeros(size(est,1),1);
ci_high = zeros(size(est,1),1);
for j = 1:size(est,1)
    ci_low(j,1) = error_sort(j,index_low(j));
    ci_high(j,1) = error_sort(j,index_high(j));
end

boot_std = std(boots,0,2);
temp = [est,boot_std,ci_low,ci_high]';
meas_life_r = temp(:);


load('est_life_nr_uf')
est = est_final(5:end);
load('est_life_nr_boot_par_uf')
boots = boot_est(5:end,:);

est = [est(1);est(2)*(1-est(1));est(3:end)];
boots = [boots(1,:);boots(2,:).*(1-boots(1,:));boots(3:end,:)];

breps = size(boots,2);

error_r_mean = mean(boots,2);
error_sort = sort(boots,2);

comp = est*ones(1,breps);
C_theta = mean(boots < comp,2);
z_zero = norminv(C_theta);
low_95 = normcdf(2*z_zero - 1.96);
high_95 = normcdf(2*z_zero + 1.96);
index_low = max(ones(size(est,1),1),floor(low_95*breps));
index_high = max(ones(size(est,1),1),ceil(high_95*breps));
ci_low = zeros(size(est,1),1);
ci_high = zeros(size(est,1),1);
for j = 1:size(est,1)
    ci_low(j,1) = error_sort(j,index_low(j));
    ci_high(j,1) = error_sort(j,index_high(j));
end

boot_std = std(boots,0,2);
temp = [est,boot_std,ci_low,ci_high]';
meas_life_nr = temp(:);




% Export

beta_ltc_nr = meas_ltc_nr;
beta_ltc_r = [zeros(4,1);meas_ltc_r];
beta_dis_nr = meas_dis_nr;
beta_dis_r = [zeros(4,1);meas_dis_r];
beta_life_nr = [zeros(4,1);meas_life_nr];
beta_life_r = [zeros(4,1);meas_life_r];



beta_table = [beta_ltc_nr , beta_ltc_r , beta_dis_nr , beta_dis_r , beta_life_nr , beta_life_r]

cd /Users/nhendren/Research/'Insurance - Empirical'/'HRS Analysis'/Drafts
save('beta_table','beta_table','-ascii','-tabs')
cd /Users/nhendren


