% Combine Graphs

clear
close all

%% Settings

granular = .003;
normal = 0 ;
efron = 1;
pctile = 0;
expand_pct = 0;
expand_pct_b = 0;
expand_norm = 1;
inf_T_vals = [.7;.8;.9];
q_vals = [0.2 ; 0.5 ; 0.8];

%confidence_z = 1.96;
confidence_z = 1.64;
t_cut = .8;

%% Load Data

name = 'est_dis_nr_graph_f';
load(name)
T_nr = T_est;
F_p_nr = F_p_est;
center_nr = center;
f_p_nr = f_p;
F_p_q_nr = F_p_est_q;
T_q_nr = T_est_q;
q_dis_nr = q_dis;

name = 'est_dis_r_graph_par_uf';
load(name)
T_r = T_est;
F_p_r = F_p_est;
center_r = center;
f_p_r = f_p;
F_p_q_r = F_p_est_q;
T_q_r = T_est_q;
q_dis_r = q_dis;


boot_savename = 'est_dis_nr_boot_f';
load(boot_savename)
keepers = find(boot_exitflag > 0)';

ci_savename = 'est_dis_nr_ci_f';
load(ci_savename)
T_b_nr = T(:,keepers);
F_b_nr = F_p_b(:,keepers);
T_b_nr = ones(size(T_b_nr)).*(T_b_nr < 1) + (T_b_nr >= 1).*T_b_nr;
f_b_nr = f_p_b(:,keepers);
T_b_q_nr = T_b_q(:,keepers,:);
F_b_q_nr = F_p_b_q(:,keepers,:);

boot_savename = 'est_dis_r_boot_par_uf';
load(boot_savename)
keepers = find(boot_exitflag > 0)';


ci_savename = 'est_dis_r_ci_par_uf';
load(ci_savename)
T_b_r = T(:,keepers);
F_b_r = F_p_b(:,keepers);
T_b_r = ones(size(T_b_r)).*(T_b_r < 1) + (T_b_r >= 1).*T_b_r;
f_b_r = f_p_b(:,keepers);
T_b_q_r = T_b_q(:,keepers,:);
F_b_q_r = F_p_b_q(:,keepers,:);


% Even out the data! 

breps_nr = size(T_b_nr,2);
breps_r = size(T_b_r,2);
breps = min(breps_nr,breps_r);

T_b_r = T(:,1:breps);
F_b_r = F_b_r(:,1:breps);
f_b_r = f_b_r(:,1:breps);
T_b_nr = T_b_nr(:,1:breps);
F_b_nr = F_b_nr(:,1:breps);
f_b_nr = f_b_nr(:,1:breps);
T_b_q_r = T_b_q_r(:,1:breps,:);
F_b_q_r = F_b_q_r(:,1:breps,:);
T_b_q_nr = T_b_q_nr(:,1:breps,:);
F_b_q_nr = F_b_q_nr(:,1:breps,:);


%% Distribution Graphs
 
% pdf graphs (no std errors)
pp = [.01:granular:.99]';
pp_r = sort([pp;center_r]);
pp_nr = sort([pp;center_nr]);
pp_f = ([.01:granular:.99]')*ones(1,size(T_b_q_r,3));
pp_q_r = sort([pp_f;q_dis_r']);
pp_q_nr = sort([pp_f;q_dis_nr']);

pdf_fig = figure;
pdf_plot = plot(pp_nr,f_p_nr,'k--',pp_r,f_p_r,'k-','LineWidth',3);
title_1 = title({'\fontsize{20}Distribution of Private Information';'\fontsize{16}Disability'},'fontweight','b');
%set(title_1,'fontweight','b')
set(pdf_plot(1),'color',[0 0 .5])
set(pdf_plot(2),'color',[.7 0 0])
legend_1 = legend('No Reject','Reject');
set(legend_1,'fontsize',14,'fontweight','b')
xlabel('Probability of Loss','fontweight','b','fontsize',14)
ylabel('Density','fontweight','b','fontsize',14)


% 
% 
% %% Full pdf graph  (No Std Errors)
% pp_f = ([.01:granular:.99]')*ones(1,size(T_b_q_r,3));
% pp_q_r = sort([pp_f;q_dis_r']);
% pp_q_nr = sort([pp_f;q_dis_nr']);
% 
% 
% 
% pdf_fig_q = figure;
% hold on
% pdf_plot_full_nr = plot(pp_q_nr(:,1),f_p_q_nr(:,1),'k--',pp_q_nr(:,2),f_p_q_nr(:,2),'k--',pp_q_nr(:,3),f_p_q_nr(:,3),'k--','LineWidth',3); 
% pdf_plot_full_r = plot(pp_q_r(:,1),f_p_q_r(:,1),'k-',pp_q_r(:,2),f_p_q_r(:,2),'k-',pp_q_r(:,3),f_p_q_r(:,3),'k-','LineWidth',3); 
% set(pdf_plot_full_nr,'color',[0 0 .5])
% set(pdf_plot_full_r,'color',[.7 0 0])
% axis([0 1 0 15])
% legend_1 = legend([pdf_plot_full_nr(1);pdf_plot_full_r(1)],'No Reject','Reject')
% lab1 = text(.075,11,['\downarrow q = ',num2str(round(1000*q_dis_nr(1))/1000)]);
% set(lab1,'fontweight','b','fontsize',12)
% lab2 = text(.11,9.5,['\downarrow q = ',num2str(round(1000*q_dis_nr(2))/1000)]);
% set(lab2,'fontweight','b','fontsize',12)
% lab3 = text(.16,8,['\downarrow q = ',num2str(round(1000*q_dis_nr(3))/1000)]);
% set(lab3,'fontweight','b','fontsize',12)
% 
% lab4 = text(.2,7,['\leftarrow q = ',num2str(round(1000*q_dis_r(1))/1000)]);
% set(lab4,'fontweight','b','fontsize',12)
% lab5 = text(.26,6.3,['\downarrow q = ',num2str(round(1000*q_dis_r(2))/1000)]);
% set(lab5,'fontweight','b','fontsize',12)
% lab6 = text(.37,5.7,['\downarrow q = ',num2str(round(1000*q_dis_r(3))/1000)]);
% set(lab6,'fontweight','b','fontsize',12)
% 
% 
% xlabel('Probability of Loss','fontweight','b','fontsize',14)
% ylabel('Density','fontweight','b','fontsize',14)
% title_4d = title({'\fontsize{20}Figure 4e: Distribution of Private Information';'\fontsize{16}Disability (Quantiles of q)'},'fontweight','b');
% 
% hold off
% 
%% pdf graphs (w std errors)

    
f_b_nr_mean = mean(f_b_nr,2);
f_b_sort = sort(f_b_nr,2);

comp = f_p_nr*ones(1,breps);
C_theta_nr = mean(f_b_nr < comp,2);
z_zero_nr = norminv(C_theta_nr);
low_95_nr = normcdf(2*z_zero_nr - 1.96);
high_95_nr = normcdf(2*z_zero_nr + 1.96);
index_low_nr = max(ones(size(f_p_nr,1),1),floor(low_95_nr*breps));
index_high_nr = max(ones(size(f_p_nr,1),1),ceil(high_95_nr*breps));
ci_low_f_nr_t = zeros(size(f_p_nr,1),1);
ci_high_f_nr_t = zeros(size(f_p_nr,1),1);
ci_low_f_nr = zeros(size(f_p_nr,1),1);
ci_high_f_nr = zeros(size(f_p_nr,1),1);
for j = 1:size(T_nr,1)
    ci_low_f_nr(j,1) = f_b_sort(j,index_low_nr(j));
    ci_high_f_nr(j,1) = f_b_sort(j,index_high_nr(j));
end


% Reject
f_b_r_mean = mean(f_b_r,2);
f_b_sort = sort(f_b_r,2);

comp = f_p_r*ones(1,breps);
C_theta_r = mean(f_b_r < comp,2);
z_zero_r = norminv(C_theta_r);
low_95_r = normcdf(2*z_zero_r - 1.96);
high_95_r = normcdf(2*z_zero_r + 1.96);
index_low_r = max(ones(size(f_p_r,1),1),floor(low_95_r*breps));
index_high_r = max(ones(size(f_p_r,1),1),ceil(high_95_r*breps));
ci_low_f_r_t = zeros(size(f_p_r,1),1);
ci_high_f_r_t = zeros(size(f_p_r,1),1);
ci_low_f_r = zeros(size(f_p_r,1),1);
ci_high_f_r = zeros(size(f_p_r,1),1);
for j = 1:size(T_r,1)
    ci_low_f_r(j,1) = f_b_sort(j,index_low_r(j));
    ci_high_f_r(j,1) = f_b_sort(j,index_high_r(j));
end


if expand_norm == 1
    
    
var_nr = var(f_b_nr,0,2);
sd_nr = sqrt(var_nr);

var_r = var(f_b_r,0,2);
sd_r = sqrt(var_r);

ci_low_f_nr_norm = F_p_nr - 1.96*sd_nr;
ci_high_f_nr_norm = F_p_nr + 1.96*sd_nr;

ci_low_f_r_norm = F_p_r - 1.96*sd_r;
ci_high_f_r_norm = F_p_r + 1.96*sd_r;


ci_low_f_r = min(ci_low_f_r,ci_low_f_r_norm);
ci_high_f_r = max(ci_high_f_r,ci_high_f_r_norm);
ci_low_f_nr = min(ci_low_f_nr,ci_low_f_nr_norm);
ci_high_f_nr = max(ci_high_f_nr,ci_high_f_nr_norm);
    
    
end


pdf_fig_std = figure;
hold on 
f_plot_nr = plot(pp_nr,f_p_nr,'b--','LineWidth',2);
f_plot_nr_5 = plot(pp_nr,ci_low_f_nr,'b--','LineWidth',1);
f_plot_nr_95 = plot(pp_nr,ci_high_f_nr,'b--','LineWidth',1);
f_plot_r = plot(pp_r,f_p_r,'r-','LineWidth',2);
f_plot_r_5 = plot(pp_r,ci_low_f_r,'r--','LineWidth',1);
f_plot_r_95 = plot(pp_r,ci_high_f_r,'r--','LineWidth',1);
axis([0 1 0 12])
set([f_plot_nr;f_plot_nr_5;f_plot_nr_95],'color',[0 0 .5])
set([f_plot_r;f_plot_r_5;f_plot_r_95],'color',[.7 0 0])
legend_1 = legend([f_plot_nr;f_plot_nr_5;f_plot_r;f_plot_r_5],'No Reject','95% CI','Reject','95% CI','Location','NorthEast');
set(legend_1,'fontsize',14,'fontweight','b')
title({'\fontsize{20}PDF of Private Information';'\fontsize{16}Disability'},'fontweight','b')
xlabel('Probability of Loss','fontweight','b','fontsize',14)
ylabel('PDF','fontweight','b','fontsize',14)

hold off
% 

% cdf graphs (w std errors)

% No Reject
if efron == 1 
    
F_b_nr_mean = mean(F_b_nr,2);
F_b_sort = sort(F_b_nr,2);

comp = F_p_nr*ones(1,breps);
C_theta_nr = mean(F_b_nr < comp,2);
z_zero_nr = norminv(C_theta_nr);
low_95_nr = normcdf(2*z_zero_nr - 1.96);
high_95_nr = normcdf(2*z_zero_nr + 1.96);
index_low_nr = max(ones(size(F_p_nr,1),1),floor(low_95_nr*breps));
index_high_nr = max(ones(size(F_p_nr,1),1),ceil(high_95_nr*breps));
ci_low_F_nr_t = zeros(size(F_p_nr,1),1);
ci_high_F_nr_t = zeros(size(F_p_nr,1),1);
ci_low_F_nr = zeros(size(F_p_nr,1),1);
ci_high_F_nr = zeros(size(F_p_nr,1),1);
for j = 1:size(T_nr,1)
    ci_low_F_nr_t(j,1) = F_b_sort(j,index_low_nr(j));
    ci_high_F_nr_t(j,1) = F_b_sort(j,index_high_nr(j));
end
for j = 1:size(T_nr,1)
    ci_low_F_nr(j,1) = min(ci_low_F_nr_t(j:end,1));
end
for j = 1:size(T_nr,1)
    ci_high_F_nr(end-j+1) = max(ci_high_F_nr_t(1:end-j+1));
end


% Reject
F_b_r_mean = mean(F_b_r,2);
F_b_sort = sort(F_b_r,2);

comp = F_p_r*ones(1,breps);
C_theta_r = mean(F_b_r < comp,2);
z_zero_r = norminv(C_theta_r);
low_95_r = normcdf(2*z_zero_r - 1.96);
high_95_r = normcdf(2*z_zero_r + 1.96);
index_low_r = max(ones(size(F_p_r,1),1),floor(low_95_r*breps));
index_high_r = max(ones(size(F_p_r,1),1),ceil(high_95_r*breps));
ci_low_F_r_t = zeros(size(F_p_r,1),1);
ci_high_F_r_t = zeros(size(F_p_r,1),1);
ci_low_F_r = zeros(size(F_p_r,1),1);
ci_high_F_r = zeros(size(F_p_r,1),1);
for j = 1:size(T_r,1)
    ci_low_F_r_t(j,1) = F_b_sort(j,index_low_r(j));
    ci_high_F_r_t(j,1) = F_b_sort(j,index_high_r(j));
end
for j = 1:size(T_r,1)
    ci_low_F_r(j,1) = min(ci_low_F_r_t(j:end,1));
end
for j = 1:size(T_r,1)
    ci_high_F_r(end-j+1) = max(ci_high_F_r_t(1:end-j+1));
end
end

if expand_pct_b == 1
    
    
    
end

if expand_norm == 1
    
    
var_nr = var(F_b_nr,0,2);
sd_nr = sqrt(var_nr);

var_r = var(F_b_r,0,2);
sd_r = sqrt(var_r);

ci_low_F_nr_norm = F_p_nr - 1.96*sd_nr;
ci_high_F_nr_norm = F_p_nr + 1.96*sd_nr;

ci_low_F_r_norm = F_p_r - 1.96*sd_r;
ci_high_F_r_norm = F_p_r + 1.96*sd_r;


ci_low_F_r = min(ci_low_F_r,ci_low_F_r_norm);
ci_high_F_r = max(ci_high_F_r,ci_high_F_r_norm);
ci_low_F_nr = min(ci_low_F_nr,ci_low_F_nr_norm);
ci_high_F_nr = max(ci_high_F_nr,ci_high_F_nr_norm);
    
    
end



cdf_fig = figure;
hold on 
F_plot_nr = plot(pp_nr,F_p_nr,'b--','LineWidth',2);
F_plot_nr_5 = plot(pp_nr,ci_low_F_nr,'b--','LineWidth',1);
F_plot_nr_95 = plot(pp_nr,ci_high_F_nr,'b--','LineWidth',1);
F_plot_r = plot(pp_r,F_p_r,'r-','LineWidth',2);
F_plot_r_5 = plot(pp_r,ci_low_F_r,'r--','LineWidth',1);
F_plot_r_95 = plot(pp_r,ci_high_F_r,'r--','LineWidth',1);
axis([0 1 0 1])
set([F_plot_nr;F_plot_nr_5;F_plot_nr_95],'color',[0 0 .5])
set([F_plot_r;F_plot_r_5;F_plot_r_95],'color',[.7 0 0])
legend_1 = legend([F_plot_nr;F_plot_nr_5;F_plot_r;F_plot_r_5],'No Reject','95% CI','Reject','95% CI','Location','SouthEast');
set(legend_1,'fontsize',14,'fontweight','b');
title({'\fontsize{20}CDF of Private Information';'\fontsize{16}Disability'},'fontweight','b')
xlabel('Probability of Loss','fontweight','b','fontsize',14)
ylabel('Cumulative Distribution','fontweight','b','fontsize',14)

hold off


%%

cdf_fig_q = figure;
hold on
cdf_plot_full_nr = plot(pp_q_nr(:,1),F_p_q_nr(:,1),'k--',pp_q_nr(:,2),F_p_q_nr(:,2),'k--',pp_q_nr(:,3),F_p_q_nr(:,3),'k--','LineWidth',3); 
cdf_plot_full_r = plot(pp_q_r(:,1),F_p_q_r(:,1),'k-',pp_q_r(:,2),F_p_q_r(:,2),'k-',pp_q_r(:,3),F_p_q_r(:,3),'k-','LineWidth',3); 
set(cdf_plot_full_nr,'color',[0 0 .5])
set(cdf_plot_full_r,'color',[.7 0 0])
axis([0 1 0 1])
legend_1 = legend([cdf_plot_full_nr(1);cdf_plot_full_r(1)],'No Reject','Reject')
lab1 = text(.04,.9,['q = ',num2str(round(1000*q_dis_nr(1))/1000),' \rightarrow']);
set(lab1,'fontweight','b','fontsize',12)
lab2 = text(.18,.8,['\leftarrow q = ',num2str(round(1000*q_dis_nr(2))/1000)]);
set(lab2,'fontweight','b','fontsize',12)
lab3 = text(.24,.75,['\leftarrow q = ',num2str(round(1000*q_dis_nr(3))/1000)]);
set(lab3,'fontweight','b','fontsize',12)

lab4 = text(.27,.64,['\leftarrow q = ',num2str(round(1000*q_dis_r(1))/1000)]);
set(lab4,'fontweight','b','fontsize',12)
lab5 = text(.49,.65,['\leftarrow q = ',num2str(round(1000*q_dis_r(2))/1000)]);
set(lab5,'fontweight','b','fontsize',12)
lab6 = text(.37,.2,['\leftarrow q = ',num2str(round(1000*q_dis_r(3))/1000)]);
set(lab6,'fontweight','b','fontsize',12)


xlabel('Probability of Loss','fontweight','b','fontsize',14)
ylabel('Density','fontweight','b','fontsize',14)
title({'\fontsize{20}Figure 5e: CDF of Private Information';'\fontsize{16}Disability (Quantiles of q)'},'fontweight','b')

hold off


%% CI For T(p) 

topcode = 3;


% No Reject


if efron == 1 

T_b_nr = T_b_nr.*(T_b_nr <= topcode).*(T_b_nr >= 1) + (T_b_nr > topcode)*topcode + (T_b_nr < 1)*1;
T_b_nr_mean = mean(T_b_nr,2);
T_b_sort = sort(T_b_nr,2);

comp = T_nr*ones(1,breps);
C_theta_nr = mean(T_b_nr < comp,2);
z_zero_nr = norminv(C_theta_nr);
low_95_nr = normcdf(2*z_zero_nr - 1.96);
high_95_nr = normcdf(2*z_zero_nr + 1.96);
index_low_nr = max(ones(size(T_nr,1),1),floor(low_95_nr*breps));
index_high_nr = max(ones(size(T_nr,1),1),ceil(high_95_nr*breps));
ci_low_T_nr = zeros(size(T_nr,1),1);
ci_high_T_nr = zeros(size(T_nr,1),1);
for j = 1:size(T_nr,1)
    ci_low_T_nr(j,1) = T_b_sort(j,index_low_nr(j));
    ci_high_T_nr(j,1) = T_b_sort(j,index_high_nr(j));
end

% Reject
T_b_r = T_b_r.*(T_b_r <= topcode).*(T_b_r >= 1) + (T_b_r > topcode)*topcode + (T_b_r < 1)*1;
T_b_r_mean = mean(T_b_r,2);
T_b_sort = sort(T,2);

comp = T_r*ones(1,breps);
C_theta_r = mean(T_b_r < comp,2);
z_zero_r = norminv(C_theta_r);
low_95_r = normcdf(2*z_zero_r - 1.96);
high_95_r = normcdf(2*z_zero_r + 1.96);
index_low_r = max(ones(size(T_r,1),1),floor(low_95_r*breps));
index_high_r = max(ones(size(T_r,1),1),ceil(high_95_r*breps));
ci_low_T_r = zeros(size(T_r,1),1);
ci_high_T_r = zeros(size(T_r,1),1);
for j = 1:size(T_r,1)
    ci_low_T_r(j,1) = T_b_sort(j,index_low_r(j));
    ci_high_T_r(j,1) = T_b_sort(j,index_high_r(j));
end

end

%if normal == 1

var_nr = var(T_b_nr,0,2);
sd_nr = sqrt(var_nr);

var_r = var(T_b_r,0,2);
sd_r = sqrt(var_r);



% sd_nr = std(T_b_nr,0,2);

ci_low_T_nr_norm = T_nr - 1.96*sd_nr;
ci_high_T_nr_norm = T_nr + 1.96*sd_nr;

%sd_r = std(T_b_r,0,2);
ci_low_T_r_norm = T_r - 1.96*sd_r;
ci_high_T_r_norm = T_r + 1.96*sd_r;


%end

%if pctile == 1


% Construct bias-corrected pctile std errors

% No Reject
T_b_sort = sort(T_b_nr,2);
index_low_nr = max(ones(size(T_nr,1),1),floor(.025*breps));
index_high_nr = max(ones(size(T_nr,1),1),ceil(.975*breps));
ci_low_T_nr_pct = zeros(size(T_nr,1),1);
ci_high_T_nr_pct = zeros(size(T_nr,1),1);
for j = 1:size(T_nr,1)
    ci_low_T_nr_pct(j,1) = T_b_sort(j,index_low_nr(j));
    ci_high_T_nr_pct(j,1) = T_b_sort(j,index_high_nr(j));
end
    
% Reject
T_b_sort = sort(T_b_r,2);
index_low_r = max(ones(size(T_r,1),1),floor(.025*breps));
index_high_r = max(ones(size(T_r,1),1),ceil(.975*breps));
ci_low_T_r_pct = zeros(size(T_r,1),1);
ci_high_T_r_pct = zeros(size(T_r,1),1);
for j = 1:size(T_r,1)
    ci_low_T_r_pct(j,1) = T_b_sort(j,index_low_r(j));
    ci_high_T_r_pct(j,1) = T_b_sort(j,index_high_r(j));
end



if expand_pct == 1
    ci_low_T_r = min(ci_low_T_r,ci_low_T_r_pct);
    ci_high_T_r = max(ci_high_T_r,ci_high_T_r_pct);
    ci_low_T_nr = min(ci_low_T_nr,ci_low_T_nr_pct);
    ci_high_T_nr = max(ci_high_T_nr,ci_high_T_nr_pct);
    
end

if expand_pct_b == 1
    ci_low_T_r = min(ci_low_T_r,2*T_r - ci_high_T_r_pct);
    ci_high_T_r = max(ci_high_T_r,2*T_r - ci_low_T_r_pct);
    ci_low_T_nr = min(ci_low_T_nr,2*T_nr - ci_high_T_nr_pct);
    ci_high_T_nr = max(ci_high_T_nr,2*T_nr - ci_low_T_nr_pct);
    
end

if expand_norm == 1
    ci_low_T_r = min(ci_low_T_r,ci_low_T_r_norm);
    ci_high_T_r = max(ci_high_T_r,ci_high_T_r_norm);
    ci_low_T_nr = min(ci_low_T_nr,ci_low_T_nr_norm);
    ci_high_T_nr = max(ci_high_T_nr,ci_high_T_nr_norm);
    
end


% Graphs

graph_nr = F_p_nr < t_cut;
graph_r = F_p_r < t_cut;



T_fig = figure;
hold on
T_plot_nr = plot(pp_nr(graph_nr),T_nr(graph_nr),'b--','LineWidth',2);
T_plot_nr_5 = plot(pp_nr(graph_nr),ci_low_T_nr(graph_nr),'b--','LineWidth',1);
T_plot_nr_95 = plot(pp_nr(graph_nr),ci_high_T_nr(graph_nr),'b--','LineWidth',1);
T_plot_r = plot(pp_r(graph_r),T_r(graph_r),'r-','LineWidth',2);
T_plot_r_5 = plot(pp_r(graph_r),ci_low_T_r(graph_r),'r--','LineWidth',1);
T_plot_r_95 = plot(pp_r(graph_r),ci_high_T_r(graph_r),'r--','LineWidth',1);

axis([0 1 1 3])
legend_T = legend([T_plot_nr;T_plot_nr_5;T_plot_r;T_plot_r_5],'No Reject','95% CI','Reject','95% CI');
set(legend_T,'fontsize',14,'fontweight','b')
set([T_plot_nr;T_plot_nr_5;T_plot_nr_95],'color',[0 0 .5])
set([T_plot_r;T_plot_r_5;T_plot_r_95],'color',[.7 0 0])
xlabel('Probability of Loss','fontweight','b','fontsize',14)
ylabel('Pooled Price Ratio','fontweight','b','fontsize',14)
title({'\fontsize{20}Pooled Price Ratio';'\fontsize{16}Disability'},'fontweight','b')
text(0,.65,'Note: Plot censored above 80th estimated pctile of F(p)');

hold off

% 
% 
% T_fig_q = figure;
% hold on
% T_plot_full_nr = plot(pp_q_nr(F_p_q_nr(:,1) < t_cut,1),T_q_nr(F_p_q_nr(:,1) < t_cut,1),'k--',pp_q_nr(F_p_q_nr(:,2) < t_cut,2),T_q_nr(F_p_q_nr(:,2) < t_cut,2),'k--',pp_q_nr(F_p_q_nr(:,3) < t_cut,3),T_q_nr(F_p_q_nr(:,3) < t_cut,3),'k--','LineWidth',3); 
% T_plot_full_r = plot(pp_q_r(F_p_q_r(:,1) < t_cut,1),T_q_r(F_p_q_r(:,1) < t_cut,1),'k-',pp_q_r(F_p_q_r(:,2) < t_cut,2),T_q_r(F_p_q_r(:,2) < t_cut,2),'k-',pp_q_r(F_p_q_r(:,3) < t_cut,3),T_q_r(F_p_q_r(:,3) < t_cut,3),'k-','LineWidth',3); 
% set(T_plot_full_nr,'color',[0 0 .5])
% set(T_plot_full_r,'color',[.7 0 0])
% axis([0 1 1 4])
% legend_1 = legend([T_plot_full_nr(1);T_plot_full_r(1)],'No Reject','Reject')
% lab1 = text(0,1.6,['q = ',num2str(round(1000*q_dis_nr(1))/1000)]);
% set(lab1,'fontweight','b','fontsize',12)
% lab2 = text(.1,1.5,['q = ',num2str(round(1000*q_dis_nr(2))/1000)]);
% set(lab2,'fontweight','b','fontsize',12)
% lab3 = text(.22,1.6,['\leftarrow q = ',num2str(round(1000*q_dis_nr(3))/1000)]);
% set(lab3,'fontweight','b','fontsize',12)
% 
% lab4 = text(.35,2.4,['\leftarrow q = ',num2str(round(1000*q_dis_r(1))/1000)]);
% set(lab4,'fontweight','b','fontsize',12)
% lab5 = text(.52,2.5,['\leftarrow q = ',num2str(round(1000*q_dis_r(2))/1000)]);
% set(lab5,'fontweight','b','fontsize',12)
% lab6 = text(.75,3,['\leftarrow q = ',num2str(round(1000*q_dis_r(3))/1000)]);
% set(lab6,'fontweight','b','fontsize',12)
% 
% 
% xlabel('Probability of Loss','fontweight','b','fontsize',14)
% ylabel('Density','fontweight','b','fontsize',14)
% title({'\fontsize{20}Figure 6e: Pooled Price Ratio';'\fontsize{16}Disability (Quantiles of q)'},'fontweight','b')
% text(0,.65,'Note: Plot censored above 90th estimated pctile of F(p)');
% 
% hold off


% T graphs (w std errors)
% 
% figure(1)
% plot(pp,T_nr,'k--',pp,T_r,'k-','LineWidth',3)
% title({'\fontsize{16}Pooled Price Ratio';'\fontsize{14}Reject and No Reject'})
% legend('No Reject','Reject')
% axis([0 1 1 3])

% 
% 
% %% q Graphs
% 
% pp = [.01:granular:.99]';
% pp_nr = sort([pp;center_nr]);
% pp_r = sort([pp;center_r]);
% 
% q_fig = figure;
% q_plot = plot(pp_r,f_q_nr,'k--',pp_nr,f_q_r,'k-','LineWidth',3);
% title_2 = title({'\fontsize{20}Figure 7b: Distribution of Pr[L|X]';'\fontsize{16}Disability'},'fontweight','b');
% set(q_plot(1),'color',[0 0 .5])
% set(q_plot(2),'color',[.7 0 0])
% legend_1 = legend('No Reject','Reject');
% set(legend_1,'fontsize',14,'fontweight','b')
% xlabel('Probability of Loss','fontweight','b','fontsize',14)
% ylabel('Density','fontweight','b','fontsize',14)
% 
% 
% %% P_dist (Unconditional) Graphs
% 
% 
% P_dist_fig = figure;
% P_dist_plot = plot(pp_nr,P_dist_nr,'k--',pp_r,P_dist_r,'k-','LineWidth',3);
% title_3 = title({'\fontsize{20}Figure 8b: Unconditional Distribution of P';'\fontsize{16}Disability'},'fontweight','b');
% set(P_dist_plot(1),'color',[0 0 .5])
% set(P_dist_plot(2),'color',[.7 0 0])
% legend_1 = legend('No Reject','Reject');
% set(legend_1,'fontsize',14,'fontweight','b')
% xlabel('Probability of Loss','fontweight','b','fontsize',14)
% ylabel('Density','fontweight','b','fontsize',14)
% 
% 
% % Fraction P_reject > P_noreject
% upper = zeros(size(pp,1)+1,size(pp,1)+1);
% total_p = ones(size(upper));
% for j = 1:size(pp,1)
%     for k = j:size(pp,1)
%         upper(j,k) = (pp_r(j) <= pp_nr(k));
%     end
% end
% 
% frac_hr = (P_dist_r'*upper*P_dist_nr) / (P_dist_r'*total_p*P_dist_nr);
% frac_hr_b = zeros(size(P_dist_nr,1),breps);
% for b = 1:breps
%     frac_hr_b(:,b) = (P_dist_b_r(:,b)'*upper*P_dist_b_nr(:,b)) / (P_dist_b_r(:,b)'*total_p*P_dist_b_nr(:,b));
% end
% frac_hr_b = sort(frac_hr_b);
% frac_hr_low = frac_hr_b(round(5*breps/100));
% frac_hr_high = frac_hr_b(round(95*breps/100));
% 
% % Fraction inf_T_reject > inf_T_noreject



%% Confidence Intervals for inf_T (for a range of values)

pt_nr = zeros(size(inf_T_vals,1),1);
ci_low_nr = zeros(size(inf_T_vals,1),1);
ci_high_nr = zeros(size(inf_T_vals,1),1);
pt_r = zeros(size(inf_T_vals,1),1);
ci_low_r = zeros(size(inf_T_vals,1),1);
ci_high_r = zeros(size(inf_T_vals,1),1);
pt_diff = zeros(size(inf_T_vals,1),1);
ci_low_diff = zeros(size(inf_T_vals,1),1);
ci_high_diff = zeros(size(inf_T_vals,1),1);
p_diff = zeros(size(inf_T_vals,1),1);



for jj = 1:size(inf_T_vals,1)
    t_cut = 1-inf_T_vals(jj);
    
    % Point Estimates
    F_p_nr_use = [0;F_p_nr(1:end-1)];
    inf_T_t = T_nr.*(F_p_nr_use < 1-t_cut).*(T_nr >= 1) + 100.*((F_p_nr_use >= 1-t_cut) + (T_nr < 1) );
    inf_T_nr = max(1,min(inf_T_t));
    inf_T_t = T_r.*(F_p_r < 1-t_cut).*(T_r >= 1) + 100.*((F_p_r >= 1-t_cut) + (T_r < 1) );
    inf_T_r = max(1,min(inf_T_t));
    pt_nr(jj) = inf_T_nr;
    pt_r(jj) = inf_T_r;
    pt_diff(jj) =inf_T_r - inf_T_nr;
    
    % Bootstrapped CI
    inf_T_b_new_nr = zeros(size(T_b_nr,2),1);
    inf_T_b_new_r = zeros(size(T_b_r,2),1);
    for b = 1:size(T_b_nr,2)
        F_b_nr_use = [0;F_b_nr(1:end-1,b)];
        inf_T_t = T_b_nr(:,b).*(F_b_nr_use < 1-t_cut).*(T_b_nr(:,b)>=1) + 100.*((F_b_nr_use >= 1-t_cut) + (T_b_nr(:,b) < 1));
        inf_T_b_new_nr(b) = max(1,min(inf_T_t));
    end
    for b = 1:size(T_b_r,2)
        inf_T_t = T_b_r(:,b).*(F_b_r(:,b) < 1-t_cut).*(T_b_r(:,b)>=1) + 100.*((F_b_r(:,b) >= 1-t_cut) + (T_b_r(:,b) < 1));
        inf_T_b_new_r(b) = max(1,min(inf_T_t));
    end
    C_theta_nr = mean(inf_T_b_new_nr < inf_T_nr);
    z_zero_nr = norminv(C_theta_nr);
    low_95_nr = normcdf(2*z_zero_nr - confidence_z);
    high_95_nr = normcdf(2*z_zero_nr + confidence_z);
    index_low_nr = max(1,floor(low_95_nr*breps));
    index_high_nr = ceil(high_95_nr*breps);
    inf_T_b_nr_sort = sort(inf_T_b_new_nr);
    ci_low_nr(jj) = inf_T_b_nr_sort(index_low_nr);
    ci_high_nr(jj) = inf_T_b_nr_sort(index_high_nr);
    
    C_theta_r = mean(inf_T_b_new_r < inf_T_r);
    z_zero_r = norminv(C_theta_r);
    low_95_r = normcdf(2*z_zero_r - confidence_z);
    high_95_r = normcdf(2*z_zero_r + confidence_z);
    index_low_r = max(1,floor(low_95_r*breps));
    index_high_r = ceil(high_95_r*breps);
    inf_T_b_r_sort = sort(inf_T_b_new_r);
    ci_low_r(jj) = inf_T_b_r_sort(index_low_r);
    ci_high_r(jj) = inf_T_b_r_sort(index_high_r);
    
    pt_est = inf_T_r - inf_T_nr;
    diff = inf_T_b_new_r - inf_T_b_new_nr;
    diff_sort = sort(diff);
    C_theta_diff = mean(diff < pt_est);
    z_zero_diff = norminv(C_theta_diff);
    low_95_diff = normcdf(2*z_zero_diff - confidence_z);
    high_95_diff = normcdf(2*z_zero_diff + confidence_z);
    index_low_diff = max(1,floor(low_95_diff*breps));
    index_high_diff = ceil(high_95_diff*breps);
    ci_low_diff(jj) = diff_sort(index_low_diff);
    ci_high_diff(jj) = diff_sort(index_high_diff);
    
    
    if expand_norm == 1 
        
var_nr = var(inf_T_b_new_r,0,1);
sd_nr = sqrt(var_nr);

var_r = var(inf_T_b_new_r,0,1);
sd_r = sqrt(var_r);

var_diff = var(diff,0,1);
sd_diff = sqrt(var_diff);

ci_low_inf_T_nr_norm = inf_T_nr - confidence_z*sd_nr;
ci_high_inf_T_nr_norm = inf_T_nr + confidence_z*sd_nr;

ci_low_inf_T_r_norm = inf_T_r - confidence_z*sd_r;
ci_high_inf_T_r_norm = inf_T_r + confidence_z*sd_r;

ci_low_inf_T_diff_norm = (inf_T_r - inf_T_nr) - confidence_z*sd_diff;
ci_high_inf_T_diff_norm = (inf_T_r - inf_T_nr) + confidence_z*sd_diff;

ci_low_nr(jj) = min(ci_low_nr(jj),ci_low_inf_T_nr_norm);
ci_high_nr(jj) = max(ci_high_nr(jj),ci_high_inf_T_nr_norm);
ci_low_r(jj) = min(ci_low_r(jj),ci_low_inf_T_r_norm);
ci_high_r(jj) = max(ci_high_r(jj),ci_high_inf_T_r_norm);
ci_low_diff(jj) = min(ci_low_diff(jj),ci_low_inf_T_diff_norm);
ci_high_diff(jj) = max(ci_high_diff(jj),ci_high_inf_T_diff_norm);

    end
    
    
    

end



%% Table for Inf T (for different q values)

numq = size(q_vals,1);

pt_q_nr = zeros(size(inf_T_vals,1),numq);
ci_low_q_nr = zeros(size(inf_T_vals,1),numq);
ci_high_q_nr = zeros(size(inf_T_vals,1),numq);
pt_q_r = zeros(size(inf_T_vals,1),numq);
ci_low_q_r = zeros(size(inf_T_vals,1),numq);
ci_high_q_r = zeros(size(inf_T_vals,1),numq);
pt_diff_q = zeros(size(inf_T_vals,1),numq);
ci_low_diff_q = zeros(size(inf_T_vals,1),numq);
ci_high_diff_q = zeros(size(inf_T_vals,1),numq);

for qq = 1:numq 
    

for jj = 1:size(inf_T_vals,1)
    t_cut = 1-inf_T_vals(jj);
    
    % Point Estimates
    F_p_q_nr_use = [zeros(1,numq);F_p_q_nr(1:end-1,:)];   % FIX FOR PT MASS DISTRIBUTIONS
    
    inf_T_t = T_q_nr(:,qq).*(F_p_q_nr_use(:,qq) < 1-t_cut).*(T_q_nr(:,qq) >= 1) + 100.*((F_p_q_nr_use(:,qq) >= 1-t_cut) + (T_q_nr(:,qq) < 1) );
    inf_T_nr = max(1,min(inf_T_t));
    inf_T_t = T_q_r(:,qq).*(F_p_q_r(:,qq) < 1-t_cut).*(T_q_r(:,qq) >= 1) + 100.*((F_p_q_r(:,qq) >= 1-t_cut) + (T_q_r(:,qq) < 1) );
    inf_T_r = max(1,min(inf_T_t));
    pt_q_nr(jj,qq) = inf_T_nr;
    pt_q_r(jj,qq) = inf_T_r;
    pt_diff_q(jj,qq) =inf_T_r - inf_T_nr;
    
    % Bootstrapped CI
    inf_T_b_new_nr = zeros(size(T_b_q_nr,2),1);
    inf_T_b_new_r = zeros(size(T_b_q_r,2),1);
    for b = 1:size(T_b_nr,2)
        F_b_q_nr_use = [0;F_b_q_nr(1:end-1,b,qq)];
        inf_T_t = T_b_q_nr(:,b,qq).*(F_b_q_nr_use < 1-t_cut).*(T_b_q_nr(:,b,qq)>=1) + 100.*((F_b_q_nr_use >= 1-t_cut) + (T_b_q_nr(:,b,qq) < 1));
        inf_T_b_new_nr(b) = max(1,min(inf_T_t));
    end
    for b = 1:size(T_b_q_r,2)
        inf_T_t = T_b_q_r(:,b,qq).*(F_b_q_r(:,b,qq) < 1-t_cut).*(T_b_q_r(:,b,qq)>=1) + 100.*((F_b_q_r(:,b,qq) >= 1-t_cut) + (T_b_q_r(:,b,qq) < 1));
        inf_T_b_new_r(b) = max(1,min(inf_T_t));
    end
    
    C_theta_nr = mean(inf_T_b_new_nr < inf_T_nr);
    z_zero_nr = norminv(C_theta_nr);
    low_95_nr = normcdf(2*z_zero_nr - confidence_z);
    high_95_nr = normcdf(2*z_zero_nr + confidence_z);
    index_low_nr = max(1,floor(low_95_nr*breps));
    index_high_nr = max(1,ceil(high_95_nr*breps));
    inf_T_b_nr_sort = sort(inf_T_b_new_nr);
    ci_low_q_nr(jj,qq) = inf_T_b_nr_sort(index_low_nr);
    ci_high_q_nr(jj,qq) = inf_T_b_nr_sort(index_high_nr);
     
    

    C_theta_r = mean(inf_T_b_new_r < inf_T_r);
    z_zero_r = norminv(C_theta_r);
    low_95_r = normcdf(2*z_zero_r - confidence_z);
    high_95_r = normcdf(2*z_zero_r + confidence_z);
    index_low_r = max(1,floor(low_95_r*breps));
    index_high_r = ceil(high_95_r*breps);
    inf_T_b_r_sort = sort(inf_T_b_new_r);
    ci_low_q_r(jj,qq) = inf_T_b_r_sort(index_low_r);
    ci_high_q_r(jj,qq) = inf_T_b_r_sort(index_high_r);
    
    pt_est = inf_T_r - inf_T_nr;
    diff = inf_T_b_new_r - inf_T_b_new_nr;
    diff_sort = sort(diff);
    C_theta_diff = mean(diff < pt_est);
    z_zero_diff = norminv(C_theta_diff);
    low_95_diff = normcdf(2*z_zero_diff - confidence_z);
    high_95_diff = normcdf(2*z_zero_diff + confidence_z);
    index_low_diff = max(1,floor(low_95_diff*breps));
    index_high_diff = ceil(high_95_diff*breps);
    ci_low_diff_q(jj,qq) = diff_sort(index_low_diff);
    ci_high_diff_q(jj,qq) = diff_sort(index_high_diff);
    
    
    if expand_pct_b == 1
        
        
        
    end
    
    if expand_norm == 1 
        
var_nr = var(inf_T_b_new_r,0,1);
sd_nr = sqrt(var_nr);

var_r = var(inf_T_b_new_r,0,1);
sd_r = sqrt(var_r);

var_diff = var(diff,0,1);
sd_diff = sqrt(var_diff);

ci_low_inf_T_nr_norm = inf_T_nr - confidence_z*sd_nr;
ci_high_inf_T_nr_norm = inf_T_nr + confidence_z*sd_nr;

ci_low_inf_T_r_norm = inf_T_r - confidence_z*sd_r;
ci_high_inf_T_r_norm = inf_T_r + confidence_z*sd_r;

ci_low_inf_T_diff_norm = (inf_T_r - inf_T_nr) - confidence_z*sd_diff;
ci_high_inf_T_diff_norm = (inf_T_r - inf_T_nr) + confidence_z*sd_diff;

ci_low_q_nr(jj,qq) = min(ci_low_q_nr(jj),ci_low_inf_T_nr_norm);
ci_high_q_nr(jj,qq) = max(ci_high_q_nr(jj),ci_high_inf_T_nr_norm);
ci_low_q_r(jj,qq) = min(ci_low_q_r(jj),ci_low_inf_T_r_norm);
ci_high_q_r(jj,qq) = max(ci_high_q_r(jj),ci_high_inf_T_r_norm);
ci_low_diff_q(jj,qq) = min(ci_low_diff_q(jj),ci_low_inf_T_diff_norm);
ci_high_diff_q(jj,qq) = max(ci_high_diff_q(jj),ci_high_inf_T_diff_norm);

    end
    
    
    
    
    
    
    
end

end




% 
% %% Confidence Intervals for inf_T
% 
% % CI for Non-Reject
% 
% inf_T_b_nr_mean = mean(inf_T_b_nr);
% C_theta_nr = mean(inf_T_b_nr < inf_T_nr);
% z_zero_nr = norminv(C_theta_nr);
% low_95_nr = normcdf(2*z_zero_nr - 1.96);
% high_95_nr = normcdf(2*z_zero_nr + 1.96);
% index_low_nr = max(1,floor(low_95_nr*breps));
% index_high_nr = ceil(high_95_nr*breps);
% ci_low_nr = inf_T_b_nr_sort(index_low_nr);
% ci_high_nr = inf_T_b_nr_sort(index_high_nr);
% 
% % CI for Reject
% 
% inf_T_b_r_mean = mean(inf_T_b_r);
% C_theta_r = mean(inf_T_b_r < inf_T_r);
% z_zero_r = norminv(C_theta_r);
% low_95_r = normcdf(2*z_zero_r - 1.96);
% high_95_r = normcdf(2*z_zero_r + 1.96);
% index_low_r = max(1,floor(low_95_r*breps));
% index_high_r = ceil(high_95_r*breps);
% ci_low_r = inf_T_b_r_sort(index_low_r);
% ci_high_r = inf_T_b_r_sort(index_high_r);
% 
% 
% % CI for difference
% pt_est = inf_T_r - inf_T_nr;
% diff = inf_T_b_r - inf_T_b_nr;
% diff_sort = sort(diff);
% C_theta_diff = mean(diff < pt_est);
% z_zero_diff = norminv(C_theta_diff);
% low_95_diff = normcdf(2*z_zero_diff - 1.96);
% high_95_diff = normcdf(2*z_zero_diff + 1.96);
% index_low_diff = max(1,floor(low_95_diff*breps));
% index_high_diff = ceil(high_95_diff*breps);
% ci_low_diff = diff_sort(index_low_diff);
% ci_high_diff = diff_sort(index_high_diff);
% 
% 
% 
% 
% %% Confidence Intervals for inf_T_local
% 
% % CI for Non-Reject
% 
% inf_T_b_nr_mean = mean(inf_T_b_local_nr);
% C_theta_nr = mean(inf_T_b_local_nr < inf_T_local_nr);
% z_zero_nr = norminv(C_theta_nr);
% low_95_nr = normcdf(2*z_zero_nr - 1.96);
% high_95_nr = normcdf(2*z_zero_nr + 1.96);
% index_low_nr = max(1,floor(low_95_nr*breps));
% index_high_nr = ceil(high_95_nr*breps);
% ci_low_local_nr = inf_T_b_local_nr_sort(index_low_nr);
% ci_high_local_nr = inf_T_b_local_nr_sort(index_high_nr);
% 
% % CI for Reject
% 
% inf_T_b_r_mean = mean(inf_T_b_local_r);
% C_theta_r = mean(inf_T_b_local_r < inf_T_local_r);
% z_zero_r = norminv(C_theta_r);
% low_95_r = normcdf(2*z_zero_r - 1.96);
% high_95_r = normcdf(2*z_zero_r + 1.96);
% index_low_r = max(1,floor(low_95_r*breps));
% index_high_r = ceil(high_95_r*breps);
% ci_low_local_r = inf_T_b_local_r_sort(index_low_r);
% ci_high_local_r = inf_T_b_local_r_sort(index_high_r);
% 
% 
% % CI for difference
% pt_est_local = inf_T_local_r - inf_T_local_nr;
% diff = inf_T_b_local_r - inf_T_b_local_nr;
% diff_sort = sort(diff);
% C_theta_diff = mean(diff < pt_est);
% z_zero_diff = norminv(C_theta_diff);
% low_95_diff = normcdf(2*z_zero_diff - 1.96);
% high_95_diff = normcdf(2*z_zero_diff + 1.96);
% index_low_diff = max(1,floor(low_95_diff*breps));
% index_high_diff = ceil(high_95_diff*breps);
% ci_low_local_diff = diff_sort(index_low_diff);
% ci_high_local_diff = diff_sort(index_high_diff);
% 
% 
% 



