
clear

est_savename = 'est_dis_nr_f'
est_rob_savename = 'est_dis_nr_robust_f'
boot_savename = 'est_dis_nr_boot_f'
ci_savename = 'est_dis_nr_ci_f'
graph_savename = 'est_dis_nr_graph_f'
graph_savename_rob = 'est_dis_nr_graph_rob_f'
noinf_savename = 'est_dis_nr_noinf_f'

num_beta = 1
use_robust_start = 1
num_robust_start = 100;
updatecoeff = 0;
reducedform = 1;

% For appending bootstrapped results into _par bootstrap reps
%DELETE THIS IF YOU DON'T WANT PREVIOUS _PAR REPETITIONS TO BE DELETED!!!

%load('est_dis_r_boot')
%save(boot_savename,'boot_est','boot_fval','boot_exitflag','b','b_tot');




% % Just In Case
% clear
% load('est_dis_r_final')
% save('est_dis_r_final_jic')
% clear
% load('est_dis_r_boot')
% save('est_dis_r_boot_jic')
% clear
% load('est_dis_r_ci')
% save('est_dis_r_ci_jic')
% clear
% load('est_dis_r_graph')
% save('est_dis_r_graph_jic')
% clear
% load('est_dis_r_noinf')
% save('est_dis_r_noinf_jic')
% clear

%% Load data

load('using_matlab_dis_nr')

% load('alpha_x')

indid = data(:,1);
hhid = data(:,2);
L = data(:,3);
z = data(:,4);
r = data(:,5);
x_d = data(:,6:end);

%other = [ones(size(x_d,1),1),x_d(:,1:5)];
%other = [ones(size(x_d,1),1),x_d];
other = ones(size(x_d,1),1);

% Estimate sigma using non-focal points

nonfocal = find((z~=0).*(z~=.5).*(z~=1));
L_nf = L(nonfocal,:);
z_nf = z(nonfocal,:);

cov_sigma = cov(z_nf,L_nf);
sigma_hat = sqrt(cov_sigma(1,1) - cov_sigma(2,1));

% Remove focal points
% nonfocal = find((z~=0).*(z~=.5).*(z~=1));
% indid = indid(nonfocal,:);
% L = L(nonfocal,:);
% z = z(nonfocal,:);
% r = r(nonfocal,:);
% x_d = x_d(nonfocal,:);
% other = other(nonfocal,:);


%% Settings
estimate = 0
estimate_robust = 0
finitesample = 0
pointgraph = 0
bootstrap = 0
append = 0
ci = 1
breps = 100;
k_step = 5000;

mix = 2;
num = 3+size(other,2);
endpt = 1;

t_cut = .01;
t_cut_p = .9;
t_cut_local = .2;

granular = .003;

q_vals = [.2; .5 ; .8];

% Start Parameters

if num_beta == 1
    para_start_z_p = [sigma_hat;.3;0.2;zeros(size(other,2),1)];
    para_start_p = [.8;.3;.5;.1;.05;5;5];
    para_start = [para_start_z_p;para_start_p];
lb_z_p = [0;0;0;-10*ones(size(other,2),1)];
ub_z_p = [1;1;1;10*ones(size(other,2),1)];

lb_p = [0;0;0;0;-1;1.5;1.5];
ub_p = [1;1;1;1;1;200;200];
lb = [lb_z_p;lb_p];    
ub = [ub_z_p;ub_p];  
%     
% para_start_z_p = [.25;.3;0.2;zeros(size(other,2),1)];
% para_start_p = [.4;.07;7];
% para_start =  [para_start_z_p;para_start_p]
% 
% lb_z_p = [0;0;0;-10*ones(size(other,2),1)];
% lb_p = [0;-1;1];
% lb = [lb_z_p;lb_p];
% ub_z_p = [1;1;1;10*ones(size(other,2),1)];
% ub_p = [1;1;300];
% ub = [ub_z_p;ub_p];
end

if num_beta == 2 
    
    para_start_z_p = [sigma_hat;.3;0.2;zeros(size(other,2),1)];
    para_start_p = [.8;.8;.3;.3;.3;.1;.1;.04;300;300];
    para_start = [para_start_z_p;para_start_p];
lb_z_p = [0;0;0;-10*ones(size(other,2),1)];
ub_z_p = [1;1;1;10*ones(size(other,2),1)];
lb_p = [0;0;0;0;0;0;0;0;1.5;1.5];
ub_p = [1;1;1;1;1;1;1;1;50;50];
lb = [lb_z_p;lb_p];    
ub = [ub_z_p;ub_p];  
% para_start_z_p = [.25;.3;0.2;zeros(size(other,2),1)];
% para_start_p = [.59;.07;4.69;.1318;.0978;4.54];
% para_start =  [para_start_z_p;para_start_p]
% 
% lb_z_p = [0;0;0;-10*ones(size(other,2),1)];
% lb_p = [0;-1;1;0;0;1];
% lb = [lb_z_p;lb_p];
% ub_z_p = [.2;1;1;10*ones(size(other,2),1)];
% ub_p = [1;1;300;1;1;300];
% ub = [ub_z_p;ub_p];
end 
    
% Impose sigma

A_sigma = zeros(size(para_start))';
A_sigma(1) = -1;
A_ineq = A_sigma;
b_ineq = -sigma_hat;


    

%% Make q 

b = glmfit(x_d,L,'binomial','link','probit');
q = glmval(b,x_d,'probit');

cut = .01;

q = q.*(q>cut).*(q<1-cut) + (q<=cut).*cut + (q>=1-cut).*(1-cut);

b_z = glmfit(x_d,z,'normal','link','identity');
q_z = glmval(b_z,x_d,'identity');
q_z = (q_z >= cut).*(q_z <= 1-cut).*q_z + (1-cut).*(q_z > 1-cut) + cut.*(q_z < cut);


center = mean(L);
q_dis = zeros(size(q_vals,1),1);
q_sort = sort(q,1);
q_size = size(q,1);

for qq = 1:size(q_vals,1);
    num_q = round(q_vals(qq)*q_size);
    q_dis(qq) = q_sort(num_q);
end

%% Test f_z_p_X

zz = [0:.01:1]';
p_start = .05;
f_z_test = zeros(size(zz));

for j = 1:size(zz,1);
    f_z_test(j,1) = f_z_p_X_use(.05,zz(j),.05,para_start_z_p,other(1,:));
end

figure(1)
plot(zz,f_z_test)


%% test f_p_X

zz = [0:.01:1]';
pp = zz;
f_p_inf_test = zeros(size(zz));
f_p_cdf_test = zeros(size(zz));
q_start = 0.2;

for j = 1:size(zz,1);
    f_p_cdf_test(j,1) = para_start_p(1).*(pp(j) >= q_start) + (1-para_start_p(1)).*f_cdf_p_X_use(pp(j),q_start,para_start_p(2:end),num_beta,center);
end
figure(2)
plot(pp,f_p_inf_test);
title('f_p_inf_test');
figure(3)
plot(pp,f_p_cdf_test);
title('f_p_cdf_test');

%% test ln_like_X_use



%% Robustness

if estimate_robust == 1 
    
    
r = num_robust_start;

if num_beta == 1
    lb_space = [sigma_hat;.2;.1;zeros(size(other,2),1);.1;.1;.01;.01;0;2;2];
    ub_space = [sigma_hat;.5;.3;zeros(size(other,2),1);.9;.9;.3;.3;.05;25;25];
end

if num_beta == 2
lb_space = [sigma_hat;.2;.1;zeros(size(other,2),1);.3;.7;.01;.01;.01;.01;.01;1.5;1.5];
ub_space = [sigma_hat;.5;.3;zeros(size(other,2),1);1;.9;.1;.3;.3;.3;.3;25;25];
end



bb = size(lb_space,1);


matlabpool open 8

est_final_rob = zeros(size(lb_space,1),r);
est_val_rob = zeros(1,r);
flags = zeros(1,r);


parfor r_loop = 1:r 
%for r_loop = 1:r
w_rob = rand(size(lb_space));

para_start_rob = w_rob.*lb_space + (1-w_rob).*ub_space;


options = optimset('MaxFunEvals',30000,'MaxIter',30000,'Algorithm','interior-point','TolFun',1e-10);
[est_final_rob(:,r_loop),est_val_rob(1,r_loop),flags(1,r_loop)] = fmincon(@(paras) ln_like_X(L,z,q,paras,other,num_beta),para_start_rob,A_ineq,b_ineq,[],[],lb,ub,[],options)



end

save(est_rob_savename,'est_final_rob','est_val_rob');

matlabpool close

end


%% Point Estimates

if estimate == 1 
    
    
    if use_robust_start == 1 
    load(est_rob_savename)  % Estimate starting value from best maximizing value from parfor loop

    [a,b] = min(est_val_rob);
    para_start = est_final_rob(:,b);
    end
    
    
options = optimset('MaxFunEvals',Inf,'MaxIter',Inf,'Algorithm','interior-point','TolFun',1e-12);
[est_final,est_val,est_flag] = fmincon(@(paras) ln_like_X(L,z,q,paras,other,num_beta),para_start,A_ineq,b_ineq,[],[],lb,ub,[],options)

if updatecoeff == 1
    

est_val_new = est_val;
est_final_new = est_final;
est_flag_new = est_flag;

load(est_savename)

if est_val_new < est_val
    est_val = est_val_new;
    est_final = est_final_new;
    est_flag = est_flag_new;
    save(est_savename,'est_final','est_val','est_flag')
    
end
end

if updatecoeff == 0
save(est_savename,'est_final','est_val','est_flag');
end
end



%% Graphs

if pointgraph == 1
    load(est_savename)
    para_est = est_final;

para_z_p = para_est(1:end-3*num_beta-4);
para_est_p = para_est(end-3*num_beta-3:end);
para_est_p_inf = para_est_p(2:end);
frac_uninf = para_est_p(1);

pp = [.01:granular:.99]';
pp = sort([pp;center]);
zz = ones(size(pp)).*center;
    
    
    % Mean q values
    F_p_est = zeros(size(pp));
    f_p = zeros(size(pp));
    p_p = zeros(size(pp));
        for jj = 1:size(pp,1);
            F_p_est(jj) = frac_uninf.*(pp(jj) >= center) + (1-frac_uninf).*f_cdf_p_X_use(pp(jj),center,para_est_p_inf,num_beta,center);
            temp = frac_uninf.*center.*(pp(jj) <= center) + (1-frac_uninf).*quadv(@(p) e_p_X_use(p,center,para_est_p_inf,num_beta) , pp(jj),1);
            p_p(jj) = temp / (1-F_p_est(jj)+(pp(jj)==center).*frac_uninf);
            f_p(jj) = frac_uninf.*pdf('norm',pp(jj),center,1/100) + (1-frac_uninf).*f_p_X_use(pp(jj),center,para_est_p_inf,num_beta);
        end        
    
    T_est = (p_p./(1-p_p)).*(1-pp)./pp;
    
    
    % Distributional q values 

    F_p_est_q = zeros(size(pp,1),size(q_vals,1));
    T_est_q = F_p_est_q;
    f_p_est_q = F_p_est_q;
        
    for qq = 1:size(q_vals,1);
        pp = [.01:granular:.99]';
        pp = sort([pp;q_dis(qq)]);
        z_q = ones(size(pp))*q_dis(qq);
        p_p = zeros(size(pp));
        temp_f = zeros(size(pp));
        for jj = 1:size(pp,1);
            F_p_est_q(jj,qq) = frac_uninf.*(pp(jj) >= q_dis(qq)) + (1-frac_uninf).*f_cdf_p_X_use(pp(jj),q_dis(qq),para_est_p_inf,num_beta,center);
            temp = frac_uninf.*q_dis(qq).*(pp(jj) <= q_dis(qq)) + (1-frac_uninf).*quadv(@(p) e_p_X_use(p,q_dis(qq),para_est_p_inf,num_beta) , pp(jj),1);
            p_p(jj) = temp / (1-F_p_est_q(jj,qq)+(pp(jj) == q_dis(qq)).*frac_uninf);
            temp_f(jj) = frac_uninf.*pdf('norm',pp(jj),q_dis(qq),1/100) + (1-frac_uninf).*f_p_X_use(pp(jj),q_dis(qq),para_est_p_inf,num_beta);
        end        
    T_est_q(:,qq) = (p_p./(1-p_p)).*(1-pp)./pp;
    f_p_est_q(:,qq) = temp_f;
    
    end

like_val = ln_like_X(L,z,q,para_est,other,num_beta);

save(graph_savename,'T_est','F_p_est','center','T_est_q','F_p_est_q','q_dis','like_val','f_p','f_p_est_q')
    
figure(1)
plot(pp,T_est)
axis([0 1 1 3])

figure(2)
plot(pp,F_p_est)
axis([0 1 0 1])  
    
    
    
end
    
    

%% Bootstrap

  
if bootstrap == 1 
    

s = RandStream('mt19937ar','Seed',1);

    if reducedform == 0
    RandStream.setGlobalStream(s);
    end
    if reducedform == 1 
        RandStream.setDefaultStream(s);
    end

[unique_hh,I_hh,J_hh] = unique(hhid);
n = size(unique_hh,1);

if append == 1 
    load(boot_savename)
    oldbreps = size(boot_est,2);
    newbreps = breps - oldbreps;
    for b = 1:oldbreps
        h_sample = randsample(s,unique_hh,n,true);
    end
end

if append == 0
    boot_est = [];
    boot_fval = [];
    boot_exitflag = [];
    newbreps = breps;
    oldbreps = 0;
end

load(est_savename)
para_start = est_final;

h_sample_pre = [];
for b = 1:newbreps
    h_sample_pre_t = randsample(s,unique_hh,n,true);
    h_sample_pre = [h_sample_pre,h_sample_pre_t];
end

% Constraints

if num_beta == 1
    para_start_z_p = [.3;.3;0.2;zeros(size(other,2),1)];
    para_start_p = [.1;.3;.5;.1;.05;5;5];
    para_start = [para_start_z_p;para_start_p];
lb_z_p = [0;0;0;-10*ones(size(other,2),1)];
ub_z_p = [1;1;1;10*ones(size(other,2),1)];
lb_p = [0;0;0;0;0;1.5;1.5];
ub_p = [1;1;1;1;1;200;200];
lb = [lb_z_p;lb_p];    
ub = [ub_z_p;ub_p];  

A_sigma = zeros(size(para_start))';
A_sigma(1) = -1;
A_ineq = A_sigma;
end


matlabpool open 31    

parfor b = 1:newbreps
%for b = 1:newbreps
    
    h_sample = h_sample_pre(:,b);
    h_index = [];
    for nn = 1:n
        temp = find(hhid(:,1)==h_sample(nn));
        h_index = [h_index;temp];
    end
    
    x_b = x_d(h_index,:);
    L_b = L(h_index,:);
    z_b = z(h_index,:);
%    other_b = [ones(size(x_b,1),1),x_b];
    other_b = ones(size(x_b,1),1);
    nonfocal = find((z_b~=0).*(z_b~=.5).*(z_b~=1));
    L_nf = L_b(nonfocal,:);
    z_nf = z_b(nonfocal,:);    
    cov_sigma = cov(z_nf,L_nf);
    sigma_hat = sqrt(cov_sigma(1,1) - cov_sigma(2,1));
    b_ineq = -sigma_hat;
    
    
    % Probit Step
    
    b_b = glmfit(x_b,L_b,'binomial','link','probit');
    q_b = glmval(b_b,x_b,'probit');
    
    cut = .01;
    b_z = glmfit(x_b,z_b,'normal','link','identity');
    q_z_b = glmval(b_z,x_b,'identity');
    q_z_b = (q_z_b >= cut).*(q_z_b <= 1-cut).*q_z_b + (1-cut).*(q_z_b > 1-cut) + cut.*(q_z_b < cut);
    
    center = mean(L_b);
    
    
    
    % Estimation
    
    
    options = optimset('MaxIter',k_step,'MaxFunEvals',k_step,'Algorithm','interior-point');
    [est,fval,exitflag] = fmincon(@(paras) ln_like_X(L_b,z_b,q_b,paras,other_b,num_beta), para_start,A_ineq,b_ineq,[],[],lb,ub,[],options);
    boot_est = [boot_est,est];
    boot_fval = [boot_fval,fval];
    boot_exitflag = [boot_exitflag,exitflag];
    if append == 0
        b_tot = b;
    end
    if append == 1
        b_tot = b+oldbreps;
    end
    b_tot
    disp(' of ')
    breps

end

save(boot_savename,'boot_est','boot_fval','boot_exitflag');

matlabpool close


end

%% Construct Confidence Intervals with Bootstrapped Estimates

if ci == 1 
load(boot_savename)

center = mean(L);
breps = size(boot_est,2);

% Center Calculations
pp = [.01:granular:.99]';
pp = sort([pp;center]);
zz = center.*ones(size(pp));
f_p_b = zeros(size(pp,1),breps);
F_p_b = zeros(size(pp,1),breps);
p_p = zeros(size(pp,1),breps);
T = zeros(size(pp,1),breps);
inf_T_b = zeros(breps,1);
inf_T_b_local = zeros(breps,1);
support_check = zeros(size(pp,1),breps);
support_check(1,:) = ones(1,breps);


matlabpool open 31

parfor b = 1:breps
    
    
    paras_b = boot_est(:,b);
    para_est_p = paras_b(end-3*num_beta-3:end);
    frac_uninf = para_est_p(1);
    para_est_p_inf = para_est_p(2:end);

    p_p = zeros(size(pp,1),1);
    temp_F_p = zeros(size(pp));
    temp_f = zeros(size(pp));
        for jj = 1:size(pp,1);
            if jj > 1
                if temp_F_p(jj-1) < .99
            temp_F_p(jj) = frac_uninf.*(pp(jj) >= center) + (1-frac_uninf).*f_cdf_p_X_use(pp(jj),center,para_est_p_inf,num_beta,center);
            temp = frac_uninf.*center.*(pp(jj) <= center) + (1-frac_uninf).*quadv(@(p) e_p_X_use(p,center,para_est_p_inf,num_beta) , pp(jj),1);
            p_p(jj) = temp / (1-temp_F_p(jj)+(pp(jj)==center).*frac_uninf);
            temp_f(jj) = frac_uninf.*pdf('norm',pp(jj),center,1/100) + (1-frac_uninf).*f_p_X_use(pp(jj),center,para_est_p_inf,num_beta);
                end
                if temp_F_p(jj-1) >= .99
                    temp_F_p(jj) = 1;
                    p_p(jj) = .99;
                    temp_f(jj) = 0;
                end
                    
            end
            if jj == 1
                
            temp_F_p(jj) = frac_uninf.*(pp(jj) >= center) + (1-frac_uninf).*f_cdf_p_X_use(pp(jj),center,para_est_p_inf,num_beta,center);
            temp = frac_uninf.*center.*(pp(jj) <= center) + (1-frac_uninf).*quadv(@(p) e_p_X_use(p,center,para_est_p_inf,num_beta) , pp(jj),1);
            p_p(jj) = temp / (1-temp_F_p(jj)+(pp(jj)==center).*frac_uninf);
            temp_f(jj) = frac_uninf.*pdf('norm',pp(jj),center,1/100) + (1-frac_uninf).*f_p_X_use(pp(jj),center,para_est_p_inf,num_beta);
            end
                
        end        
    F_p_b(:,b) = temp_F_p;
    f_p_b(:,b) = temp_f;
    T(:,b) = (p_p./(1-p_p)).*(1-pp)./pp;
end



T_sort = sort(T,2);
F_sort = sort(F_p_b,2);

index_95 = ceil(95*breps/100);
index_5 = max(floor(5*breps/100),1);

T_95 = T_sort(:,index_95);
T_5 = T_sort(:,index_5);
F_95 = F_sort(:,index_95);
F_5 = F_sort(:,index_5);


% Q Calculations

F_p_b_q = zeros(size(pp,1),breps,size(q_vals,1));
T_b_q = F_p_b_q;
f_p_b_q = F_p_b_q;
        
for qq = 1:size(q_vals,1);
pp = [.01:granular:.99]';
pp = sort([pp;q_dis(qq)]);
z_q = ones(size(pp))*q_dis(qq);
p_p = zeros(size(pp,1),breps);



parfor b = 1:breps

    paras_b = boot_est(:,b);
    para_est_p = paras_b(end-3*num_beta-3:end);
    frac_uninf = para_est_p(1);
    para_est_p_inf = para_est_p(2:end);
    temp_F_p = zeros(size(pp));
    p_p = zeros(size(pp));
    temp_f = zeros(size(pp));
        for jj = 1:size(pp,1)
            if jj > 1
                if temp_F_p(jj-1) < .99
            temp_F_p(jj) = frac_uninf.*(pp(jj) >= q_dis(qq)) + (1-frac_uninf).*f_cdf_p_X_use(pp(jj),q_dis(qq),para_est_p_inf,num_beta,center);
            temp = frac_uninf.*q_dis(qq).*(pp(jj) <= q_dis(qq)) + (1-frac_uninf).*quadv(@(p) e_p_X_use(p,q_dis(qq),para_est_p_inf,num_beta) , pp(jj),1);
            p_p(jj) = temp / (1-temp_F_p(jj)+(pp(jj) == q_dis(qq)).*frac_uninf);
            temp_f(jj) = frac_uninf.*pdf('norm',pp(jj),q_dis(qq),1/100) + (1-frac_uninf).*f_p_X_use(pp(jj),q_dis(qq),para_est_p_inf,num_beta);
                end
                if temp_F_p(jj-1) >= .99
                    temp_F_p(jj) = 1;
                    p_p(jj) = .99;
                    temp_f(jj) = 0;
                end
            end
            if jj == 1
                
            temp_F_p(jj) = frac_uninf.*(pp(jj) >= q_dis(qq)) + (1-frac_uninf).*f_cdf_p_X_use(pp(jj),q_dis(qq),para_est_p_inf,num_beta,center);
            temp = frac_uninf.*q_dis(qq).*(pp(jj) <= q_dis(qq)) + (1-frac_uninf).*quadv(@(p) e_p_X_use(p,q_dis(qq),para_est_p_inf,num_beta) , pp(jj),1);
            p_p(jj) = temp / (1-temp_F_p(jj)+(pp(jj) == q_dis(qq)).*frac_uninf);
            temp_f(jj) = frac_uninf.*pdf('norm',pp(jj),q_dis(qq),1/100) + (1-frac_uninf).*f_p_X_use(pp(jj),q_dis(qq),para_est_p_inf,num_beta);
            end
                    
        end
    F_p_b_q(:,b,qq) = temp_F_p;
    T_b_q(:,b,qq) = (p_p./(1-p_p)).*(1-pp)./pp;
    f_p_b_q(:,b,qq) = temp_f;
end



end

matlabpool close

save(ci_savename,'T_95','T_5','F_95','F_5','T','F_p_b','T_b_q','F_p_b_q','f_p_b_q','f_p_b')

figure(1)
plot(pp,T_95,'r',pp,T_5,'b')
axis([0 1 1 4])
figure(2)
plot(pp,F_95,'r',pp,F_5,'b')

end

    

